      IMPLICIT INTEGER(A-Z)
      COMMON /COMA/ MX,MZ,MB,MC,L0,SEIDO,ACR,IMAX,HG,
     $              MMW,MG,MMSC,MBNR,MBNV,MBNS
     $       /COMB/ XGRI(500),KSG(500),KJG(500),KC(500),KW(500)
     $       /COMC/ EB(500),IB(500),AB(500),MPB(500),
     $              EC(500),IC(500),AC(500),MPC(500),
     $              EG(500),IG(500),AG(500),MPG(50),
     $              EW(500),IW(500),AW(500),MPW(500)
     $       /COMD/ HHH(100),FFF(100)
     $       /COME/ RBN(3,500),VBN(3,500),SBN(3,500),SBMAX(500)
      REAL EB,IB,AB,EC,IC,AC,FFF,
     $     MPB,MPC,MPG,MPW
      REAL EG,IG,AG,EW,IW,AW,RBN,VBN,SBN,SBMAX
      REAL L0,SEIDO,ACR
      CHARACTER*20 WK_FILE1,WK_FILE2,WK_FILE3,
     $             WK_FILE4,WK_FILE5 
      CHARACTER*4 TITL,AAA
      INTEGER ZERO(500),ICHI(500)
C
C                                       **FILE OPEN**
C
      READ(5,*) TITL
      WK_FILE1  =  TITL//'pr.csv'
      WK_FILE2  =  TITL//'o.csv'
      WK_FILE3  =  TITL//'q.csv'
      WK_FILE4  =  TITL//'zb.csv'
      WK_FILE5  =  TITL//'zc.csv'
C
      OPEN (UNIT=7, FILE=WK_FILE1, ACCESS='SEQUENTIAL',
     &      STATUS='OLD', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-01 ***'
      ENDIF
C
      OPEN (UNIT=11, FILE=WK_FILE2, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-02 ***'
      ENDIF
C
      OPEN (UNIT=12, FILE=WK_FILE3, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
       IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-03 ***'
      ENDIF
C
      OPEN (UNIT=13, FILE=WK_FILE4, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-04 ***'
      ENDIF
C
      OPEN (UNIT=14, FILE=WK_FILE5, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
       IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-05 ***'
      ENDIF
C
C                                       **DATA INPUT**
C
      READ(7,1020) MX,MZ,MB,MC,L0,SEIDO,ACR,IMAX,MW,ISTEP0
 1020 FORMAT(4I5,F10.0,F10.7,F10.3,I10,I10,I10)
      READ(7,1025) MMW,MG,MMSC,MBNR,MBNV,MBNS,HG
 1025 FORMAT(6I5,I6)
C
      CALL BCWMST(EB,IB,AB,MPB,MB)
      CALL BCWMST(EC,IC,AC,MPC,MC)
      IF(MMW.NE.0) THEN
          CALL BCWMST(EG,IG,AG,MPG,MG)
          CALL BCWMST(EW,IW,AW,MPW,MMSC)
          CALL BANEIN(RBN,MBNR)
          CALL BANEIN(VBN,MBNV)
          CALL BANEIN2(SBN,MBNS,SBMAX)
      ENDIF
C
      READ(7,1010)
 1010 FORMAT(A4)
      DO 10 IX=1,MX
          READ(7,1030) IDUM,XGRI(IX),JDUM,KSG(IX),
     $                 KJG(IX),KC(IX),KW(IX)
 1030     FORMAT(I4,2I6,4I5)
   10 CONTINUE
C
      READ(7,1032) (HHH(IZ),IZ=1,MZ)
 1032 FORMAT(I6)
      READ(7,1033) (FFF(IZ),IZ=1,MZ-1)
 1033 FORMAT(F10.0)
C
C                                       **SYOKI SETTEI**
C
      DO 15 IX=1,MX
          ZERO(IX)=0
          ICHI(IX)=1
   15 CONTINUE
C
C                                       **or FILE OUTPUT**
C
      WRITE(11,1035) MX,MZ,MB,MC,L0,SEIDO,ACR,IMAX,MW,ISTEP0
 1035 FORMAT(4(I5,','),F10.0,',',F10.7,',',F10.3,',',3(I10,','))
C
      DO 20 IX=1,MX
          WRITE(11,1040) XGRI(IX)
 1040     FORMAT(I6,',')
   20 CONTINUE
      WRITE(11,1045) (HHH(IZ),IZ=1,MZ)
 1045 FORMAT(I6,',')
C
      CALL BCWM11(EB,IB,AB,MB)
      CALL BCWM11(EC,IC,AC,MC)
C
      WRITE(11,1050) (KSG(IX),IX=1,MX)
 1050 FORMAT(10(I5,','))
      DO 30 IZ=1,MZ-1
          WRITE(11,1050) (KJG(IX),IX=1,MX)
   30 CONTINUE
      WRITE(11,1060)
 1060 FORMAT('0,0,0,')
C
      DO 40 IZ=1,MZ-1
          WRITE(11,1050) (KC(IX),IX=1,MX)
   40 CONTINUE
      WRITE(11,1050) (ZERO(IX),IX=1,MX)
      WRITE(11,1060)
      WRITE(11,1050) (ICHI(IX),IX=1,MX)
      WRITE(11,1062) (FFF(IZ),IZ=1,MZ-1)
 1062 FORMAT(F12.1,',')
C
C                                      **wr FILE OUTPUT**
C
      IF(MMW.NE.0) THEN
      WRITE(12,1065) MMW,MG,MMSC,MBNR,MBNV,MBNS
 1065 FORMAT(6(I5,','))
C
      DO 50 IZ=1,MZ-1
          DO 45 IX=1,MX
              IF(KW(IX).NE.0) THEN
                  WRITE(12,1070) ((XGRI(IX+I-1)-XGRI(IX)),I=1,3)
 1070             FORMAT(3(I8,',')) 
              ENDIF
   45     CONTINUE
   50 CONTINUE
C
      DO 60 IZ=1,MZ-1
          DO 55 IX=1,MX
              IF(KW(IX).NE.0) THEN
                  WRITE(12,1080) HG
 1080             FORMAT('0 ,',I6,',')
              ENDIF
   55     CONTINUE
   60 CONTINUE
C
      CALL BCWM12(EG,IG,AG,MG)
      CALL BCWM12(EW,IW,AW,MMSC)
      CALL BANEWR(RBN,MBNR)
      CALL BANEWR(VBN,MBNV)
      CALL BANEWR2(SBN,MBNS,SBMAX)
C
      DO 70 IZ=1,MZ-1
          DO 65 IX=1,MX
              IF(KW(IX).NE.0) THEN
                  WRITE(12,1090) IX,IX+1,IX+2,
     $                           IX,IX+1,IX+2
 1090             FORMAT(6(I5,','))
                  WRITE(12,1090) IZ,IZ,IZ,IZ+1,IZ+1,IZ+1
              ENDIF
   65     CONTINUE
   70 CONTINUE
C
      DO 80 IZ=1,MZ-1
          DO 75 IX=1,MX
              IF(KW(IX).NE.0) THEN
                  DO 72 K=1,2
                      WRITE(12,1100)
 1100                 FORMAT('1 ,0 ,2 ,'/
     $                       '1 ,1, 3 ,'/
     $                       '0 ,2, 0 ,')
   72             CONTINUE
              ENDIF
   75     CONTINUE
   80 CONTINUE
C
      DO 90 IZ=1,MZ-1
          DO 85 IX=1,MX
              IF(KW(IX).NE.0) THEN
                  WRITE(12,1110) KW(IX)
 1110             FORMAT(I5,' ,0 , 2,')
              ENDIF
   85     CONTINUE
   90 CONTINUE
C
      DO 100 IZ=1,MZ-1
          DO 95 IX=1,MX
              IF(KW(IX).NE.0) THEN
                  I=KW(IX)
                  DO 93 II=1,2
                      WRITE(12,1120) I,I,I
 1120                 FORMAT(3(I5,','))
                      WRITE(12,1125)
 1125                 FORMAT('0 ,0, 0,')
                      WRITE(12,1120) I,I,I
   93             CONTINUE
              ENDIF
   95     CONTINUE
  100 CONTINUE
      ENDIF
C
C                                       **zb FILE OUTPUT**
C
      IZ=1
      DO 110 IX=1,MX
          IF(KSG(IX).NE.0) THEN
              II=KSG(IX)
              WRITE(13,1130) IZ,IX,IX+1,MPB(II),MPB(II)
 1130         FORMAT(3(I5,','),2(F10.1,','))
          ENDIF
  110 CONTINUE
C
      DO 120 IZ=2,MZ
          DO 115 IX=1,MX
              IF(KJG(IX).NE.0) THEN
                  II=KJG(IX)
                  WRITE(13,1130) IZ,IX,IX+1,MPB(II),MPB(II)
              ENDIF
  115     CONTINUE
  120 CONTINUE
C
C                                        **zc FILE OURPUT**
C
      DO 130 IZ=1,MZ-1
          DO 125 IX=1,MX
              II=KC(IX)
              IF(KC(IX).NE.0) THEN
                  WRITE(14,1130) IX,IZ,IZ+1,MPC(II),MPC(II)
              ENDIF
  125     CONTINUE
  130 CONTINUE
      STOP
      END
      SUBROUTINE BCWMST(EB,IB,AB,MPB,MB)
      IMPLICIT INTEGER(A-Z)
      REAL EB(MB),IB(MB),AB(MB),MPB(MB)
      DO 10 I=1,MB
          READ(7,1010) IDUM,EB(I),IB(I),AB(I),MPB(I)
 1010     FORMAT(I5,4F12.0)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE BANEIN(RBN,MBNR)
      IMPLICIT INTEGER(A-Z)
      REAL RBN(3,MBNR)
      DO 10 IBNR=1,MBNR
          READ(7,1010) (RBN(I,IBNR),I=1,3)
 1010 FORMAT(3F12.0)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE BANEIN2(RBN,MBNR,SBMAX)
      IMPLICIT INTEGER(A-Z)
      REAL RBN(3,MBNR),SBMAX(MBNR)
      DO 10 IBNR=1,MBNR
          READ(7,1010) (RBN(I,IBNR),I=1,3),SBMAX(IBNR)
 1010 FORMAT(4F12.0)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE BCWM11(EB,IB,AB,MB)
      IMPLICIT INTEGER(A-Z)
      REAL EB(MB),IB(MB),AB(MB)
      DO 10 I=1,MB
          WRITE(11,1010) I,EB(I),IB(I),AB(I)
 1010     FORMAT(I5,',',3(F12.1,','))
   10 CONTINUE
      RETURN
      END
      SUBROUTINE BCWM12(EB,IB,AB,MB)
      IMPLICIT INTEGER(A-Z)
      REAL EB(MB),IB(MB),AB(MB)
      DO 10 I=1,MB
          WRITE(12,1010)I,EB(I),IB(I),AB(I)
 1010     FORMAT(I5,',',3(F12.1,','))
   10 CONTINUE
      RETURN
      END
      SUBROUTINE BANEWR(RBN,MBNR)
      IMPLICIT INTEGER(A-Z)
      REAL RBN(3,MBNR)
      DO 10 IBNR=1,MBNR
          WRITE(12,1010) (RBN(I,IBNR),I=1,3)
 1010     FORMAT(3(F12.1,','))
   10 CONTINUE
      RETURN
      END
      SUBROUTINE BANEWR2(RBN,MBNR,SBMAX)
      IMPLICIT INTEGER(A-Z)
      REAL RBN(3,MBNR),SBMAX(MBNR)
      DO 10 IBNR=1,MBNR
          WRITE(12,1010) (RBN(I,IBNR),I=1,3),SBMAX(IBNR)
 1010     FORMAT(4(F12.1,','))
   10 CONTINUE
      RETURN
      END