      SUBROUTINE SANKOU(KSX,NZ,NF,KX)
      IMPLICIT INTEGER(A-Z)
      REAL KSX(NF,NZ,2),KX(NZ,NZ)
      CALL CLEAR(KX,NZ*NZ,3)
      DO 20 IF=1,NF
        DO 10 IZ=1,NZ
        DO 10 I=1,2
          KX(IZ,IZ)=KX(IZ,IZ)+KSX(IF,IZ,I)
          IF(IZ.NE.1) KX(IZ,IZ)=KX(IZ,IZ)+KSX(IF,IZ-1,I)
          IF(IZ.NE.NZ) THEN
              KX(IZ+1,IZ)=KX(IZ+1,IZ)-KSX(IF,IZ,I)
              KX(IZ,IZ+1)=KX(IZ,IZ+1)-KSX(IF,IZ,I)
          ENDIF
   10   CONTINUE
   20 CONTINUE
      RETURN
      END
      SUBROUTINE MDSET(M,NZ,MD)
      REAL M(NZ),MD(1)
      CALL CLEAR(MD,NZ*NZ,3)
      DO 15 I=1,NZ
          MD(NZ*(I-1)+I)=M(I)
   15 CONTINUE
      RETURN
      END
      SUBROUTINE DUMPST(K,T,H,NT,C)
      IMPLICIT INTEGER(A-Z)
      REAL K(NT,NT),C(NT,NT),T(1),H,PIE,PIE2
C      CHARACTER NAMC*(*)
      PIE=3.141592
      PIE2=2*H/(2*PIE/T(1))
      DO 10 IX=1,NT
      DO 10 IY=1,NT
          C(IX,IY)=PIE2*K(IX,IY)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE MIVSET(K,C,MD,BETA,DT,NT,MIV)
      IMPLICIT INTEGER(A-Z)
      REAL MD(NT,NT),C(NT,NT),K(NT,NT),BETA,DT,MIV(NT,NT)
      REAL DT5,BETA2
C      CHARACTER NMIV*(*)
      BETA=1.0/6.0
      DT5=0.5*DT
      BETA2=BETA*DT**2
      DO 10 IX=1,NT
      DO 10 IY=1,NT
          MIV(IX,IY)=MD(IX,IY)+C(IX,IY)*DT5
     *                        +BETA2*K(IX,IY)
   10 CONTINUE
      CALL SWEEP(MIV,NT,NT,NT)
      RETURN
      END
      SUBROUTINE DSET(SD,NZ,D)
      REAL D(NZ),SD(NZ)
      D(NZ)=SD(NZ)
      DO 10 IZ=NZ-1,1,-1
          D(IZ)=SD(IZ)+D(IZ+1)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE CRASET(NZ,CRA)
      IMPLICIT INTEGER(A-Z)
      REAL CRA(NZ,NZ)
      CALL CLEAR(CRA,NZ*NZ,3)
      DO 20 I=1,NZ
          DO 10 J=I,NZ
              CRA(I,J)=1.0
   10     CONTINUE
   20 CONTINUE
      RETURN
      END
      SUBROUTINE HENKAN(KI,AR,NZ,KO)
      IMPLICIT INTEGER(A-Z)
C      COMMON //AAA(10000)
      REAL AAA(10000),KI,AR,KO
      CALL S005(AR,KI,AAA,NZ,NZ,NZ)
      CALL S003(AAA,AR,KO,NZ,NZ,NZ)
      RETURN
      END
      SUBROUTINE TENCHI(AR,BBB,NZ)
      REAL AR(NZ,NZ),BBB(NZ,NZ)
      DO 10 I=1,NZ
      DO 10 J=1,NZ
          BBB(J,I)=AR(I,J)
   10 CONTINUE
      RETURN
      END