      PROGRAM             MAIN
C
      IMPLICIT INTEGER(A-Z)
      COMMON /COMA/ NZ,KIJT(100,2),NF
     \       /COMB/ M(100),K(10000),C(10000),MIV(10000),MD(10000),
     \              KD(10000),KD1(10000),MD1(10000)
     \       /COMC/ D(100),V(100),A(100)
     \       /COMC2/ TD(100),TV(100),TA(100),
     \       /COMD/ T(100),U(10000)
     \       /COME/ A0MAX,TMAX,TFR,DT,H,BETA
     \       /COMF/ NO,XEIND,XENAM(3),XAV,YEIND,YENAM(3),YAV,RAD1
     \       /COMG/ SD(100),Q(100,2)
     \       /COMG1/ SA(100),SV(100)
     \       /COMG2/ TSD(100),TQ(100,2),TSV(100)
     \       /COMH/ DMAX(100),AMAX(100),VMAX(100),
     \              SDMAX(100),QMAX(100,2)
     \       /COMMAX/ITM(5,100),ITM1(5,100),SDMAX1(1000)
     \       /COMHNK/ CRA(10000) 
     \       /COMI/ MSTEP,SDJ(10000,100),QQJ(10000,100,2),
     \              ISTEP(100,2),ICHG(100,2),TSD0(100,2),TQ0(100,2),
     \              KIJ0(10000,100,2)
C    
      REAL M,K,C,MIV,MD,KD,D,V,A,T,U,
     \    A0MAX,TMAX,TFR,DT,H,BETA,  
     \    XAV,YAV,RAD1,XA0,XA1,AAA(150),SDMAX1,QMAX,
     \    SD,DMAX,AMAX,VMAX,SDMAX,QIJ,KIJT,RITM(5,100),WTM(100000),
     \    Q,TD,TV,TA,TSD,TQ,SA,SV,KD1,MD1,CRA,SDJ,QQJ,TSV,TSD0,TQ0,
     \    KIJ0,TTT,TTD(100)
C
      INTEGER      WK_IOS,CND,TYP,NZ,NF,ICHG
      CHARACTER*20 WK_FILE1,WK_FILE2,WK_FILE3,WK_FILE4,WK_FILE5,
     \             WK_FILE6
      CHARACTER*4 TITL
      READ(5,*)TITL
C
      WK_FILE1  =  TITL//'s.csv'
      WK_FILE2  =  'cis.ji1'
      WK_FILE3  =  TITL//'cwt.csv'
      WK_FILE4  =  TITL//'slp.txt'
      WK_FILE5  =  TITL//'sout.csv'
      WK_FILE6  =  TITL//'dbg.txt'
C
      OPEN (UNIT=7, FILE=WK_FILE1, ACCESS='SEQUENTIAL',
     &      STATUS='OLD', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      WRITE (6,100)  WK_FILE1,WK_IOS
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  MAIN ERR-01 ***'
      ENDIF
C
      OPEN (UNIT=11, FILE=WK_FILE2, ACCESS='SEQUENTIAL',
     &      STATUS='OLD', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      WRITE (6,100)  WK_FILE2,WK_IOS
      IF  (WK_IOS  .NE.  0)  THEN
          CLOSE (7)
          STOP '***  MAIN ERR-02  ***'
      ENDIF
C
      OPEN (UNIT=9, FILE=WK_FILE3, ACCESS='SEQUENTIAL',
     &      STATUS='OLD', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      WRITE (6,100)  WK_FILE3,WK_IOS
      IF  (WK_IOS  .NE.  0)  THEN
          CLOSE(7)
          CLOSE(9)
          STOP '***  MAIN ERR-03 ***'
      ENDIF
C
      OPEN (UNIT=8, FILE=WK_FILE4, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      WRITE (6,100)  WK_FILE4,WK_IOS
      IF  (WK_IOS  .NE.  0)  THEN
          CLOSE(7)
          CLOSE(9)
          STOP '***  MAIN ERR-04 ***'
      ENDIF
C
      OPEN (UNIT=10, FILE=WK_FILE5, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      WRITE (6,100)  WK_FILE5,WK_IOS
      IF  (WK_IOS  .NE.  0)  THEN
          CLOSE(7)
          CLOSE(9)
          CLOSE(11)
          CLOSE(8)
          STOP '***  MAIN ERR-05 ***'
      ENDIF
      OPEN (UNIT=12, FILE=WK_FILE6, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      WRITE (6,100)  WK_FILE6,WK_IOS
      IF  (WK_IOS  .NE.  0)  THEN
          CLOSE(7)
          CLOSE(9)
          CLOSE(11)
          CLOSE(8)
          CLOSE(10)
          STOP '***  MAIN ERR-06 ***'
      ENDIF
  100 FORMAT (1H ,'***  MAIN OPEN ***  ',A20,I5)
C
      READ (7,1010) NZ
 1010 FORMAT (I5)
      NF=1
C      WRITE(12,*)  'IT,SD(NZ),Q(NZ),TSD(NZ),TQ(NZ),ISTEP(NZ)'
C
      CALL SDQJIN(SDJ,QQJ,NZ,MSTEP)
C      CALL DEBUGST(SDJ,10000,NZ)
C      CALL DEBUGST(QQJ,10000,NZ*2)
      CALL KIJINI(SDJ,QQJ,NZ,MSTEP,KIJ0)
      WRITE(6,*) NZ,'**SDQJIN END**'
      DO 5 IZ=1,100
      DO 5 I=1,2
          ISTEP(IZ,I)=1
    5 CONTINUE
C      CALL KIJSET(SDJ,QQJ,NZ,ISTEP,KIJT)
      CALL KIJST2(KIJ0,NZ,ISTEP,KIJT)
      WRITE(6,*) '**KIJSET END**'
      CALL IDATSTS1(M,NZ)
      READ (7,1020)  A0MAX,TMAX,TFR,DT,H,BETA
 1020 FORMAT (6F12.0)
C
      CALL DEBUGST(KIJT,NZ,2)
      CALL SANKOU(KIJT,NZ,NF,KD)
      CALL DEBUGST(KD,NZ,NZ)
      WRITE(6,*) '**SANKOU END**'
      CALL MDSET(M,NZ,MD)
      WRITE(6,*) '**MDSET END**'
      CALL JACOB3(NZ,KD,M,T,U)
      TTT=T(1)
      WRITE(6,*) '**JACOB3 END**'
      CALL ODATSTS1 (T, 1,NZ,'T   ')
      WRITE(6,*) '**ODATSTS1 END**'
      CALL ODATSTS5 (U,NZ,NZ,'U   ')
C
      NTM=1
   10 READ(11,1035,END=15) WTM(NTM)
 1035 FORMAT(X,E15.7)
      NTM=NTM+1
      GO TO 10
   15 CONTINUE
      CALL WAVEST(WTM,NTM,A0MAX)   
C
      IT=0
      XA0=0.0
C      CALL CLEARI(CND,100,2)
      CALL CLEAR(D,300,3)
      CALL CLEAR(TD,300,3)
      CALL CLEAR(SD,200,3)
      CALL CLEAR(SA,200,3)
      CALL CLEAR(TSD,300,3)
      CALL CLEAR(DMAX,500,3)
      CALL CLEARI(ITM,2000*2,2)
      CALL CLEAR(TSD0,100,3)
      CALL CLEAR(TQ0,100*2,3)
C
   20 IT=IT+1
C      WRITE(6,*) '**IT1=',IT
      IF(IT/100*100.EQ.IT) WRITE(6,*) IT,NTM
      IF (IT.GT.NTM) THEN
          CALL ODATSTS3(DMAX ,1,NZ,'D   ')
          CALL ODATSTS3(AMAX ,1,NZ,'A   ')
          CALL ODATSTS3(VMAX ,1,NZ,'V   ')
          CALL ODATSTS3(SDMAX,1,NZ,'SD  ')
          CALL ODATSTS7(QMAX, NF,NZ,'Q   ')
C
          DO 35 I=1,5
          DO 25 L=1,NZ
              RITM(I,L)=ITM(I,L)*DT
   25     CONTINUE
   35     CONTINUE
C
          WRITE(8,*) '** DMAX'
          WRITE(8,2000) (RITM(1,I),I=1,NZ)
          WRITE(8,*) '** AMAX'
          WRITE(8,2000) (RITM(2,I),I=1,NZ)
          WRITE(8,*) '** VMAX'
          WRITE(8,2000) (RITM(3,I),I=1,NZ)
          WRITE(8,*) '**DMAX'
          WRITE(8,2000) (RITM(4,I),I=1,NZ)
 2000     FORMAT(1H ,5E15.7)
          CLOSE (7)
          CLOSE (11)
          CLOSE (12)
          CLOSE (10)
          CLOSE (8)
          CLOSE (20)
          STOP
      ENDIF
      XA1=XA0
      XA0=WTM(IT)
      CALL CLEAR(AAA,NZ,3)
      AAA(NZ)=XA0-XA1
      IF(IT.EQ.1) THEN
          CALL CRASET(NZ,CRA)
C          WRITE(6,*) '**IT2-1=',IT
          CALL HENKAN(KD,CRA,NZ,KD1)
C          WRITE(6,*) '**IT2-2=',IT
          CALL OUTMAT(CRA,KD,KD1,NZ)
C          WRITE(6,*) '**IT2-3=',IT
          CALL HENKAN(MD,CRA,NZ,MD1)
C          WRITE(6,*) '**IT2-4=',IT
          CALL DUMPST(KD1,T,H,NZ,C)
C          WRITE(6,*) '**IT2=',IT
          CALL MIVSET(KD1,C,MD1,BETA,DT,NZ,MIV)
      ENDIF
C      WRITE(6,*) '**IT2=',IT
      CALL DELTST(MIV,C,KD1,MD1,AAA,SD,SV,SA,NZ,DT,BETA)
C      CALL DEBUGOT2(IT,CRA,KIJT,KD,KD1,NZ)
      CALL DSET(SD,NZ,D)
      CALL DSET(SA,NZ,A)
      CALL DSET(SV,NZ,V)
      CALL QSET(SD,KIJT,Q,NZ,NF)
C      WRITE(6,*) '**IT3=',IT
      CALL TOTLST(D,TD,NZ)
      CALL TOTLST(A,TA,NZ)
      CALL TOTLST(V,TV,NZ)
      CALL TOTLST(SD,TSD,NZ)
      CALL TOTLST(SV,TSV,NZ)
      CALL TOTLST3(Q,TQ,NZ)
C      WRITE(6,*) '**IT4=',IT
      CALL MAXSET0(TD,DMAX,NZ,0.0,IT,1)
      CALL MAXSET0(TA,AMAX,NZ,XA0,IT,2)
      CALL MAXSET0(TV,VMAX,NZ,0.0,IT,3)
      CALL MAXSET0(TSD,SDMAX,NZ,0.0,IT,4)
      CALL MAXSET2(TQ,QMAX,NZ,0.0,IT,5)
C      WRITE(6,*) '**IT5=',IT
      CALL QDOUT(TSD,TQ,TTT,NZ,DT,IT)
      CALL JHSTST(IT,SD,Q,TSD,TQ,SDJ,QQJ,NZ,MSTEP,ISTEP,ICHG,
     \            TSD0,TQ0)
C      CALL DEBUGOT(IT,SD,Q,TSD,TQ,ISTEP,KIJT,TSD0,NZ)
C      WRITE(6,*) '**IT6=',IT
C      IF(ICHG.EQ.1) THEN
C          WRITE(6,*) '**IT7=',IT
C          STOP
C          CALL KIJSET(SDJ,QQJ,NZ,ISTEP,KIJT)
          CALL KIJST2(KIJ0,NZ,ISTEP,KIJT)

C      CALL DEBUGOT2(IT,CRA,KIJT,KD,KD1,NZ)
          CALL SANKOU(KIJT,NZ,NF,KD)
          CALL JACOB3(NZ,KD,M,TTD,U)
          TTT=TTD(1)
C      CALL DEBUGOT2(IT,CRA,KIJT,KD,KD1,NZ)
          CALL HENKAN(KD,CRA,NZ,KD1)
C      CALL DEBUGOT3(IT,CRA,KIJT,KD,KD1,NZ)
C      CALL DEBUGOT2(IT,CRA,KIJT,KD,KD1,NZ)
C          CALL DUMPST(KD1,T,H,NZ,C)
          CALL MIVSET(KD1,C,MD1,BETA,DT,NZ,MIV)
C      CALL DEBUGOT2(IT,CRA,KIJT,KD,KD1,NZ)
C      ENDIF
      GOTO  20
      END
      SUBROUTINE IEIDST2(NZ,NF,KIJ,TYP,QIJ)
C
      INTEGER TYP(NF,NZ)
      REAL KIJ(NF,3,NZ),QIJ(NF,2,NZ)
C
      CALL CLEAR(KIJ,NF*NZ*3,3)
      CALL CLEAR(QIJ,NF*NZ*2,3)
      DO 10 IF=1,NF
      DO 10 IZ=1,NZ
          READ(7,1010) TYP(IF,IZ),(KIJ(IF,J,IZ),J=1,3),
     \                            (QIJ(IF,K,IZ),K=1,2)
          WRITE (6,1011) TYP(IF,IZ),(KIJ(IF,J,IZ),J=1,3),
     \                              (QIJ(IF,K,IZ),K=1,2)
   10 CONTINUE
C
 1010 FORMAT(I5,5F10.0)
 1011 FORMAT (1H ,'***IEIDST2***TYP(I)=',I5,' **KIJ,QIJ=',5E15.7/)
      RETURN
      END
      SUBROUTINE IDATSTS1(RRR,NZ)
C
      REAL RRR(NZ)
C
      DO 10 I=1,NZ
          READ(7,1010) RRR(I)
   10 CONTINUE
C
 1010 FORMAT(F12.0)
      DO 20 I=1,NZ
         RRR(I)=RRR(I)/980.0
   20 CONTINUE
      RETURN
      END
      SUBROUTINE ODATSTS1(RRR,N1,N2,NAME)
      REAL RRR(N1,N2)
      CHARACTER NAME*(*)
      WRITE(8,1010) NAME
 1010 FORMAT(/1H ,'<<',A4,'>>'/)
      DO 10 I=1,N1
          WRITE(8,1020) (RRR(I,J),J=1,N2)
 1020     FORMAT(1H ,5E15.7/)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE ODATSTS5(RRR,N1,N2,NAME)
      REAL RRR(N1,N2)
      CHARACTER NAME*4
      WRITE(8,1010) NAME
 1010 FORMAT(/1H ,'<<',A4,'>>'/)
      DO 10 J=1,N2
          WRITE(8,1020) (RRR(I,J),I=1,N1)
 1020     FORMAT(1H ,5E15.7/)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE ODATSTS3(RRR,N1,N2,NAME)
      REAL RRR(N1,N2)
      CHARACTER NAME*4
      WRITE(8,1010) NAME
 1010 FORMAT(/1H ,'<<',A4,'>>'/)
      DO 10 J=1,N2
         WRITE(8,1020) (RRR(I,J),I=1,N1)
 1020     FORMAT(1H ,8F10.3/)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE ODATSTS7(RRR,N1,N2,NAME)
      REAL RRR(N1,N2,2)
      CHARACTER NAME*4
      WRITE(8,1010) NAME
 1010 FORMAT(/1H ,'<<',A4,'>>'/)
      DO 10 K=1,2
      DO 10 J=1,N2
         WRITE(8,1020) (RRR(I,J,K),I=1,N1)
 1020     FORMAT(1H ,8F10.3/)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TOTLST(D,TD,ME)
      IMPLICIT INTEGER(A-Z)
      REAL D(ME),TD(ME)
      DO 10 IE=1,ME
          TD(IE)=TD(IE)+D(IE)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TOTLST2(D,TD,NZ,NF)
      IMPLICIT INTEGER(A-Z)
      REAL D(NF,NZ),TD(NF,NZ)
      DO 10 IF=1,NF
      DO 10 IZ=1,NZ
          TD(IF,IZ)=TD(IF,IZ)+D(IF,IZ)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TOTLST3(D,TD,ME)
      IMPLICIT INTEGER(A-Z)
      REAL D(ME,2),TD(ME,2)
      DO 10 IE=1,ME
      DO 10 I=1,2
          TD(IE,I)=TD(IE,I)+D(IE,I)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE QSET(SD,KIJT,Q,NZ,NF)
      IMPLICIT INTEGER(A-Z)
      REAL SD(NZ),KIJT(NF,NZ,2),Q(NF,NZ,2)
      DO 10 IF=1,NF
      DO 10 IZ=1,NZ
      DO 10 I=1,2
          Q(IF,IZ,I)=KIJT(IF,IZ,I)*SD(IZ)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE OUTMAT(CRA,KD,KD1,NZ)
      REAL KD(NZ,NZ),KD1(NZ,NZ),CRA(NZ,NZ)
      INTEGER NZ
      DO 10 I=1,NZ
          WRITE(8,1010)(KD(I,J),J=1,NZ)
   10 CONTINUE
      DO 20 I=1,NZ
          WRITE(8,1010)(KD1(I,J),J=1,NZ)
   20 CONTINUE
      DO 30 J=1,NZ
          WRITE(8,1020)(CRA(I,J),I=1,NZ)
   30 CONTINUE
 1010 FORMAT(1H ,10F8.0)
 1020 FORMAT(1H ,10F8.2)
      RETURN
      END
      SUBROUTINE WAVEST(WTM,NTM,AMAX)
      REAL WTM(NTM),AMAX,BMAX,RATIO
      IF(AMAX.EQ.0.0) RETURN
      BMAX=0.0
      DO 10 I=1,NTM
          IF(ABS(WTM(I)).GT.BMAX) THEN
              BMAX=ABS(WTM(I))
          ENDIF
   10 CONTINUE
      RATIO=AMAX/BMAX
      DO 20 I=1,NTM
          WTM(I)=WTM(I)*RATIO
   20 CONTINUE
      WRITE(8,1010) AMAX,BMAX,RATIO
 1010 FORMAT(1H ,3F10.2)
      RETURN
      END
      SUBROUTINE QDOUT(TSD,TQ,TTT,NZ,DT,IT)
      REAL TSD(NZ),TQ(NZ,2) ,TTT,DT
      WRITE(10,1010) (TSD(IZ),TQ(IZ,1),TQ(IZ,2),
     \          TQ(IZ,1)+TQ(IZ,2),IZ=1,NZ),IT*DT,TTT
 1010 FORMAT(1H ,20(F12.5,',',3(F12.3,',')),F12.4,',',F12.5)
      RETURN
      END
      SUBROUTINE SDQJIN(SDJ,QQJ,NZ,MSTEP)
      IMPLICIT INTEGER(A-Z)
      REAL SDJ(10000,NZ),QQJ(10000,NZ,2)
      INTEGER IDUM 
      CHARACTER DUMMY*4
      READ(9,1010) MSTEP
 1010 FORMAT(I15)
      DO 20 IZ=1,NZ
          READ(9,1015) DUMMY
 1015     FORMAT(A4)
          DO 10 IS=1,MSTEP
              READ(9,1020) IDUM,SDJ(IS,IZ),QQJ(IS,IZ,1),QQJ(IS,IZ,2)
 1020         FORMAT(I15,F15.6,2F15.3)
   10     CONTINUE
   20 CONTINUE
      RETURN
      END
      SUBROUTINE KIJSET(SDJ,QQJ,NZ,ISTEP,KIJT)
      IMPLICIT INTEGER(A-Z)
      REAL SDJ(10000,NZ),QQJ(10000,NZ)
      REAL KIJT(NZ)
      INTEGER ISTEP(NZ)
      DO 10 IZ=1,NZ
          JZ=NZ-IZ+1
          IP=1
    5     IF(ABS(SDJ(ISTEP(JZ),JZ)-SDJ(ISTEP(JZ)+IP,JZ)).LT.0.001) THEN
              IP=IP+1
              IF(IP+IS.LT.MSTEP) THEN
                  GO TO 5
              ENDIF
    6         IP=IP-1
              IF(ABS(SDJ(ISTEP(JZ),JZ)-SDJ(ISTEP(JZ)+IP,JZ))
     \            .LT.0.001) THEN
                  GO TO 6
              ENDIF
          ENDIF
          KIJT(IZ)=(QQJ(ISTEP(JZ)+IP,JZ)-QQJ(ISTEP(JZ),JZ))
     \            /(SDJ(ISTEP(JZ)+IP,JZ)-SDJ(ISTEP(JZ),JZ))
   10 CONTINUE
      RETURN
      END
      SUBROUTINE JHSTST(IT,SD,Q,TSD,TQ,SDJ,QQJ,NZ,MSTEP,ISTEP,
     \                  ICHG,TSD0,TQ0)
      IMPLICIT INTEGER(A-Z)
      REAL SD(NZ),Q(NZ,2),TSD(NZ),TQ(NZ,2),SDJ(10000,NZ),
     \     QQJ(10000,NZ,2),TSD0(NZ),TQ0(NZ,2)
      INTEGER ISTEP(NZ,2),ICHG(NZ,2)
C      CALL CLEARI(ICHG,NZ,2)
C
      DO 5 IZ=1,NZ
      DO 5 I=1,2
          IF(TQ0(IZ,I)*TQ(IZ,I).LE.0.0) THEN
              TSD0(IZ)=TSD(IZ)
          ENDIF
          TQ0(IZ,I)=TQ(IZ,I)
    5 CONTINUE
      DO 10 IZ=1,NZ
      DO 10 I=1,2
          JZ=NZ-IZ+1
          IF(TQ(IZ,I).GE.0.0) THEN
              IF(Q(IZ,I).GE.0.0) THEN
                  CALL ISTSRC(TSD(IZ)-TSD0(IZ),TQ(IZ,I),SDJ(1,JZ),
     \                        QQJ(1,JZ,I),ISTEP(JZ,I),MSTEP)
              ELSE
                  ISTEP(JZ,I)=1
               ENDIF
          ELSE
              IF(Q(IZ,I).LE.0.0) THEN
C              IF(Q(IZ,I).LE.0.0 .AND. SD(IZ).LE.0.0) THEN
                  CALL ISTSRC(TSD(IZ)-TSD0(IZ),TQ(IZ,I),SDJ(1,JZ),
     \                        QQJ(1,JZ,I),ISTEP(JZ,I),MSTEP)
              ELSE
                  ISTEP(JZ,I)=1
              ENDIF
          ENDIF
   10 CONTINUE
      RETURN
      END
      SUBROUTINE ISTSRC(TSD,TQ,SDJ,QQJ,ISTEP,MSTEP)
      IMPLICIT INTEGER(A-Z)
      REAL TSD,TQ,SDJ(10000),QQJ(10000)
      INTEGER ISTEP,ICHG
      DO 10 IS=1,MSTEP-1
          IP=1
    5     IF(ABS(QQJ(IS)-QQJ(IS+IP)).LT.1.0) THEN
              IP=IP+1
              IF(IP+IS.LT.MSTEP) THEN
                  GO TO 5
              ENDIF
          ENDIF
          IF(ABS(TQ).GE.QQJ(IS) .AND. ABS(TQ).LE.QQJ(IS+IP)) THEN
              ISTEP=IS
              GO TO 30
          ENDIF
   10 CONTINUE 
      DO 20 IS=1,MSTEP-1
          IP=1
   15     IF(ABS(SDJ(IS)-SDJ(IS+IP)).LT.0.1) THEN
              IP=IP+1
              IF(IP+IS.LT.MSTEP) THEN
                  GO TO 15
              ENDIF
          ENDIF
          IF(ABS(TSD).GE.SDJ(IS) .AND. ABS(TSD).LE.SDJ(IS+IP)) THEN
              ISTEP=IS
              GO TO 30
          ENDIF
   20 CONTINUE
      ISTEP=MSTEP-1
   30 CONTINUE
      RETURN
      END
      SUBROUTINE DEBUGOT(IT,SD,Q,TSD,TQ,ISTEP,KIJT,TSD0,NZ)
      IMPLICIT INTEGER(A-Z)
      REAL SD(NZ),Q(NZ),TSD(NZ),TQ(NZ),KIJT(NZ),TSD0(NZ)
      INTEGER ISTEP(NZ)
      WRITE(12,*)  IT,SD(NZ),Q(NZ),TSD(NZ),TQ(NZ),ISTEP(1),
     \             KIJT(NZ),TSD0(NZ)
      RETURN
      END
      SUBROUTINE DEBUGOT2(IT,CRA,KIJT,KD,KD1,NZ)
      IMPLICIT INTEGER(A-Z)
      REAL CRA(1),KIJT(1),KD(1),KD1(1)
      WRITE(12,*) '**IT=',IT,CRA(1),KIJT(1),KD(1),KD1(1)
C      DO 10 IZ=1,NZ
C          WRITE(12,*) IZ,SD(IZ),SV(IZ),SA(IZ)
C   10 CONTINUE
      RETURN
      END
      SUBROUTINE DEBUGOT3(IT,CRA,KIJT,KD,KD1,NZ)
      IMPLICIT INTEGER(A-Z)
      REAL CRA(NZ,NZ),KIJT(NZ),KD(NZ,NZ),KD1(NZ,NZ)
      IF(IT.NE.661) RETURN
      CALL DEBUGST(CRA,NZ,NZ)
      CALL DEBUGST(KIJT,NZ,2)
      CALL DEBUGST(KD,NZ,NZ)
      CALL DEBUGST(KD1,NZ,NZ)
      STOP
      END
      SUBROUTINE DEBUGST(KD,N1,N2)
      REAL KD(N1,N2)
      DO 10 I2=1,N2
          WRITE(12,1010) (KD(I1,I2),I1=1,N1)
 1010     FORMAT(1H ,10F12.5)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE KIJINI(SDJ,QQJ,NZ,MSTEP,KIJ0)
      IMPLICIT INTEGER(A-Z)
      REAL SDJ(10000,NZ),QQJ(10000,NZ,2),KIJ0(10000,NZ,2)
      DO 10 IZ=1,NZ
      DO 10 IS=1,MSTEP-1
      DO 10 I=1,2
          IF(ABS(SDJ(IS+1,IZ)-SDJ(IS,IZ)).EQ.0.0) THEN
              KIJ0(IS,IZ,I)=999999
          ELSEIF(ABS(QQJ(IS+1,IZ,I)-QQJ(IS,IZ,I)).EQ.0.0) THEN
              KIJ0(IS,IZ,I)=999999
          ELSE
              KIJ0(IS,IZ,I)=(QQJ(IS+1,IZ,I)-QQJ(IS,IZ,I))
     \                   /(SDJ(IS+1,IZ)-SDJ(IS,IZ))
          ENDIF
   10 CONTINUE
      DO 20 IZ=1,NZ
      DO 20 IS=1,MSTEP-1
      DO 20 I=1,2
          IF(KIJ0(IS,IZ,I).GT.999990.0) THEN
              KIJ0(IS,IZ,I)=KIJ0(IS-1,IZ,I)
          ENDIF
   20 CONTINUE
C      DO 30 IS=1,MSTEP
      IS=1
      DO 30 I=1,2
          WRITE(12,1010) (KIJ0(IS,IZ,I),IZ=1,NZ)
 1010     FORMAT(1H ,5F12.3)
   30 CONTINUE
      RETURN
      END
      SUBROUTINE KIJST2(KIJ0,NZ,ISTEP,KIJT)
      IMPLICIT INTEGER(A-Z)
      REAL KIJ0(10000,NZ,2),KIJT(NZ,2)
      INTEGER ISTEP(NZ,2)
      DO 10 IZ=1,NZ
      DO 10 I=1,2
          JZ=NZ-IZ+1
          KIJT(JZ,I)=KIJ0(ISTEP(IZ,I),IZ,I)
   10 CONTINUE
      RETURN
      END
