      SUBROUTINE TINPTZ
C
      IMPLICIT INTEGER(A-Z)
      COMMON /COM0/ MX,MZ,NX,NZ,MB,MC,L0,SEIDO
      COMMON /COMA/ MMW,MG,MMSC,MBNR,MBNV,MBNS,
     \              NNWIJ(3,2,2,1000),TNWIJ(3,2,500,50)
     \       /COMB/ XXX(3,1000),ZZZ(2,1000)
     \       /COMC/ NGIJ(3,3,2,1000),NMSIJ(3,1000),NBNIJ(3,3 ,2,1000)
     \       /COMD1/ EG(1000),IG(1000),EMS(1000),IMS(1000),AMS(1000),
     \              BNR(3,1000),BNV(3,1000),BNS(3,1000),
     \              BNSMAX(1000)
     \       /COME/ RS(3,2,1000),VS(3,2,1000),US(3,2,1000)
     \       /COMF/ KBS(4,3,2,1000),KCS(5,1000),KBNS(3,3,2,1000)
     \       /COMG/ QG(3,2,1000),RMG(2,3,2,1000),
     \              QMS(1000),NMS(1000),MMS(2,1000)
      INTEGER MMW,MG,MMSC,MBNR,MBNV,MBNS,NNWIJ,NGIJ,NMSIJ,NBNIJ
      REAL XXX,ZZZ,EG,IG,EMS,IMS,AMS,BNR,BNV,BNS,RS,VS,US,
     \     KBS,KCS,KBNS,QG,RMG,QMS,NMS,MMS,
     \     BNSMAX
C
C                                       **DATA INPUT**
C
      READ(15,1010) MMW,MG,MMSC,MBNR,MBNV,MBNS
 1010 FORMAT(6I10)
      WRITE(8,1020) MMW,MG,MMSC,MBNR,MBNV,MBNS
 1020 FORMAT(1H ,6I5)
      CALL TGRIDST(XXX,3,MMW)
      CALL RDWRIT('XXX ',XXX,3,MMW,1)
      CALL TGRIDST(ZZZ,2,MMW)
      CALL RDWRIT('ZZZ ',ZZZ,2,MMW,1)
      CALL TBMEMST(EG,IG,MG)
      CALL RDWRIT('EG  ',EG,MG,1,1)
      CALL RDWRIT('IG  ',IG,MG,1,1)
      CALL TCMEMST(EMS,IMS,AMS,MMSC)
      CALL RDWRIT('EMS ',EMS,MMSC,1,1)
      CALL RDWRIT('IMS ',IMS,MMSC,1,1)
      CALL RDWRIT('AMS  ',AMS,MMSC,1,1)
      WRITE(6,*) '**TCMEST END**'
      CALL TBANEST(BNR,MBNR)
      CALL TBANEST(BNV,MBNV)
      CALL TBANES2(BNS,BNSMAX,MBNS)
      WRITE(8,*) '**TBANEST END**'
      CALL TAIOUS(NNWIJ,MMW)
      CALL WTAIOUS(NNWIJ,MMW)
      WRITE(6,*) '**TAIOUS END**'
      CALL GYKTOS(NNWIJ,MMW,TNWIJ,MX,MZ)
      WRITE(6,*) '**GYKTOS END**'
      CALL TNWIJOT(TNWIJ,MX,MZ)
      CALL TBHICST(NGIJ,MMW)
      CALL WTBHICST(NGIJ,MMW)
      CALL TCHICST(NMSIJ,MMW)
      CALL WTCHICST(NMSIJ,MMW)
      CALL TBANEHC(NBNIJ,MMW)
      CALL WTBANEHC(NBNIJ,MMW)
      WRITE(6,*) '**TBANEHC END**'
      RETURN
      END
      SUBROUTINE TGRIDST(XXX,N,MMW)
      IMPLICIT INTEGER(A-Z)
      REAL XXX(N,MMW)
      DO 10 IX=1,MMW
          READ(15,1010) (XXX(I,IX),I=1,N)
 1010     FORMAT(3F10.0)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TBMEMST(EG,IG,MG)
      IMPLICIT INTEGER(A-Z)
      REAL EG(MG),IG(MG)
      DO 10 I=1,MG
          READ(15,1010) IDUM,EG(I),IG(I)
 1010     FORMAT(I10,2E15.7)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TCMEMST(EMS,IMS,AMS,MMSC)
      IMPLICIT INTEGER(A-Z)
      REAL EMS(MMSC),IMS(MMSC),AMS(MMSC)
      DO 10 I=1,MMSC
          READ(15,1010) IDUM,EMS(I),IMS(I),AMS(I)
 1010     FORMAT(I10,3E15.7)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TBANEST(BN,MBN)
      IMPLICIT INTEGER(A-Z)
      REAL BN(3,MBN)
      DO 10 J=1,MBN
          READ(15,1010) (BN(I,J),I=1,3)
 1010     FORMAT(3E15.7)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TBANES2(BN,BNMAX,MBN)
      IMPLICIT INTEGER(A-Z)
      REAL BN(3,MBN),BNMAX(MBN)
      DO 10 J=1,MBN
          READ(15,1010) (BN(I,J),I=1,3),BNMAX(J)
 1010     FORMAT(4E15.7)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TAIOUS(NNWIJ,MMW)
      IMPLICIT INTEGER(A-Z)
      INTEGER NNWIJ(3,2,2,MMW)
      CALL CLEAR(NNWIJ,3*2*2*MMW,2) 
      DO 10 IW=1,MMW
      DO 10 K=1,2
          READ(15,1010) ((NNWIJ(I,J,K,IW),I=1,3),J=1,2)
 1010     FORMAT(6I10)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE WTAIOUS(NNWIJ,MMW)
      IMPLICIT INTEGER(A-Z)
      INTEGER NNWIJ(3,2,2,MMW)
      DO 10 IW=1,MMW
      DO 10 K=1,2
          WRITE(8,1010) ((NNWIJ(I,J,K,IW),I=1,3),J=1,2)
 1010     FORMAT(1H ,6I5)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE GYKTOS(NNWIJ,MMW,TNWIJ,MX,MZ)
      IMPLICIT INTEGER(A-Z)
      INTEGER NNWIJ(3,2,2,MMW),TNWIJ(3,2,MX,MZ)
      CALL CLEAR(TNWIJ,3*2*MX*MZ,1)
      DO 20 IW=1,MMW
          IF(NNWIJ(1,1,1,IW).NE.0) THEN
          DO 10 I=1,3
              IX=NNWIJ(I,1,1,IW)
              IZ=NNWIJ(I,1,2,IW)
              TNWIJ(1,2,IX,IZ)=IW
              TNWIJ(2,2,IX,IZ)=I
              TNWIJ(3,2,IX,IZ)=1
              TNWIJ(1,1,IX,IZ+1)=IW
              TNWIJ(2,1,IX,IZ+1)=I
              TNWIJ(3,1,IX,IZ+1)=2
   10     CONTINUE
          ENDIF
   20 CONTINUE
      RETURN
      END      
      SUBROUTINE TBHICST(NGIJ,MMW)
      IMPLICIT INTEGER(A-Z)
      INTEGER NGIJ(3,3,2,MMW)
      CALL CLEARI(NGIJ,3*3*2*MMW,2)
      DO 10 IW=1,MMW
      DO 10 K=1,2
      DO 10 J=1,3
          READ(15,1010) (NGIJ(I,J,K,IW),I=1,3)
 1010     FORMAT(3I10)
   10 CONTINUE
      RETURN
      END    
      SUBROUTINE WTBHICST(NGIJ,MMW)
      IMPLICIT INTEGER(A-Z)
      INTEGER NGIJ(3,3,2,MMW)
      DO 10 IW=1,MMW
      DO 10 K=1,2
      DO 10 J=1,3
          WRITE(8,1010) (NGIJ(I,J,K,IW),I=1,3)
 1010     FORMAT(1H ,3I5)
   10 CONTINUE
      RETURN
      END    
      SUBROUTINE TCHICST(NMSIJ,MMW)
      IMPLICIT INTEGER(A-Z)
      INTEGER NMSIJ(3,MMW)
      CALL CLEARI(NMSIJ,3*MMW,2)
      DO 10 IW=1,MMW
          READ(15,1010) (NMSIJ(I,IW),I=1,3)
 1010     FORMAT(3I10)
   10 CONTINUE
      RETURN
      END 
      SUBROUTINE WTCHICST(NMSIJ,MMW)
      IMPLICIT INTEGER(A-Z)
      INTEGER NMSIJ(3,MMW)
      DO 10 IW=1,MMW
          WRITE(8,1010) (NMSIJ(I,IW),I=1,3)
 1010     FORMAT(1H ,3I5)
   10 CONTINUE
      RETURN
      END 

      SUBROUTINE TBANEHC(NBNIJ,MMW)
      IMPLICIT INTEGER(A-Z)
      INTEGER NBNIJ(3,3,2,MMW)
      CALL CLEAR(NBNIJ,3*3*2*MMW,2)
      DO 10 IW=1,MMW
      DO 10 K=1,2
      DO 10 J=1,3
          READ(15,1010) (NBNIJ(I,J,K,IW),I=1,3)
 1010     FORMAT(3I10)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE WTBANEHC(NBNIJ,MMW)
      IMPLICIT INTEGER(A-Z)
      INTEGER NBNIJ(3,3,2,MMW)
      DO 10 IW=1,MMW
      DO 10 K=1,2
      DO 10 J=1,3
          WRITE(8,1010) (NBNIJ(I,J,K,IW),I=1,3)
 1010     FORMAT(1H ,3I5)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TNWIJOT(TNWIJ,MX,MZ)
      IMPLICIT INTEGER(A-Z)
      INTEGER TNWIJ(3,2,MX,MZ) 
      DO 10 IZ=1,MZ
      DO 10 J=1,2
      DO 10 I=1,3
          WRITE(8,1010) (TNWIJ(I,J,IX,IZ),IX=1,MX)
 1010     FORMAT(1H ,20I5)
   10 CONTINUE
      RETURN
      END      