      SUBROUTINE TMATSZ
      IMPLICIT INTEGER(A-Z)     
      COMMON /COM0/ MX,MZ,NX,NZ,MB,MC,L0,SEIDO
      COMMON /COMA/ MMW,MG,MMSC,MBNR,MBNV,MBNS,
     \              NNWIJ(3,2,2,1000),TNWIJ(3,2,500,50)
     \       /COMB/ XXX(3,1000),ZZZ(2,1000)
     \       /COMC/ NGIJ(3,3,2,1000),NMSIJ(3,1000),NBNIJ(3,3,2,1000)
     \       /COMD1/ EG(1000),IG(1000),EMS(1000),IMS(1000),AMS(1000),
     \              BNR(3,1000),BNV(3,1000),BNS(3,1000)
     \       /COME/ RS(3,2,1000),VS(3,2,1000),US(3,2,1000)
     \       /COMF/ KBS(4,3,2,1000),KCS(5,1000),KBNS(3,3,2,1000),
     \       /COMG/ QG(3,2,1000),RMG(2,3,2,1000),
     \              QMS(1000),NMS(1000),MMS(2,1000)
      INTEGER MMW,MG,MMSC,MBNR,MBNV,MBNS,NNWIJ,NGIJ,NMSIJ,NBNIJ
      REAL XXX,ZZZ,EG,IG,EMS,IMS,AMS,BNR,BNV,BNS,RS,VS,US,
     \     KBS,KCS,KBNS,QG,RMG,QMS,NMS,MMS,L0
C
      CALL TBMATST(EG,IG,MG,XXX,ZZZ,L0,MMW,NGIJ,KBS)
      CALL TCMATST(EMS,IMS,AMS,MMSC,XXX,ZZZ,L0,MMW,NMSIJ,KCS)
      CALL TBNMATS(NBNIJ,BNR,BNV,BNS,MMW,MBNR,MBNV,MBNS,KBNS)
      RETURN
      END
      SUBROUTINE TBMATST(EG,IG,MG,XXX,ZZZ,L0,MMW,NGIJ,KBS)
      IMPLICIT INTEGER(A-Z)
      REAL EG(MG),IG(MG),XXX(3,MMW),ZZZ(2,MMW),L0,
     \     KBS(4,3,2,MMW),LB,LB0,KB0
      INTEGER NGIJ(3,3,2,MMW)
      CALL CLEAR(KBS,4*3*2*MMW,3)
      DO 10 IW=1,MMW
      DO 10 I=1,3
      DO 10 J=1,2
         IF(NGIJ(3,I,J,IW).EQ.0) GO TO 10
         LB=XXX(NGIJ(3,I,J,IW),IW)-XXX(I,IW)
         LB0=LB/L0
         KB0=EG(NGIJ(1,I,J,IW))*IG(NGIJ(1,I,J,IW))/LB**3
         KBS(1,I,J,IW)=12*KB0
         KBS(2,I,J,IW)=+6*KB0*LB0
         KBS(3,I,J,IW)=4*KB0*LB0**2
         KBS(4,I,J,IW)=2*KB0*LB0**2
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TCMATST(EMS,IMS,AMS,MMSC,XXX,ZZZ,L0,MMW,NMSIJ,KCS)
      IMPLICIT INTEGER(A-Z)
      REAL EMS(MMSC),IMS(MMSC),AMS(MMSC),XXX(3,MMW),ZZZ(2,MMW),L0,
     \     KCS(5,MMW),LC,LC0
      INTEGER NMSIJ(3,MMW)
      CALL CLEAR(KCS,5*MMW,3)
      DO 10 IW=1,MMW
          IF(NMSIJ(3,IW).EQ.0) GO TO 10
          LC=ZZZ(2,IW)-ZZZ(1,IW)
          LC0=LC/L0
          KC0=EMS(NMSIJ(1,IW))*IMS(NMSIJ(1,IW))/LC**3
          AC0=AMS(NMSIJ(1,IW))*LC**2/IMS(NMSIJ(1,IW))
          KCS(1,IW)=12*KC0
          KCS(2,IW)=-6*KC0*LC0
          KCS(3,IW)=KC0*AC0
          KCS(4,IW)=4*KC0*LC0**2
          KCS(5,IW)=2*KC0*LC0**2
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TBNMATS(NBNIJ,BNR,BNV,BNS,MMW,MBNR,MBNV,MBNS,KBNS)
      IMPLICIT INTEGER(A-Z)
      INTEGER NBNIJ(3,3,2,MMW)
      REAL BNR(3,MBNR),BNV(3,MBNV),BNS(3,MBNS),KBNS(3,3,2,MMW)
      CALL CLEAR(KBNS,3*3*2*MMW,3)
      DO 10 IW=1,MMW
      DO 10 I=1,3
      DO 10 J=1,2
          IF(NBNIJ(1,I,J,IW).NE.0) THEN
              IN=NBNIJ(1,I,J,IW)
              KBNS(1,I,J,IW)=BNR(1,IN)
          ENDIF
          IF(NBNIJ(2,I,J,IW).NE.0) THEN
              IN=NBNIJ(2,I,J,IW)
              KBNS(2,I,J,IW)=BNV(1,IN)
          ENDIF
          IF(NBNIJ(3,I,J,IW).NE.0) THEN
              IN=NBNIJ(3,I,J,IW)
              KBNS(3,I,J,IW)=BNS(1,IN)
          ENDIF
   10 CONTINUE
      RETURN
      END
