      SUBROUTINE CHSTBI( ESPR,PSPR,QCUT,DELY,DELM,                              
     *                   DL,DLA,DL1,DL1A,                                       
     *                   TPDL,TNDL,ENEG,                                        
     *                   RDEL,QQ,RK, IPLA,ICHG )                                
C                                                                               
C     FUNCTION: BI-LINEAR ގ Վݎ ʎގ ގ֎                               
C                                                                               
C     PARAMATER: (IN)     ESPR    ̎ގ ؎֎ Ď ގݎ ގ                    
C                         PSPR                      ގ                    
C                         QCUT                    ގ  Q ގ Ď Î      
C                         DELY                   ̎ ͎ݎ                       
C                         DELM                   ʎ ͎ݎ                        
C                                                                               
C                         DL      T=T0      ͎ݎ                             
C                         DLA     T=T0+DT   ͎ݎ                             
C                         DL1     T=T0      Ď                            
C                         DL1A    T=T0+DT   Ď                            
C                                                                               
C                (IN/OUT) TPDL    َ  ͎ݎ (+ ގ)                         
C                         TNDL                  (- ގ)                         
C                         ENEG    ՎՎ Ȏَ                                  
C                         RDEL    ގݎ ֎  Վ  ͎ݎ                     
C                                 ώ   ʎ Ď  ͎ݎ                       
C                         QQ      Վݎ ʎގ ʎގ  Q ގ  Î                
C                         RK      Վݎ ʎގ ʎގ                               
C                         IPLA    ʎގ  ގ֎  ގݎ(0),(1),ʎ(2)          
C                (OUT)    ICHG    ʎގ  ͎ݎ  Ŏ(0),(1)                       
C                                                                               
C     ID: 6-1                                                                   
C                                                                               
C     CODED BY: S.YAMAZAKI                        (1981-12-18)                  
C                                                                               
      ICHG=0                                                                    
      IF(IPLA.EQ.2) RETURN                                                      
C                                                                               
C                                       ** ώ  Î̎  Q (QB)               
C                                                                               
      QB=QQ + RK*DL                                                             
C                                                                               
C                                       ** ʎ  ʎݎÎ                           
C                                                                               
      IF( ABS(DLA).GT.DELM ) THEN                                               
          IPLA=2                                                                
                    QQ=0.                                                       
                    RK=0.                                                       
                    ICHG=1                                                      
                    RETURN                                                      
      ENDIF                                                                     
C                                                                               
C                                       ** ώ  Î̎  ގݎ                  
C                                                                               
      IF(IPLA.EQ.1) GO TO 30                                                    
      IF(DLA.LT.RDEL-DELY) GO TO 10                                             
      IF(DLA.GT.RDEL+DELY) GO TO 20                                             
      GO TO 40                                                                  
C                                                                               
C                                       **    - ގ Î   ʎ                
C                                                                               
   10 ICHG=1                                                                    
      IPLA=1                                                                    
      RDEL=RDEL-DELY                                                            
      QQ=-QCUT                                                                  
      RK=PSPR                                                                   
      GO TO 30                                                                  
C                                                                               
C                                       **    + ގ Î   ʎ                
C                                                                               
   20 ICHG=1                                                                    
      IPLA=1                                                                    
      RDEL=RDEL+DELY                                                            
      QQ=QCUT                                                                   
      RK=PSPR                                                                   
      GO TO 30                                                                  
C                                                                               
C                                       ** ώ  Î̎                      
C                                                                               
   30 IF( DL1A*DL1 .GT. 0.0 )  GO TO 40                                         
      ICHG=1                                                                    
      IPLA=0                                                                    
      QQ=(PSPR-ESPR)*DLA                                                        
      RK=ESPR                                                                   
      IF(DL1.GT.0.) THEN                                                        
                    TPDL=TPDL+DLA-RDEL                                          
                    RDEL=DLA-DELY                                               
                    QQ  =QQ+QCUT                                                
      ENDIF                                                                     
      IF(DL1.LT.0.) THEN                                                        
                    TNDL=TNDL+RDEL-DLA                                          
                    RDEL=DLA+DELY                                               
                    QQ  =QQ-QCUT                                                
      ENDIF                                                                     
C                                                                               
C                                       ** Ȏَ- ގ̎ގ                        
C                                                                               
   40 QA=QQ + RK*DLA                                                            
      ENEG=ENEG + (QA+QB)/2.0*(DLA-DL)                                          
      RETURN                                                                    
      END                                                                       
      SUBROUTINE CHSTSL( ESPR,PSPR,QCUT,DELY,DELM,                              
     *                   DL,DLA,DL1,DL1A,                                       
     *                   DELP,DELN,ENEG,                                        
     *                   QQ,RK, IPLA,ICHG )                                     
C                                                                               
C     FUNCTION: SLIP ގ Վݎ ʎގ ގ֎                                    
C                                                                               
C     PARAMATER: (IN)     ESPR    ̎ގ ؎֎ Ď ގݎ ގ                    
C                         PSPR                      ގ                    
C                         QCUT                    ގ  Q ގ Ď Î      
C                         DELY                   ̎ ͎ݎ                       
C                         DELM                   ʎ ʎݎ                        
C                                                                               
C                         DL      T=T0      ͎ݎ                             
C                         DLA     T=T0+DT   ͎ݎ                             
C                         DL1     T=T0      Ď                            
C                         DL1A    T=T0+DT   Ď                            
C                                                                               
C                (IN/OUT) DELP    ގ ͎ݎ (+ ގ , ֎   DELY)               
C                         DELN              (- ގ , ֎  -DELY)               
C                         ENEG    ՎՎ Ȏَ                                  
C                                                                               
C                         QQ      Վݎ ʎގ ʎގ  Q ގ  Î                
C                         RK      Վݎ ʎގ ʎގ                               
C                         IPLA    ʎގ  ގ֎  ގݎ(0),(1),؎̎(-1)       
C                                               ʎ(2)                          
C                (OUT)    ICHG    ʎގ  ͎ݎ  Ŏ(0),(1)                       
C                                                                               
C     ID: 6-2                                                                   
C                                                                               
C     CODED BY: S.YAMAZAKI                        (1981-12-21)                  
C                                                                               
      ICHG=0                                                                    
      IF(IPLA.EQ.2) RETURN                                                      
C                                                                               
C                                       ** ώ  Î̎  Q (QB)               
C                                                                               
      QB=QQ + RK*DL                                                             
C                                                                               
C                                       ** ʎ  ʎݎÎ                           
C                                                                               
      IF( ABS(DLA).GT.DELM ) THEN                                               
                               IPLA=2                                           
                               QQ=0.                                            
                               RK=0.                                            
                               ICHG=1                                           
                               RETURN                                           
      ENDIF                                                                     
C                                                                               
C                                       ** ̎ގݎَ                                
C                                                                               
      IF(IPLA.EQ.0)  GO TO 10                                                   
      IF(IPLA.EQ.1)  GO TO 50                                                   
      IF(IPLA.EQ.-1) GO TO 60                                                   
C                                                                               
C                                       ** ώ  Î̎  ގݎ                  
C                                                                               
   10 IF(DLA.LT.DELN)                             GO TO 20                      
      IF(DLA.GT.DELP)                             GO TO 30                      
      DLP1=DELP-(QCUT+PSPR*DELP)/ESPR                                           
      DLN1=DELN-(-QCUT+PSPR*DELN)/ESPR                                          
      IF(DLA.GT.DLN1 .AND. DLA.LT.DLP1) GO TO 40                                
      GO TO 70                                                                  
C                                                                               
C                                       **    - ގ Î   ʎ                
C                                                                               
   20 ICHG=1                                                                    
      IPLA=1                                                                    
      DELN=DLA                                                                  
      QQ=-QCUT                                                                  
      RK=PSPR                                                                   
      GO TO 70                                                                  
C                                                                               
C                                       **    + ގ Î   ʎ                
C                                                                               
   30 ICHG=1                                                                    
      IPLA=1                                                                    
      DELP=DLA                                                                  
      QQ=QCUT                                                                   
      RK=PSPR                                                                   
      GO TO 70                                                                  
C                                                                               
C                                       **    ؎̎  ʎ                       
C                                                                               
   40 ICHG=1                                                                    
      IPLA=-1                                                                   
      QQ=0.                                                                     
      RK=0.                                                                     
      GO TO 70                                                                  
C                                                                               
C                                       ** ώ  Î̎                      
C                                                                               
   50 IF( DL1A*DL1 .GT. 0. )  GO TO 70                                          
   55 ICHG=1                                                                    
      IPLA=0                                                                    
      QQ=(PSPR-ESPR)*DLA                                                        
      RK=ESPR                                                                   
      IF(DLA.GT.0.) THEN                                                        
                    QQ=QQ+QCUT                                                  
                    DELP=DLA                                                    
      ENDIF                                                                     
      IF(DLA.LT.0.) THEN                                                        
                    QQ=QQ-QCUT                                                  
                    DELN=DLA                                                    
      ENDIF                                                                     
      GO TO 70                                                                  
C                                                                               
C                                       ** ώ  Î̎  SLIP                   
C                                                                               
   60 DLP1=DELP-( QCUT+PSPR*DELP)/ESPR                                          
      DLN1=DELN-(-QCUT+PSPR*DELN)/ESPR                                          
      IF(DLA.GT. DLN1 .AND. DLA.LT.DLP1) GO TO 70                               
C                                                                               
C                                       **     ELASTIC                          
C                                                                               
      ICHG=1                                                                    
      IPLA=0                                                                    
      QQ=-DLA*ESPR                                                              
      RK=ESPR                                                                   
C                                                                               
C                                       ** Ȏَ ގ̎ގ                         
C                                                                               
   70 QA=QQ + RK*DLA                                                            
      ENEG=ENEG + (QA+QB)/2.0*(DLA-DL)                                          
      RETURN                                                                    
      END                                                                       
      SUBROUTINE CHSTOR( PSPR,QCUT,DELY,DELM,                                   
     *                   DL,DLA,DL1,DL1A,                                       
     *                   DELP,ENEG,                                             
     *                   QQ,RK,IPLA,ICHG )                                      
C                                                                               
C     FUNCTION: ގݎÎ  ގ *ݎ ʎގ ގ֎                               
C                                                                               
C     PARAMATER: (IN)     PSPR    ̎ގ ؎֎ Ď  ގ                      
C                         QCUT                    ގ  Q ގ Ď Î      
C                         DELY                   ގ 2 ̎ ͎ݎ                 
C                         DELM                   ʎ ͎ݎ                        
C                                                                               
C                         DL      T=T0      ͎ݎ                             
C                         DLA     T=T0+DT   ͎ݎ                             
C                         DL1     T=T0      Ď                            
C                         DL1A    T=T0+DT   Ď                           
C                                                                               
C                (IN/OUT) DELP    ގ ͎ݎ  ގ   (֎   DELY1)          
C                         ENEG    ՎՎ Ȏَ                                  
C                         QQ      Վݎ ʎގ ʎގ  Q ގ  Î                
C                         RK      Վݎ ʎގ ʎގ                               
C                         IPLA    ʎގ  ގ֎                                  
C                (OUT)    ICHG    ʎގ  ͎ݎ  Ŏ(0),(1)                       
C                                                                               
C     ID: 6-3                                                                   
C                                                                               
C     CODED BY: S.YAMAZAKI                        (1981-12-21)                  
C                                                                               
      REAL PSPR(1),QCUT(1)                                                      
      PSP1=PSPR(1)                                                              
      PSP2=PSPR(2)                                                              
      QCU1=QCUT(1)                                                              
      QCU2=QCUT(2)                                                              
      ICHG=0                                                                    
      IF(IPLA.EQ.2) RETURN                                                      
      IF(DELM.LE.0.) THEN                                                       
                     WRITE(6,*) DELM                                            
                     STOP '** CHSTOR **'                                        
      ENDIF                                                                     
      IF(DELP.LE.0.) THEN                                                       
                     WRITE(6,*) DELP                                            
                     STOP '** CHSTOR **'                                        
      ENDIF                                                                     
C                                                                               
C                                       ** ώ  Î̎  Q (QB)               
C                                                                               
      QB=QQ + RK*DL                                                             
C                                                                               
C                                       ** ʎ  ʎݎÎ                           
C                                                                               
      IF( ABS(DLA).GT.DELM ) THEN                                               
                               IPLA=2                                           
                               QQ=0.                                            
                               RK=0.                                            
                               ICHG=1                                           
                               RETURN                                           
      ENDIF                                                                     
C                                                                               
C                                       ** ώ  Î̎  ގݎ                  
C                                                                               
      IF(IPLA.EQ.1) GO TO 10                                                    
      IF( ABS(DLA).LT.ABS(DELP) )  GO TO 20                                     
C                                                                               
C                                       **      ʎ                         
C                                                                               
      ICHG=1                                                                    
      IPLA=1                                                                    
      DELP=ABS(DLA)                                                             
      QQ=SIGN(QCU1,DLA)                                                         
      RK=PSP1                                                                   
      IF( ABS(DLA).GT.DELY )  THEN                                              
                              QQ=SIGN(QCU2,DLA)                                 
                              RK=PSP2                                           
      ENDIF                                                                     
C                                                                               
C                                       ** ώ  Î̎                      
C                                                                               
   10 DELP=ABS(DLA)                                                             
      IF( DL1A*DL1 .GT. 0.0 )  GO TO 20                                         
      ICHG=1                                                                    
      IPLA=0                                                                    
      QA=QQ + RK*DLA                                                            
      RK=ABS(QA/DLA)                                                            
      QQ=0.                                                                     
C                                                                               
C                                       ** Ȏَ ގ̎ގ                         
C                                                                               
   20 QA=QQ + RK*DLA                                                            
      ENEG=ENEG + (QA+QB)/2.0*(DLA-DL)                                          
      RETURN                                                                    
      END                                                                       
      SUBROUTINE CHSTDT( SPR,DEL,FOR,SDF,                                       
     *                   DL,DLA,                                                
     *                   ICO,RCO, ENEG, QQ,RK, ICHG )                           
C                                                                               
C     FUNCTION: D-TRI (TAKEDA MODEL) ʎގ ގ֎                              
C                                                                               
C     PARAMATER: (IN)     SPR(3)   ̎ގ ؎֎ Ď ގ                         
C                         DEL(2)                  DELTA                         
C                         FOR(2)                  FORCE                         
C                         SDF(2)                  ގ Î                 
C                                                                               
C                         DL       T=T0      ͎ݎ                            
C                         DLA      T=T0+DT   ͎ݎ                            
C                                                                               
C                (IN/OUT) ICO      ̎ގ ؎֎ ގ֎ CONSTANT                    
C                         RCO(20)                                               
C                         ENEG     ՎՎ Ȏَ                                 
C                         QQ       Վݎ ʎގ ʎގ  Q ގ  Î               
C                         RK       Վݎ ʎގ ʎގ                              
C                                                                               
C                (OUT)    ICHG     ʎގ  ͎ݎ  Ŏ(0),(1)                      
C                                                                               
C     ROUTINE USED: HYST10                                                      
C                                                                               
C     ID: 6-4                                                                   
C                                                                               
C     CODED BY: S.YAMAZAKI                        (1982- 1- 9)                  
C                                                                               
      COMMON /STFF/ DCDY(2),FCFY(2),SCSY(3),FMDM(25)                            
     *       /STFF2/ B0B1(2)                                                    
      REAL   SPR(1),DEL(1),FOR(1),SDF(1), RCO(1)                                
C                                                                               
C                                       ** COMMON /STFF2/                   
C                                                                               
      DO 35 I=1,2                                                               
         B0B1(I)=SDF(I)                                                         
   35 CONTINUE                                                                  
C                                                                               
C                                       ** COMMON /STFF/                    
C                                                                               
      DO 10 I=1,2                                                               
         DCDY(I)=DEL(I)                                                         
         FCFY(I)=FOR(I)                                                         
   10 CONTINUE                                                                  
      DO 20 I=1,3                                                               
         SCSY(I)=SPR(I)                                                         
   20 CONTINUE                                                                  
      DO 30 I=1,20                                                              
         FMDM(I)=RCO(I)                                                         
   30 CONTINUE                                                                  
C                                                                               
C                                       ** HYST10  ˎ                    
C                                                                               
      RK1=RK                                                                    
      FS=QQ+RK*DL                                                               
      CALL HYST10(ICO,RK,DLA,DL, FF,FS)                                         
C                                                                               
C                                       **  ˎ                      
C                                                                               
      DO 40 I=1,20                                                              
         RCO(I)=FMDM(I)                                                         
   40 CONTINUE                                                                  
      QQ=FF-RK*DLA                                                              
      ENEG=ENEG + (FF+FS)*(DLA-DL)/2.0                                          
      ICHG=0                                                                    
      IF(RK.NE.RK1) ICHG=1                                                      
      RETURN                                                                    
      END                                                                       
      SUBROUTINE HYST10(LL,SS,DD,DS,FF,FS )                                     
C                                                                               
C     TAKEDA HYSTERESIS MODEL                                                   
C                                                                               
C     INPUT DATA                                                                
C        LL        HYSTERESIS RULE POINTER AT PREVIOUS TIME STEP                
C        DS        DISPLACEMENT AT PREVIOUS TIME STEP                           
C        DD        DISPLACEMENT AT PRESENT TIME STEP                            
C        FS        FORCE AT PREVIOUS TIME STEP                                  
C        SS        STIFFNESS AT PREVIOUS TIME STEP                              
C        FC        CRACKING FORCE                                               
C        FY        YIELDING FORCE                                               
C        DC        CRACKING DISPLACEMENT                                        
C        DY        YIELDING DISPLACEMENT                                        
C        SC        DISPLACEMENT STIFFNESS BEFORE CRACKING                       
C        SY        DISPLACEMENT STIFFNESS BEFORE YIELDING                       
C        SU        DISPLACEMENT STIFFNESS AFTER YIELDING                        
C        B0        STIFFNESS DEGRADATION FACTOR                                 
C        B1        STIFFNESS DEGRADATION FACTOR                                 
C     WRITE(6,*) DATA                                                           
C        LL        HYSTERESIS RULE POINTER AT PRESENT TIME STEP                 
C        SS        STIFFNESS AT PRESENT TIME STEP                               
C        FF        FORCE AT PRESENT TIME STEP                                   
C     DESCRIPTION OF VARIABLES                                                  
C        S1(*)     UNLOADING STIFFNESS FROM A PEAK ON PRIMARY CURVE             
C        S2(*)     UNLOADING STIFFNESS ON INNER HYSTERESIS LOOPS                
C        F0        UNLOADING FORCE LEVEL FROM STEP  6                           
C        F1        UNLOADING FORCE LEVEL FROM STEP  8                           
C        F2        UNLOADING FORCE LEVEL FROM STEP  10                          
C        F3        UNLOADING FORCE LEVEL FROM STEP  12                          
C        D0        UNLOADING DISPLACEMENT FROM STEP  6                          
C        D1        UNLOADING DISPLACEMENT FROM STEP  8                          
C        D2        UNLOADING DISPLACEMENT FROM STEP  10                         
C        D3        UNLOADING DISPLACEMENT FROM STEP  12                         
C        X0        ZERO-CROSSING POINT FROM STEP 4 TO STEP 5                    
C                  ZERO-CROSSING POINT FROM STEP 4 TO STEP 6                    
C        X1        ZERO-CROSSING POINT FROM STEP 7 TO STEP 8                    
C        X2        ZERO-CROSSING POINT FROM STEP 9 TO STEP 10                   
C                  ZERO-CROSSING POINT FROM STEP 13 TO STEP 10                  
C        X3        ZERO-CROSSING POINT FROM STEP 11 TO STEP 12                  
C        FM(*)     UNLOADING FORCE LEVEL ON PRIMARY CURVE                       
C        DM(*)     UNLOADING DISPLACEMENT ON PRIMARY CURVE                      
C                                                                               
C                                                                               
      COMMON/STFF/DC,DY,FC,FY,SC,SY,SU,FM(2),DM(2),S1(2),S2(2),                 
     1F0,F1,F2,F3,D0,D1,D2,D3,X0,X1,X2,X3,DUMM(5)
      COMMON/STFF2/B0,B1                                                        
C                                                                               
      IS=2                                                                      
      IF  (FS.LT.0.0) IS=1                                                      
      SN=FLOAT(IS+IS-3)                                                         
      GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13),LL                                  
C        RULE 1    ELASTIC STAGE UP TO CRACKING                                 
    1 IF  (DC-ABS(DD)) 110,110,100                                              
  100 FF=SC*DD                                                                  
      GO TO 10000                                                               
  110 FM(1)=-FC                                                                 
      FM(2)= FC                                                                 
      DM(1)=-DC                                                                 
      DM(2)= DC                                                                 
      S1(1)= SC                                                                 
      S1(2)= SC                                                                 
  120 IF  (DY-ABS(DD)) 300,300,200                                              
C        RULE 2    LOADING ON THE POST-CRACKING PRIMARY CURVE UP TO             
C                  YIELDING                                                     
    2 IF  ((DD-DS)*SN) 230,230,220                                              
  200 LL=2                                                                      
      SS=SY                                                                     
  210 FF=(FC+(ABS(DD)-DC)*SY)*SN                                                
      GO TO 10000                                                               
  220 IF  (DY-ABS(DD)) 300,300,210                                              
  230 S1(IS)=(ABS(FS)+FC)/(ABS(DS)+DC)                                          
      GO TO 330                                                                 
C        RULE 3    LOADING ON THE POST-YIELDING PRIMARY CURVE                   
    3 IF  ((DD-DS)*SN) 320,320,310                                              
  300 LL=3                                                                      
      SS=SU                                                                     
  310 FF=(FY+(ABS(DD)-DY)*SU)*SN                                                
      GO TO 10000                                                               
  320 S1(IS)=(DY/ABS(DS))**B0*(FC+FY)/(DC+DY)                                   
  330 FM(IS)=FS                                                                 
      DM(IS)=DS                                                                 
      X0=DS-FS/S1(IS)                                                           
      IF  ((DD-X0)*SN) 430,430,400                                              
C        RULE 4    UNLOADING FROM A PEAK (DM,FM) ON THE PRIMARY CURVE           
C   4 IF  ((DM(IS)-DD)*SN) 120,120,420                                          
C 400 LL=4                                                                      
C     SS=S1(IS)                                                                 
C 410 FF=FM(IS)+(DD-DM(IS))*S1(IS)                                              
C     GO TO 10000                                                               
C 420 IF  ((DD-X0)*SN) 430,430,410                                              
C 430 IS=3-IS                                                                   
    4 IF  ((DD-X0)*SN) 430,430,410                                              
  400 LL=4                                                                      
      SS=S1(IS)                                                                 
  410 IF  ((DM(IS)-DD)*SN) 120,120,420                                          
  420 FF=FM(IS)+(DD-DM(IS))*S1(IS)                                              
      GO TO 10000                                                               
  430 IS=3-IS                                                                   
      SN=FLOAT(IS+IS-3)                                                         
      IF  (ABS(DM(IS)).GE.DY) GO TO 740                                         
      X=FM(IS)/(DM(IS)-X0)                                                      
      Y=FY*SN/(DY*SN-X0)                                                        
      IF  (X-Y) 440,440,450                                                     
  440 FM(IS)=FY*SN                                                              
      DM(IS)=DY*SN                                                              
  450 IF  (FC-ABS(FM(IS))) 740,460,460                                          
  460 CONTINUE                                                                  
      D0=X0+FC/SS*SN                                                            
      F0=FC*SN                                                                  
      IF  ((D0-DD)*SN) 740,740,500                                              
C     IF  ((D0-DD)*SN) 530,530,500                                              
C        RULE 5    LOAD REVERSED AT A ZERO-CROSSING POINT (X0,0) WITHOUT        
C                  PREVIOUS CRACKING IN NEW LOADING DIRECTION                   
    5 IF  ((DD-X0)*SN) 540,540,520                                              
  500 LL=5                                                                      
  510 FF=(DD-X0)*SS                                                             
      GO TO 10000                                                               
  520 IF  ((D0-DD)*SN) 740,740,510                                              
C 520 IF  ((D0-DD)*SN) 530,530,510                                              
C 530 FM(IS)=FY*SN                                                              
C     DM(IS)=DY*SN                                                              
C     X0=SN*(DY-FY*(DY*SN-D0)/(FY*SN-F0))                                       
C     GO TO 740                                                                 
  540 IS=3-IS                                                                   
      SN=FLOAT(IS+IS-3)                                                         
      IF  ((DM(IS)-DD)*SN) 120,120,400                                          
C        RULE 6    LOAD REVERSED AT ZERO-CROSSING POINT (X0,0), AND             
C                  LOADING TOWARD A PEAK (DM,FM) ON THE PRIMARY CURVE           
    6 IF  ((DD-DS)*SN) 630,630,620                                              
  600 LL=6                                                                      
      SS=FM(IS)/(DM(IS)-X0)                                                     
  610 FF=(DD-X0)*SS                                                             
      GO TO 10000                                                               
  620 IF  ((DM(IS)-DD)*SN) 120,120,610                                          
  630 F0=FS                                                                     
      D0=DS                                                                     
      S2(IS)=S1(IS)*B1                                                          
      IF  (SS.LT.S2(IS)) SS=S2(IS)                                              
      X1=D0-F0/SS                                                               
  640 IF  ((DD-X1)*SN) 730,730,700                                              
C        RULE 7    UNLOADING FROM A PEAK (D0,F0) TOWARD A ZERO CROSSING         
C                  POINT (X1,0)                                                 
    7 IF  ((D0-DD)*SN) 740,740,720                                              
  700 LL=7                                                                      
      IF  (SS.LT.S2(IS)) SS=S2(IS)                                              
  710 FF=F0+(DD-D0)*SS                                                          
      GO TO 10000                                                               
  720 IF  ((DD-X1)*SN) 730,730,710                                              
  730 IS=3-IS                                                                   
      SN=FLOAT(IS+IS-3)                                                         
      GO TO 940                                                                 
  740 IF  ((DM(IS)-DD)*SN) 120,120,600                                          
C        RULE 8    LOAD REVERSED AT ZERO CROSSING POINT (X1,0), AND             
C                  LOADING TOWARD A PEAK (DM,FM) ON THE PRIMARY CURVE           
    8 IF  ((DD-DS)*SN) 830,830,820                                              
  800 LL=8                                                                      
      SS=FM(IS)/(DM(IS)-X1)                                                     
  810 FF=(DD-X1)*SS                                                             
      GO TO 10000                                                               
  820 IF  ((DM(IS)-DD)*SN) 120,120,810                                          
  830 F1=FS                                                                     
      D1=DS                                                                     
      S2(IS)=S1(IS)*B1                                                          
      IF  (SS.LT.S2(IS)) SS=S2(IS)                                              
      X2=D1-F1/SS                                                               
      IF  ((DD-X2)*SN) 930,930,900                                              
C        RULE 9    UNLOADING FROM A PEAK (D1,F1) TOWARD A ZERO-CROSSING         
C                  POINT (X2,0)                                                 
    9 IF  ((D1-DD)*SN) 940,940,920                                              
  900 LL=9                                                                      
      IF  (SS.LT.S2(IS)) SS=S2(IS)                                              
  910 FF=F1+(DD-D1)*SS                                                          
      GO TO 10000                                                               
  920 IF  ((DD-X2)*SN) 930,930,910                                              
  930 IS=3-IS                                                                   
      SN=FLOAT(IS+IS-3)                                                         
      GO TO 1140                                                                
  940 IF  ((DM(IS)-DD)*SN) 120,120,800                                          
C        RULE 10    LOAD REVERSED AT A ZERO-CROSSING POINT (X2,0), AND          
C                   LOADING TOWARD A PEAK (D0,F0)                               
   10 IF  ((DD-DS)*SN) 1030,1030,1020                                           
 1000 LL=10                                                                     
      SS=F0/(D0-X2)                                                             
 1010 FF=(DD-X2)*SS                                                             
      GO TO 10000                                                               
 1020 IF  ((D0-DD)*SN) 740,740,1010                                             
 1030 F2=FS                                                                     
      D2=DS                                                                     
      IF  (SS.LT.S2(IS)) SS=S2(IS)                                              
      X3=D2-F2/SS                                                               
      IF  ((DD-X3)*SN) 1130,1130,1100                                           
C        RULE 11    UNLOADING FROM A PEAK (D2,F2) TOWARD A ZERO-CROSSING        
C        POINT (X3,0)                                                           
   11 IF  ((D2-DD)*SN) 1140,1140,1120                                           
 1100 LL=11                                                                     
      IF  (SS.LT.S2(IS)) SS=S2(IS)                                              
 1110 FF=F2+(DD-D2)*SS                                                          
      GO TO 10000                                                               
 1120 IF  ((DD-X3)*SN) 1130,1130,1110                                           
 1130 IS=3-IS                                                                   
      SN=FLOAT(IS+IS-3)                                                         
      GO TO 1330                                                                
 1140 IF  ((D0-DD)*SN) 740,740,1000                                             
C        RULE 12    LOAD RESERVED AT A ZERO-CROSSING POINT (X3,0), AND          
C                   LOADING TOWARD A PEAK (D1,F1)                               
   12 IF  ((DD-DS)*SN) 1230,1230,1220                                           
 1200 LL=12                                                                     
      SS=F1/(D1-X3)                                                             
 1210 FF=(DD-X3)*SS                                                             
      GO TO 10000                                                               
 1220 IF  ((D1-DD)*SN) 940,940,1210                                             
 1230 F3=FS                                                                     
      D3=DS                                                                     
      IF  (SS.LT.S2(IS)) SS=S2(IS)                                              
      X2=D3-F3/SS                                                               
      IF  ((DD-X2)*SN) 930,930,1300                                             
C        RULE 13    UNLOADING FROM A PEAK (D3,F3) TOWARD A ZERO-CROSSING        
C                   POINT (X2,0)                                                
   13 IF  ((D3-DD)*SN) 1330,1330,1320                                           
 1300 LL=13                                                                     
      IF  (SS.LT.S2(IS)) SS=S2(IS)                                              
 1310 FF=F3+(DD-D3)*SS                                                          
      GO TO 10000                                                               
 1320 IF  ((DD-X2)*SN) 930,930,1310                                             
 1330 IF  ((D1-DD)*SN) 940,940,1200                                             
10000 RETURN                                                                    
      END                                                                       
      SUBROUTINE CHSTBS(KB,IJB,KT,QB0,QBJ,TB,TD,DFB,ICHG)                       
C                                                                               
C     FUNCTION: HIZUMI KOUKA O KOURYO SHITA BI-LINEAR GATA NO                   
C              FUKUGENRYOKU TOKUSEI NO GOUSEI CHECK O OKONAU PROGRAM.           
C                                                                               
C     PARAMATER: KB(2)------BANE NO KOUBAI                                      
C                IJB--------(1) DANSEI,(2) +GAWA KOUFUKU,(-2) -GAWA KOUFUKU     
C                KT---------SYUNKAN GOUSEI                                      
C                QB0--------Y-JIKU TONO KOUTEN NO ZAHYOU                        
C                QBJ(2)-----KOUFUKU HANTEI NO GENKAI OURYOKU                    
C                TB---------HENI                                                
C                TD---------HENI ZOUBUN                                         
C                ICHG-------(1) NOTOKI GOUSEI HENKA ARI                         
C                                                                               
C     CODED BY: T.INADA                           (1986-04-30)                  
C                                                                               
      IMPLICIT INTEGER(A-Z)                                                     
      REAL KB(2),KT,QB0,QBJ(2),TB,TD,QT,DFB(2)                                  
          IF(QBJ(1).EQ.0.0 .AND. QBJ(2).EQ.0.0) RETURN                          
      QT=KT*TB+QB0                                                              
      IF(IJB.EQ.1) THEN                                                         
          IF(QT.GE.QBJ(1)) THEN                                                 
              QB0=QBJ(1)-KB(2)*TB                                               
              KT=KB(2)                                                          
              IJB=2                                                             
              ICHG=1                                                            
              RETURN                                                            
          ELSEIF(QT.LE.QBJ(2)) THEN                                             
              QB0=QBJ(2)-KB(2)*TB                                               
              KT=KB(2)                                                          
              IJB=-2                                                            
              ICHG=1                                                            
              RETURN                                                            
          ELSE                                                                  
              RETURN                                                            
          ENDIF                                                                 
       ELSEIF(IJB.EQ.2) THEN                                                    
          IF(TD.LT.0.0) THEN                                                    
              QBJ(1)=QT                                                         
              KT=KB(1)                                                          
              QB0=QBJ(1)-KT*TB                                                  
              IJB=1                                                             
              ICHG=1                                                            
              RETURN                                                            
          ELSE                                                                  
              DFB(1)=DFB(1)+TD                                                  
              RETURN                                                            
          ENDIF                                                                 
       ELSEIF(IJB.EQ.-2) THEN                                                   
          IF(TD.GT.0.0) THEN                                                    
              QBJ(2)=QT                                                         
              KT=KB(1)                                                          
              QB0=QBJ(2)-KT*TB                                                  
              IJB=1                                                             
              ICHG=1                                                            
              RETURN                                                            
          ELSE                                                                  
              DFB(2)=DFB(2)+TD                                                  
              RETURN                                                            
          ENDIF                                                                 
      ELSE                                                                      
          STOP '**CHSTBS PARAMATER ERROR-01**'                                  
      ENDIF                                                                     
      END                                                                       
      SUBROUTINE CHSTEP(KB,QB,IJB,QB0,KT,TB,TD,DFB,ICHG)                        
C                                                                               
C     FUNCTION: KANZEN DANSOSEI KEI NO FUKUGENRYOKU TOKUSEI NO                  
C              GOUSEI CHECK O OKONAU PROGRAM.                                   
C                                                                               
C     PARAMATER: KB---------BANE NO DANSEI KOUBAI                               
C     PARAMATER: QB---------KOUFUKU OURYOKU                                     
C                IJB--------(1) DANSEI,(2) +GAWA KOUFUKU,(-2) -GAWA KOUFUKU     
C                QB0--------Y-JIKU TONO KOUTEN NO ZAHYOU                        
C                KT---------SYUNKAN GOUSEI                                      
C                TB---------HENI                                                
C                TD---------HENI ZOUBUN                                         
C                ICHG-------(1) NOTOKI GOUSEI HENKA ARI                         
C                                                                               
C     CODED BY: T.INADA                           (1986-04-30)                  
C                                                                               
      IMPLICIT INTEGER(A-Z)                                                     
      REAL KB,QB,KT,QB0,TB,TD,QT,DFB(2)                                         
      IF(QB.EQ.0.0) RETURN                                                      
      QT=KT*TB+QB0                                                              
      IF(IJB.EQ.1) THEN                                                         
          IF(QT.GE.QB) THEN                                                     
              QB0=QB                                                            
              KT=0.0                                                            
              IJB=2                                                             
              ICHG=1                                                            
              RETURN                                                            
          ELSEIF(QT.LE.-QB) THEN                                                
              QB0=-QB                                                           
              KT=0.0                                                            
              IJB=-2                                                            
              ICHG=1                                                            
              RETURN                                                            
          ELSE                                                                  
              RETURN                                                            
          ENDIF                                                                 
       ELSEIF(IJB.EQ.2) THEN                                                    
          IF(TD.LT.0.0) THEN                                                    
              KT=KB                                                             
              QB0=QB-KT*TB                                                      
              IJB=1                                                             
              ICHG=1                                                            
              RETURN                                                            
          ELSE                                                                  
              DFB(1)=DFB(1)+TD                                                  
              RETURN                                                            
          ENDIF                                                                 
       ELSEIF(IJB.EQ.-2) THEN                                                   
          IF(TD.GT.0.0) THEN                                                    
              KT=KB                                                             
              QB0=-QB-KT*TB                                                     
              IJB=1                                                             
              ICHG=1                                                            
              RETURN                                                            
          ELSE                                                                  
              DFB(2)=DFB(2)+TD                                                  
              RETURN                                                            
          ENDIF                                                                 
      ELSE                                                                      
          STOP '**CHSTEP PARAMATER ERROR-01**'                                  
      ENDIF                                                                     
      END                                                                       
      BLOCK DATA
      COMMON /CHSINT/ IA,IN,JT
      DATA IA/0/,IN/0/,JT/0/
      END
      SUBROUTINE HSTRTN2(K,Q0,D,Q,DD,DQ,RK,TYP,CND,
     \                 MX,IT,MU,NX,ICHG)
      IMPLICIT INTEGER(A-Z) 
      COMMON /HSTWK/ AAA(402000),IP(10)
      COMMON /CHSINT/ IA,IN,JT
      REAL K(NX,MX),Q0(NX,MX),D(MX),Q(NX,MX),
     \     DD(MX),DQ(NX,MX),RK(NX,MX),AAA,MU(NX,MX)
      INTEGER CND(NX,MX),TYP(NX,MX)                                                
      IF(IT.NE.JT) THEN                                                         
          IF(JT.GT.IT) IA=1                                                     
          JT=IT                                                                 
          IN=0                                                                  
      ENDIF                                                                     
      IN=IN+1                                                                   
      IF(IT.EQ.1) THEN                                                          
          IF(IA.EQ.0) THEN                                                      
              IF(IN.EQ.1) THEN                                                  
                  IP(IN)=1                                                      
              ELSE                                                              
                  IP(IN)=IP(IN-1)+25*8*201                                   
              ENDIF                                                             
          ENDIF                                                                 
          CALL HSTINT(K,Q0,TYP,1,1,MX,RK,AAA(IP(IN)),NX)
      ENDIF                                                                     
C      WRITE(6,*) IN,IP(IN)
      CALL HSTSET2(K,Q0,D,Q,DD,DQ,RK,TYP,CND,1,1,
     \            MX,AAA(IP(IN)),MU,NX,ICHG)

      RETURN                                                                    
      END                                                                       
      SUBROUTINE HSTINT(K,Q0,TYP,MX,MY,MZ,RK,AAA,NX)
      IMPLICIT INTEGER (A-Z)                                                    
      REAL K(NX,3,MY,MZ),Q0(NX,2,MY,MZ),RK(NX,MY,MZ),AAA(25,NX,MY,MZ)
      INTEGER TYP(NX,MY,MZ)
      WRITE(6,*) '**HSTINT-01'
      DO 10 IX=1,NX
      DO 10 IY=1,MY                                                             
      DO 10 IZ=1,MZ                                                             
          IF(TYP(IX,IY,IZ).EQ.1) THEN
              CALL INSTBI(K(IX,1,IY,IZ),K(IX,2,IY,IZ),Q0(IX,1,IY,IZ),
     \                    RK(IX,IY,IZ),
     \                    AAA(1,IX,IY,IZ),AAA(2,IX,IY,IZ),
     \                    AAA(3,IX,IY,IZ),AAA(4,IX,IY,IZ))
          ELSEIF(TYP(IX,IY,IZ).EQ.2) THEN
              CALL INSTSL(K(IX,1,IY,IZ),K(IX,2,IY,IZ),Q0(IX,1,IY,IZ),
     \                    RK(IX,IY,IZ),
     \                    AAA(1,IX,IY,IZ),AAA(2,IX,IY,IZ),
     \                    AAA(3,IX,IY,IZ),
     \                    AAA(4,IX,IY,IZ),AAA(5,IX,IY,IZ))
          ELSEIF(TYP(IX,IY,IZ).EQ.3) THEN
              CALL INSTOR(K(IX,1,IY,IZ),K(IX,2,IY,IZ),K(IX,3,IY,IZ),
     \                    Q0(IX,1,IY,IZ),Q0(IX,2,IY,IZ),RK(IX,IY,IZ),
     \                    AAA(1,IX,IY,IZ),AAA(3,IX,IY,IZ),
     \                    AAA(4,IX,IY,IZ),AAA(5,IX,IY,IZ))
          ELSEIF(TYP(IX,IY,IZ).EQ.4) THEN
              CALL INSTDT(K(IX,1,IY,IZ),K(IX,2,IY,IZ),K(IX,3,IY,IZ),
     \                    Q0(IX,1,IY,IZ),Q0(IX,2,IY,IZ),RK(IX,IY,IZ),
     \                    AAA(1,IX,IY,IZ),AAA(2,IX,IY,IZ),
     \                    AAA(3,IX,IY,IZ),
     \                    AAA(4,IX,IY,IZ))
          ELSEIF(TYP(IX,IY,IZ).EQ.5) THEN
              CALL INSTBS(K(IX,1,IY,IZ),Q0(IX,1,IY,IZ),RK(IX,IY,IZ),
     \                    AAA(1,IX,IY,IZ),AAA(2,IX,IY,IZ))
          ELSEIF(TYP(IX,IY,IZ).EQ.6) THEN
              CALL INSTEP(K(IX,1,IY,IZ),RK(IX,IY,IZ),AAA(1,IX,IY,IZ))
          ELSEIF(TYP(IX,IY,IZ).EQ.7) THEN
              GO TO 10
          ELSEIF(TYP(IX,IY,IZ).EQ.0) THEN
              GO TO 10
          ELSE                                                                  
              WRITE(6,*) '**HSTINT ERR**',TYP(IX,IY,IZ)
          ENDIF                                                                 
   10 CONTINUE                                                                  
C      WRITE(6,1010) ((K(1,IX,IY,1),IY=1,MY),IX=1,MX)
C      WRITE(6,1010) ((Q0(1,IX,IY,1),IY=1,MY),IX=1,MX)
C      WRITE(6,1010) ((RK(IX,IY,1),IY=1,MY),IX=1,MX)
C      WRITE(6,1010) ((AAA(1,IX,IY,1),IY=1,MY),IX=1,MX)
C      WRITE(6,1010) (AAA(2,MX,IY,1),IY=1,MY)
C      WRITE(6,1010) ((AAA(3,IX,IY,1),IY=1,MY),IX=1,MX)
 1010 FORMAT(1H ,5E15.7)
      RETURN                                                                    
      END                                                                       
      SUBROUTINE HSTSET2(K,Q0,D,Q,DD,DQ,RK,TYP,CND,
     \                 MX,MY,MZ,AAA,MU,NX,ICHG)
      IMPLICIT INTEGER (A-Z)
      COMMON /FACTIC/ ICCT
      REAL K(NX,3,MY,MZ),Q0(NX,2,MY,MZ),AAA(25,NX,MY,MZ)
      REAL D(MX,MY,MZ),Q(NX,MY,MZ),DD(MX,MY,MZ),
     \     DQ(NX,MY,MZ),RK(NX,MY,MZ),MU(2,NX,MY,MZ),
     \     B0,B1
      INTEGER TYP(NX,MY,MZ),CND(NX,MY,MZ),ICHG
      ICHG=0
      B0=0.4
      B1=0.7                                                                    
C      WRITE(6,1010) ((AAA(2,IX,IY,1),IY=1,MY),IX=1,MX)
C      WRITE(6,1010) (AAA(2,MX,IY,1),IY=1,MY)
C      WRITE(6,1010) ((AAA(3,IX,IY,1),IY=1,MY),IX=1,MX)
 1010 FORMAT(1H ,5E15.7)
      DO 10 IX=1,NX
      DO 10 IY=1,MY                                                             
      DO 10 IZ=1,MZ                                                             
          IF(TYP(IX,IY,IZ).EQ.1) THEN
              CALL DHSTBI(K(IX,1,IY,IZ),K(IX,2,IY,IZ),D(1,IY,IZ),
     \                    DD(1,IY,IZ),
     \                    RK(IX,IY,IZ),AAA(1,IX,IY,IZ),
     \                    AAA(2,IX,IY,IZ),
     \                    AAA(3,IX,IY,IZ),AAA(4,IX,IY,IZ),
     \                    CND(IX,IY,IZ),ICHG)
          ELSEIF(TYP(IX,IY,IZ).EQ.2) THEN
              CALL DHSTSL(K(IX,1,IY,IZ),K(IX,2,IY,IZ),
     \                    D(1,IY,IZ),DD(1,IY,IZ),
     \                    RK(IX,IY,IZ),AAA(1,IX,IY,IZ),
     \                    AAA(2,IX,IY,IZ),
     \                    AAA(3,IX,IY,IZ),AAA(4,IX,IY,IZ),
     \                    AAA(5,IX,IY,IZ),
     \                    CND(IX,IY,IZ),ICHG)
          ELSEIF(TYP(IX,IY,IZ).EQ.3) THEN
              CALL DHSTOR(K(IX,2,IY,IZ),K(IX,3,IY,IZ),
     \                    D(1,IY,IZ),DD(1,IY,IZ),
     \                    RK(IX,IY,IZ),AAA(1,IX,IY,IZ),
     \                    AAA(3,IX,IY,IZ),
     \                    AAA(4,IX,IY,IZ),AAA(5,IX,IY,IZ),
     \                    CND(IX,IY,IZ),ICHG)
          ELSEIF(TYP(IX,IY,IZ).EQ.4) THEN
              CALL DHSTDT(K(IX,1,IY,IZ),K(IX,2,IY,IZ),K(IX,3,IY,IZ),
     \                    Q0(IX,1,IY,IZ),Q0(IX,2,IY,IZ),
     \                    D(1,IY,IZ),DD(1,IY,IZ),RK(IX,IY,IZ),B0,B1,
     \                    AAA(1,IX,IY,IZ),AAA(2,IX,IY,IZ),
     \                    AAA(3,IX,IY,IZ),
     \                    AAA(4,IX,IY,IZ),CND(IX,IY,IZ),ICHG)
          ELSEIF(TYP(IX,IY,IZ).EQ.5) THEN
              CALL DHSTBS(K(IX,1,IY,IZ),K(IX,2,IY,IZ),
     \                    D(1,IY,IZ),DD(1,IY,IZ),Q(IX,IY,IZ),
     \                    RK(IX,IY,IZ),AAA(1,IX,IY,IZ),
     \                    AAA(2,IX,IY,IZ),
     \                    CND(IX,IY,IZ),ICHG,MU(1,IX,IY,IZ),
     \                    IX,IY,IZ)
          ELSEIF(TYP(IX,IY,IZ).EQ.6) THEN
              CALL DHSTEP(K(IX,1,IY,IZ),Q0(IX,1,IY,IZ),
     \                    D(1,IY,IZ),DD(1,IY,IZ),
     \                    RK(IX,IY,IZ),AAA(1,IX,IY,IZ),
     \                    CND(IX,IY,IZ),ICHG)
          ELSEIF(TYP(IX,IY,IZ).EQ.7) THEN
              GO TO 10
          ELSEIF(TYP(IX,IY,IZ).EQ.0) THEN
              GO TO 10
          ELSE
              WRITE(6,*) '**HSTSET ERR**',TYP(IX,IY,IZ)
          ENDIF                                                                 
          IF(ICHG.NE.0) WRITE(6,*) IX,IY,IZ
   10 CONTINUE                                                                  
      IF(ICHG.NE.0) THEN
          WRITE(6,*) '*ICHG CHECK*'
      ENDIF
C      WRITE(6,*) 'SET END'
C      WRITE(6,1010) (AAA(2,MX,IY,1),IY=1,MY)
      RETURN                                                                    
      END                                                                       
      SUBROUTINE INSTBI(KE,KP,Q0,RK,QCUT,DELY,RDEL,QQ)                          
      IMPLICIT INTEGER(A-Z)                                                     
      REAL KE,KP,Q0,QCUT,DELY,RDEL,QQ,RK                                        
C                                                                               
C     PARAMATER: (IN)  KE      DANSEI BANE GOUSEI                               
C                      KP      SOSEI BANE GOUSEI                                
C                      Q0      KOUFUKU OURYOKU                                  
C                (OUT) RK      SYUNKAN GOUSEI                                   
C                      QCUT    SOSEI GOUSEI TO Q JIKU  TONO KOUTEN              
C                      DELY    KOUFUKU HENI                                     
C                      RDEL    DANSEI CHOKUSEN NO CHUUKAN HENI                  
C                              MATAHA SOSEI NI HAITTA TOKI NO HENI              
C                      QQ      SYUNKAN BANE KOUBAI TO Q JIKU NO KOUTEN          
C                                                                               
      RK=KE                                                                     
      IF(KE.EQ.0.0) THEN
          DELY=0.0
      ELSE
          DELY=Q0/KE
      ENDIF
      QCUT=Q0-KP*DELY                                                           
      RDEL=0                                                                    
      QQ=0                                                                      
C      WRITE(6,1010) KE,KP,Q0,RK,QCUT,DELY,RDEL,QQ
 1010 FORMAT(1H ,5E15.7)
      RETURN                                                                    
      END                                                                       
      SUBROUTINE INSTSL(KE,KP,Q0,RK,QCUT,DELY,DELP,DELN,QQ)                     
      IMPLICIT INTEGER(A-Z)                                                     
      REAL KE,KP,Q0,QCUT,DELY,DELP,DELN,QQ,RK                                   
C                                                                               
C     PARAMATER: (IN)  KE      DANSEI BANE GOUSEI                               
C                      KP      SOSEI BANE GOUSEI                                
C                      Q0      KOUFUKU OURYOKU                                  
C                (OUT) RK      SYUNKAN GOUSEI                                   
C                      QCUT    SOSEI GOUSEI TO Q JIKU  TONO KOUTEN              
C                      DELY    KOUFUKU HENI                                     
C                      DELP    SAIDAI HENI(+GAWA , SYOKICHI +DELY)              
C                      DELN    SAIDAI HENI(-GAWA , SYOKICHI -DELY)              
C                      QQ      SYUNKAN BANE KOUBAI TO Q JIKU NO KOUTEN          
C                                                                               
      RK=KE                                                                     
      DELY=Q0/KE                                                                
      QCUT=Q0-KP*DELY                                                           
      DELP=DELY                                                                 
      DELN=-DELY                                                                
      QQ=0                                                                      
      RETURN                                                                    
      END                                                                       
      SUBROUTINE INSTOR(KE,KY,KP,QY,QP,RK,QCUT,DELY,DELP,QQ)                    
      IMPLICIT INTEGER(A-Z)                                                     
      REAL KE,KY,QY,QP,QCUT(2),DELY1,DELY,DELP,QQ,RK,KP                            
C                                                                               
C     PARAMATER: (IN)  KE      DANSEI BANE GOUSEI                               
C                      KY      SOSEI BANE GOUSEI(DAI 1 KOUBAI)                  
C                      KP      SOSEI BANE GOUSEI(DAI 2 KOUBAI)                  
C                      QY      KOUFUKU OURYOKU                                  
C                      QP      SYUUKYOKU OURYOKU                                
C                (OUT) RK      SYUNKAN GOUSEI                                   
C                      QCUT    SOSEI GOUSEI TO Q JIKU  TONO KOUTEN              
C                      DELY    KOUFUKU HENI                                     
C                      DELP    SAIDAI HENI NO ZETTAICHI(SYOKICHI DELY)          
C                      QQ      SYUNKAN BANE KOUBAI TO Q JIKU NO KOUTEN          
C                                                                               
      RK=KE                                                                     
      DELY1=QY/KE                                                               
      DELY=DELY1+(QP-QY)/KY                                                     
      QCUT(1)=QY-KY*DELY1                                                       
      QCUT(2)=QP-KP*DELY                                                        
      DELP=DELY1                                                                
      QQ=0                                                                      
      RETURN                                                                    
      END                                                                       
      SUBROUTINE INSTDT(KE,KY,KP,QY,QP,RK,DELY,DELP,QQ,RCO)                     
      IMPLICIT INTEGER(A-Z)                                                     
      REAL KE,KY,KP,QY,QP,DELY,DELP,QQ,RCO(21),RK                               
C                                                                               
C     PARAMATER: (IN)  KE      DANSEI BANE GOUSEI                               
C                      KY      SOSEI BANE GOUSEI(DAI 2 KOUBAI)                  
C                      KP      SOSEI BANE GOUSEI(DAI 3 KOUBAI)                  
C                      QY      KOUFUKU OURYOKU(DAI 1 ORETEN)                    
C                      QP      KOUFUKU OURYOKU(DAI 2 ORETEN)                    
C                (OUT) RK      SYUNKAN GOUSEI                                   
C                (OUT) DELY    KOUFUKU HENI(DAI 1 ORETEN)                       
C                      DELP    KOUFUKU HENI(DAI 2 ORETEN)                       
C                      QQ      SYUNKAN BANE KOUBAI TO Q JIKU NO KOUTEN          
C                      RCO     SCRATCH                                          
C                                                                               
      RK=KE                                                                     
      DELY=QY/KE                                                                
      DELP=DELY+(QP-QY)/KY                                                      
      QQ=0                                                                      
      CALL CLEAR(RCO,21,2)                                                      
      RETURN                                                                    
      END                                                                       
      SUBROUTINE INSTBS(KE,QP,RK,QB0,QBJ)                                       
      IMPLICIT INTEGER(A-Z)                                                     
      REAL QP,QB0,QBJ(2),RK,KE                                                  
C                                                                               
C     PARAMATER: (IN)  KE      DANSEI GOUSEI                                    
C                      QP      KOUFUKU OURYOKU                                  
C                (OUT) RK      SYUNKAN GOUSEI                                   
C                      QB0     SYUNKAN BANE KOUBAI TO Q JIKU NO KOUTEN          
C                      QBJ     KOUFUKU HANTEI GENKAI OURYOKU                    
C                                                                               
      RK=KE                                                                     
      QB0=0                                                                     
      QBJ(1)=QP                                                                 
      QBJ(2)=-QP                                                                
      RETURN                                                                    
      END                                                                       
      SUBROUTINE INSTEP(KE,RK,QB0)                                              
      IMPLICIT INTEGER(A-Z)                                                     
      REAL QB0,KE,RK                                                            
C                                                                               
C     PARAMATER: (IN)  KE      DANSEI GOUSEI                                    
C                (OUT) RK      SYUNKAN GOUSEI                                   
C                      QB0     SYUNKAN BANE KOUBAI TO Q JIKU NO KOUTEN          
C                                                                               
      RK=KE                                                                     
      QB0=0                                                                     
      RETURN                                                                    
      END                                                                       
      SUBROUTINE DHSTBI(ESPR,PSPR,DLA,DD,RK,QCUT,DELY,RDEL,QQ,IPLA,ICHG)        
C                                                                               
C     FUNCTION: BI-LINEAR GATA SYUNKAN BANE JOUSUU WO SHIRU                     
C                                                                               
C     PARAMATER: (IN)     ESPR   DANSEI GOUSEI                                  
C                         PSPR   SOSEI GOUSEI                                   
C                         DLA    T=T0+DT NI OKERU HENI                          
C                         DD     HENI ZOUBUN                                    
C                (INOUT)  RK     SYUNKAN GOUSEI                                 
C                (IN)     QCUT   SOSEI GOUSEI TO Q JIKU TONO KOUTEN     Î      
C                         DELY   KOUFUKU HENI                                   
C                (INOUT)  RDEL   DANSEI CHOKUSEN NO CYUUKAN NO HENI             
C                                MATAHA SOSEI NI HAITTA TOKI NO ATAI            
C                         QQ     SYUNKAN BANE KOUBAI TO Q JIKU NO KOUTEN        
C                         IPLA   BANE NO JOUTAI DANSEI(0),SOSEI(1 OR -1)        
C                (OUT)    ICHG   BANE NO HENKOU NO ARI NASHI                    
C                                                                               
C     CODED BY: S.YAMAZAKI                        (1981-12-18)                  
C     REVISED BY: T.INADA                         (1989-07-27)                  
C                                                                               
      IMPLICIT INTEGER(A-Z)
      REAL ESPR,PSPR,DLA,DD,QCUT,DELY,RDEL,QQ,DL,RK,QB
C                                                                               
C                                      ** SYOKI SETTEI **                       
C                                                                               
      IF(ESPR.EQ.0.0) RETURN
C      WRITE(6,*) '**DHSTBI-1'
C      STOP
C      WRITE(6,1010) ESPR,PSPR,DLA,DD,RK,QCUT,DELY,RDEL,QQ
C 1010 FORMAT(1H ,5E15.7)
C      WRITE(6,1020) IPLA
C 1020 FORMAT(1H ,I10)
      DL=DLA-DD                                                                 
      QB=QQ + RK*DL                                                             
C                                                                               
C                                       ** MAE NO STEP GA DANSEI **             
C                                                                               
      IF(IPLA.NE.0) GO TO 30
      IF(DLA.LT.RDEL-DELY) GO TO 10                                             
      IF(DLA.GT.RDEL+DELY) GO TO 20
C      WRITE(6,*) '**DHSTBI-0',DLA,RDEL-DELY,RDEL+DELY
      GO TO 40                                                                  
C                                                                               
C                                       ** - GAWA DE SOSEI NI HAIRU **          
C                                                                               
   10 ICHG=1
C      WRITE(6,*) '**DHSTBI-2'
C      STOP
      IPLA=-1
      RDEL=RDEL-DELY
      QQ=-QCUT
      RK=PSPR
      GO TO 30                                                                  
C                                                                               
C                                       ** + GAWA DE SOSEI NI HAIRU **          
C                                                                               
   20 ICHG=1
C      WRITE(6,*) '**DHSTBI-3'
C      STOP
      IPLA=1
      RDEL=RDEL+DELY
      QQ=QCUT                                                                   
      RK=PSPR
      GO TO 30
C                                                                               
C                                       ** MAE NO STEP GA SOSEI **              
C                                                                               
   30 IF( IPLA*DD .GT. 0.0 )  GO TO 40                                          
      ICHG=1
C      WRITE(6,*) '**DHSTBI-4'
C      STOP
      IPLA=0                                                                    
      QQ=(PSPR-ESPR)*DLA                                                        
      RK=ESPR                                                                   
      IF(DD.LT.0.) THEN                                                         
                    RDEL=DLA-DELY                                               
                    QQ  =QQ+QCUT                                                
      ENDIF                                                                     
      IF(DD.GT.0.) THEN                                                         
                    RDEL=DLA+DELY                                               
                    QQ  =QQ-QCUT                                                
      ENDIF                                                                     
   40 RETURN                                                                    
      END
      SUBROUTINE DHSTSL( ESPR,PSPR,DLA,DD,RK,                                   
     \                   QCUT,DELY,DELP,DELN,QQ,IPLA,ICHG)                      
C                                                                               
C     FUNCTION: SLIP GATA NO SYUNKAN BANE JOUSUU WO SHIRU                       
C                                                                               
C     PARAMATER: (IN)     ESPR   DANSEI GOUSEI                                  
C                         PSPR   SOSEI GOUSEI                                   
C                         DLA    T=T0+DT NI OKERU HENIO                         
C                         DD     HENI ZOUBUN                                    
C                (INOUT)  RK     SYUNKAN GOUSEI                                 
C                (IN)     QCUT   SOSEI GOUSEI TO Q JIKU TONO KOUTEN     Î      
C                         DELY   KOUFUKU HENI                                   
C                (INOUT)  DELP   SAIDAI HENI(+GAWA,SYOKICHI +DELY)              
C                         DELN   SAIDAI HENI(-GAWA,SYOKICHI -DELY)              
C                         QQ     SYUNKAN BANE KOUBAI TO Q JIKU NO KOUTEN        
C                         IPLA   BANE NO JOUTAI(DANSEI(0),SOSEI(1 OR -1))       
C                                               SLIP(2))                        
C                (OUT)    ICHG   BANE NO HENKOU ARI(1) NASHI(0)                 
C                                                                               
C     CODED BY: S.YAMAZAKI                        (1981-12-21)                  
C     REVISED BY: T.INADA(1989-07-27)                                           
C                                                                               
      IMPLICIT INTEGER(A-Z)                                                     
      REAL ESPR,PSPR,DLA,DD,QCUT,DELY,DELP,DELN,QQ,DL,QB,RK,DLN1,DLP1           
C                                                                               
C                                      ** SYOKI SETTEI **                       
C                                                                               
      DL=DLA-DD                                                                 
      QB=QQ + RK*DL                                                             
C                                                                               
C                                       ** BUNRUI **                            
C                                                                               
      IF(IPLA.EQ.0)  GO TO 10                                                   
      IF(IABS(IPLA).EQ.1)  GO TO 50                                             
      IF(IPLA.EQ.2) GO TO 60                                                    
C                                                                               
C                                       ** MAE NO STEP GA DANSEI **             
C                                                                               
   10 IF(DLA.LT.DELN)                             GO TO 20                      
      IF(DLA.GT.DELP)                             GO TO 30                      
      DLP1=DELP-(QCUT+PSPR*DELP)/ESPR                                           
      DLN1=DELN-(-QCUT+PSPR*DELN)/ESPR                                          
      IF(DLA.GT.DLN1 .AND. DLA.LT.DLP1) GO TO 40                                
      GO TO 70                                                                  
C                                                                               
C                                       ** - GAWA DE SOSEI NI HAIRU **          
C                                                                               
   20 ICHG=1                                                                    
      IPLA=-1                                                                   
      DELN=DLA                                                                  
      QQ=-QCUT                                                                  
      RK=PSPR                                                                   
      GO TO 70                                                                  
C                                                                               
C                                       ** + GAWA DE SOSEI NI HAIRU **          
C                                                                               
   30 ICHG=1                                                                    
      IPLA=1                                                                    
      DELP=DLA                                                                  
      QQ=QCUT                                                                   
      RK=PSPR                                                                   
      GO TO 70                                                                  
C                                                                               
C                                       ** SLIP NI HAIRU **                     
C                                                                               
   40 ICHG=1                                                                    
      IPLA=2                                                                    
      QQ=0.                                                                     
      RK=0.                                                                     
      GO TO 70                                                                  
C                                                                               
C                                       ** MAE NO STEP GA SOSEI **              
C                                                                               
   50 IF(IPLA*DD .GT. 0. )  GO TO 70                                            
   55 ICHG=1                                                                    
      IPLA=0                                                                    
      QQ=(PSPR-ESPR)*DLA                                                        
      RK=ESPR                                                                   
      IF(DD.LT.0.) THEN                                                         
                    QQ=QQ+QCUT                                                  
                    DELP=DLA                                                    
      ENDIF                                                                     
      IF(DD.GT.0.) THEN                                                         
                    QQ=QQ-QCUT                                                  
                    DELN=DLA                                                    
      ENDIF                                                                     
      GO TO 70                                                                  
C                                                                               
C                                       ** MAE NO STEP GA SLIP**                
C                                                                               
   60 DLP1=DELP-( QCUT+PSPR*DELP)/ESPR                                          
      DLN1=DELN-(-QCUT+PSPR*DELN)/ESPR                                          
      IF(DLA.GT. DLN1 .AND. DLA.LT.DLP1) GO TO 70                               
C                                                                               
C                                       **     ELASTIC                          
C                                                                               
      ICHG=1                                                                    
      IPLA=0                                                                    
      QQ=-DLA*ESPR                                                              
      RK=ESPR                                                                   
   70 RETURN                                                                    
      END                                                                       
      SUBROUTINE DHSTOR( PSP1,PSP2,DLA,DD,RK,                                   
     *                   QCUT,DELY,DELP,QQ,IPLA,ICHG)                           
C                                                                               
C     FUNCTION: GENTEN SHIKOU GATA SYUNKAN BANE JOUSUU WO SHIRU                 
C                                                                               
C     PARAMATER: (IN)     PSP1  SOSEI DAI 1 KOUBAI                              
C                         PSP2  SOSEI DAI 2 KOUBAI                              
C                         DLA   T=T0+DT NI OKERU HENI                           
C                         DD    HENI ZOUBUN                                     
C                (INOUT)  RK    SYUNKAN GOUSEI                                  
C                (IN)     QCUT  SOSEI GOUSEI TO Q JIKU TONO KOUTEN      Î      
C                         DELY  KOUFUKU HENI                                    
C                (INOUT)  DELP  SAIDAI HENI NO ZETTAI CHI(SYOKICHI:DELY)        
C                         QQ    SYUNKAN BANE KOUBAI TO Q JIKU NO KOUTEN         
C                         IPLA  BANE NO JOUTAI(DANSEI:0 , SOSEI(1 OR -1)        
C                (OUT)    ICHG  BANE NO HENKOU NASHI(0) ARI(1)                  
C                                                                               
C     CODED BY: S.YAMAZAKI                        (1981-12-21)                  
C     REVISED BY: T.INADA                         (1989-07-27)                  
C                                                                               
      IMPLICIT INTEGER (A-Z)                                                    
      REAL PSP1,PSP2,DLA,DD,RK,QCUT(2),DELY,DELP,QQ,DL,QB                       
      REAL QCU1,QCU2                                                            
      QCU1=QCUT(1)                                                              
      QCU2=QCUT(2)                                                              
      DL=DLA-DD                                                                 
      QB=QQ + RK*DL                                                             
C                                                                               
C                                       ** ώ  Î̎  ގݎ                  
C                                                                               
      IF(IPLA.NE.0) GO TO 10                                                    
      IF( ABS(DLA).LT.ABS(DELP) )  GO TO 20                                     
C                                                                               
C                                       **      ʎ                         
C                                                                               
      ICHG=1                                                                    
      IF(DLA.GT.0) IPLA=1                                                       
      IF(DLA.LT.0) IPLA=-1                                                      
      DELP=ABS(DLA)                                                             
      QQ=SIGN(QCU1,DLA)                                                         
      RK=PSP1                                                                   
      IF( ABS(DLA).GT.DELY )  THEN                                              
                              QQ=SIGN(QCU2,DLA)                                 
                              RK=PSP2                                           
      ENDIF                                                                     
C                                                                               
C                                       ** ώ  Î̎                      
C                                                                               
   10 DELP=ABS(DLA)                                                             
      IF( IPLA*DD .GT. 0.0 )  GO TO 20                                          
      ICHG=1                                                                    
      IPLA=0                                                                    
      QA=QQ + RK*DLA                                                            
      RK=ABS(QA/DLA)                                                            
      QQ=0.                                                                     
C                                                                               
C                                       ** Ȏَ ގ̎ގ                         
C                                                                               
   20 RETURN                                                                    
      END                                                                       
      SUBROUTINE DHSTDT(ESPR,PSP1,PSP2,QY,QP,DLA,DD,RK,B0,B1,                   
     *                  DELY,DELP,QQ,RC0,ICO,ICHG )                             
C                                                                               
C     FUNCTION: D-TRI (TAKEDA MODEL) BANE NO JOUTAI WO SHIRU                    
C                                                                               
C     PARAMATER: (IN)    ESPR   DANSEI GOUSEI                                   
C                        PSP1   SOSEI GOUSEI DAI 1 KOUBAI                       
C                        PSP2   SOSEI GOUSEI DAI 2 KOUBAI                       
C                        QY     KOUFUKU SENDANRYOKU                             
C                        QP     SYUUKYOKU SENDANRYOKU                           
C                        DLA    T=T0+DT NI OKERU HENI                           
C                        DD     HENI ZOUBUN                                     
C                        RK     SYUNKAN GOUSEI                                  
C                        B0,B1  GOUSEI TEIKA KEISUU                             
C                        DELY   KOUFUKU HENI DAI 1 ORETEN                       
C                        DELP   KOUFUKU HENI DAI 2 ORETEN                       
C                (INOUT) QQ     SYUNKAN BANE KOUBAI TO Q JIKU NO KOUTEN         
C                        RCO    SCRATCH                                         
C                        ICO    FUKUGENRYOKU NO JOUTAI                          
C                (OUT)   ICHG   BANE NO HENKOU ARI(1) NASHI(0)                  
C                                                                               
C     ROUTINE USED: HYST10                                                      
C                                                                               
C     CODED BY: S.YAMAZAKI                        (1982- 1- 9)                  
C     REVISED BY: T.INADA                         (1989-07-27)                  
C                                                                               
      COMMON /STFF/ DCDY(2),FCFY(2),SCSY(3),FMDM(25)                            
     *       /STFF2/ B0B1(2)                                                    
      REAL ESPR,PSP1,PSP2,QY,QP,DLA,DD,RK,B0,B1,DELY,DELP,QQ,RCO(20)            
      REAL DCDY,FCFY,SCSY,FMDM,B0B1,RK1,FS,DL                                   
C                                                                               
C                                       ** COMMON /STFF2/                   
C                                                                               
      B0B1(1)=B0                                                                
      B0B1(2)=B1                                                                
C                                                                               
C                                       ** COMMON /STFF/                    
C                                                                               
      DCDY(1)=DELY                                                              
      DCDY(2)=DELP                                                              
      FCFY(1)=QY                                                                
      FCFY(2)=QP                                                                
      SCSY(1)=ESPR                                                              
      SCSY(2)=PSP1                                                              
      SCSY(3)=PSP2                                                              
      DO 30 I=1,20                                                              
         FMDM(I)=RCO(I)                                                         
   30 CONTINUE                                                                  
C                                                                               
C                                       ** HYST10  ˎ                    
C                                                                               
      DL=DLA-DD                                                                 
      RK1=RK                                                                    
      FS=QQ+RK*DL                                                               
      CALL HYST10(ICO,RK,DLA,DL, FF,FS)                                         
C                                                                               
C                                       **  ˎ                      
C                                                                               
      DO 40 I=1,20                                                              
         RCO(I)=FMDM(I)                                                         
   40 CONTINUE                                                                  
      QQ=FF-RK*DLA                                                              
      IF(RK.NE.RK1) ICHG=1                                                      
      RETURN                                                                    
      END                                                                       
      SUBROUTINE DHSTBS(KE,KP,TB,TD,TQ,KT,QB0,QBJ,IJB,ICHG,MU,IX,IY,IZ)
C                                                                               
C     FUNCTION: HIZUMI KOUKA O KOURYO SHITA BI-LINEAR GATA NO                   
C              FUKUGENRYOKU TOKUSEI NO GOUSEI CHECK O OKONAU PROGRAM.           
C                                                                               
C     PARAMATER: KE      DANSEI BANE KOUBAI                                     
C                KP      SOSEI BANE KOUBAI                                      
C                TB      HENI                                                   
C                TD      HENI ZOUBUN                                            
C                KT      SYUNKAN GOUSEI                                         
C                QB0     Y-JIKU TONO KOUTEN NO ZAHYOU                           
C                QBJ(2)  KOUFUKU HANTEI NO GENKAI OURYOKU                       
C                IJB     KOUFUKU HANTEI                                         
C                ICHG    (1) NOTOKI GOUSEI HENKA ARI                            
C                                                                               
C     CODED BY: T.INADA                           (1986-04-30)                  
C                                                                               
      IMPLICIT INTEGER(A-Z)                                                     
      REAL KE,KP,KT,QB0,QBJ(2),TB,TD,QT,TQ,MU(2)
          IF(QBJ(1).EQ.0.0 .AND. QBJ(2).EQ.0.0) RETURN                          
          IF(ABS(KE).GT.99999.0) RETURN
          IF(QBJ(1).GT.99999.0) RETURN
          IF(KE.EQ.0.0) RETURN
C      QT=KT*TB+QB0
      QT=TQ
      IF(IJB.EQ.0) THEN                                                         
          IF(QT.GE.QBJ(1)) THEN                                                 
              QB0=QBJ(1)-KP*TB                                                  
              KT=KP                                                             
              IJB=2                                                             
              ICHG=1
              MU(1)=MU(1)+TD
C              WRITE(6,*) IX,IY,IZ,IJB
C              WRITE(6,*) KE,KP,KT,QB0,QBJ(1),QBJ(2),TB,TD,QT
C              WRITE(7,*) IX,IY,IZ,IJB
C              WRITE(7,*) KE,KP,KT,QB0,QBJ(1),QBJ(2),TB,TD,QT
C              STOP
              RETURN                                                            
          ELSEIF(QT.LE.QBJ(2)) THEN                                             
              QB0=QBJ(2)-KP*TB                                                  
              KT=KP                                                             
              IJB=-2                                                            
              ICHG=1
              MU(2)=MU(2)+TD
C              WRITE(6,*) IX,IY,IZ,IJB
C              WRITE(6,*) KE,KP,KT,QB0,QBJ(1),QBJ(2),TB,TD,QT
C              WRITE(7,*) IX,IY,IZ,IJB
C              WRITE(7,*) KE,KP,KT,QB0,QBJ(1),QBJ(2),TB,TD,QT
C              STOP
              RETURN                                                            
          ELSE                                                                  
              RETURN                                                            
          ENDIF                                                                 
       ELSEIF(IJB.EQ.2) THEN                                                    
          IF(TD.LT.0.0) THEN                                                    
              QBJ(1)=QT
              KT=KE                                                             
              QB0=QBJ(1)-KT*TB                                                  
              IJB=0                                                             
              ICHG=1                                                            
C              WRITE(6,*) IX,IY,IZ,IJB
C              WRITE(6,*) KE,KP,KT,QB0,QBJ(1),QBJ(2),TB,TD,QT
C              WRITE(7,*) IX,IY,IZ,IJB
C              WRITE(7,*) KE,KP,KT,QB0,QBJ(1),QBJ(2),TB,TD,QT
              RETURN                                                            
          ELSE                                                                  
              MU(1)=MU(1)+TD
              RETURN                                                            
          ENDIF                                                                 
       ELSEIF(IJB.EQ.-2) THEN                                                   
          IF(TD.GT.0.0) THEN                                                    
              QBJ(2)=QT
              KT=KE                                                             
              QB0=QBJ(2)-KT*TB                                                  
              IJB=0                                                             
              ICHG=1                                                            
C              WRITE(6,*) IX,IY,IZ,IJB
C              WRITE(6,*) KE,KP,KT,QB0,QBJ(1),QBJ(2),TB,TD,QT
C              WRITE(7,*) IX,IY,IZ,IJB
C              WRITE(7,*) KE,KP,KT,QB0,QBJ(1),QBJ(2),TB,TD,QT
              RETURN                                                            
          ELSE                                                                  
              MU(2)=MU(2)+TD
              RETURN                                                            
          ENDIF                                                                 
      ELSE                                                                      
          STOP '**DHSTBS PARAMATER ERROR-01**'                                  
      ENDIF                                                                     
      END                                                                       
      SUBROUTINE DHSTEP(KB,QB,TB,TD,KT,QB0,IJB,ICHG)                            
C                                                                               
C     FUNCTION: KANZEN DANSOSEI KEI NO FUKUGENRYOKU TOKUSEI NO                  
C              GOUSEI CHECK O OKONAU PROGRAM.                                   
C                                                                               
C     PARAMATER: KB      DANSEI BANE KOUBAI                                     
C                QB      KOUFUKU OURYOKU                                        
C                TB      HENI                                                   
C                TD      HENI ZOUBUN                                            
C                KT      SYUNKAN GOUSEI                                         
C                QB0     Y-JIKU TONO KOUTEN NO ZAHYOU                           
C                IJB     (1) DANSEI,(2) +GAWA KOUFUKU,(-2) -GAWA KOUF   UKU     
C                ICHG    (1) NOTOKI GOUSEI HENKA ARI                            
C                                                                               
C     CODED BY: T.INADA                           (1986-04-30)                  
C                                                                               
      IMPLICIT INTEGER(A-Z)                                                     
      REAL KB,QB,KT,QB0,TB,TD,QT                                                
      IF(QB.EQ.0.0) RETURN
      IF(KB.EQ.0.0) RETURN
      IF(IJB.EQ.0) IJB=1                                                      
      QT=KT*TB+QB0                                                              
      IF(IJB.EQ.1) THEN                                                         
          IF(QT.GE.QB) THEN                                                     
              QB0=QB                                                            
              KT=0.0                                                            
              IJB=2                                                             
              ICHG=1                                                            
              RETURN                                                            
          ELSEIF(QT.LE.-QB) THEN                                                
              QB0=-QB                                                           
              KT=0.0                                                            
              IJB=-2                                                            
              ICHG=1                                                            
              RETURN                                                            
          ELSE                                                                  
              RETURN                                                            
          ENDIF                                                                 
       ELSEIF(IJB.EQ.2) THEN                                                    
          IF(TD.LT.0.0) THEN                                                    
              KT=KB                                                             
              QB0=QB-KT*TB                                                      
              IJB=1                                                             
              ICHG=1                                                            
              RETURN                                                            
          ELSE                                                                  
              RETURN                                                            
          ENDIF                                                                 
       ELSEIF(IJB.EQ.-2) THEN                                                   
          IF(TD.GT.0.0) THEN                                                    
              KT=KB                                                             
              QB0=-QB-KT*TB                                                     
              IJB=1                                                             
              ICHG=1                                                            
              RETURN                                                            
          ELSE                                                                  
              RETURN                                                            
          ENDIF                                                                 
      ELSE                                                                      
          STOP '**DHSTEP PARAMATER ERROR-01**'                                  
      ENDIF                                                                     
      END                                                                 