      SUBROUTINE QCWTST(QCT,QWT,ST,MX,MZ,NX,NZ,MMW,
     \                  CQBT,TNWIJ,QMS,ISTEP,BAIR)
      IMPLICIT INTEGER(A-Z)
      REAL QCT(25000,NZ),QWT(25000,NZ),CQBT(MX,NZ),QMS(MMW)
      REAL BAIR
      INTEGER TNWIJ(3,2,MX,MZ)
C
      CALL QCWTSTS1(QCT,CQBT,MX,NZ,ISTEP,BAIR)
      CALL QCWTSTS2(QWT,QMS,TNWIJ,MMW,MX,MZ,NZ,ISTEP,BAIR)
      RETURN
      END
      SUBROUTINE QCWTSTS1(QCT,CQBT,MX,NZ,ISTEP,BAIR)
      IMPLICIT INTEGER(A-Z)
      REAL QCT(25000,NZ),CQBT(MX,NZ),BAIR
C
      DO 20 IZ=1,NZ
      DO 10 IX=1,MX
          IF(IX.EQ.1) QCT(ISTEP,IZ)=0.0
          QCT(ISTEP,IZ)=QCT(ISTEP,IZ)+CQBT(IX,IZ)*BAIR
   10 CONTINUE
      IF(ISTEP.NE.1) THEN
            QCT(ISTEP,IZ)=QCT(ISTEP-1,IZ)+QCT(ISTEP,IZ)
      ENDIF
   20 CONTINUE
      RETURN
      END
      SUBROUTINE QCWTSTS2(QWT,QMS,TNWIJ,MMW,MX,MZ,NZ,ISTEP,BAIR)
      IMPLICIT INTEGER(A-Z)
      REAL QWT(25000,NZ),QMS(MMW),BAIR
      INTEGER TNWIJ(3,2,MX,MZ),ICHW(1000)
C      IF(ISTEP.EQ.1) THEN
C          DO 5 IZ=1,MZ
C          DO 5 IX=1,MX
C          DO 5 J=1,2
C          DO 5 I=1,3
C              WRITE(11,*) ISTEP,IX,IZ,I,J,TNWIJ(I,J,IX,IZ),BAIR
C    5     CONTINUE
C          STOP
C      ENDIF
C
      CALL CLEARI(ICHW,MMW,2)
      DO 20 IZ=1,NZ
      DO 10 IX=1,MX
          IF(IX.EQ.1) QWT(ISTEP,IZ)=0.0
          IW=TNWIJ(1,2,IX,IZ)
          IF(IW.NE.0) THEN
          IF(ICHW(IW).EQ.0) THEN
              QWT(ISTEP,IZ)=QWT(ISTEP,IZ)+QMS(IW)*BAIR
C              WRITE(11,*) ISTEP,IZ,IX,IW,QMS(IW),BAIR,QWT(ISTEP,IZ)
              ICHW(IW)=1
          ENDIF
          ENDIF
   10 CONTINUE
      IF(ISTEP.NE.1) THEN
          QWT(ISTEP,IZ)=QWT(ISTEP-1,IZ)+QWT(ISTEP,IZ)
      ENDIF
   20 CONTINUE
C      IF(ISTEP.EQ.2) STOP
      RETURN
      END
      SUBROUTINE QCWTOT(QCT,QWT,ST,NZ,ISTEP)
      IMPLICIT INTEGER(A-Z)
      REAL QCT(25000,NZ),QWT(25000,NZ),ST(25000,NZ)
C
      WRITE(21,*) ISTEP,','
      DO 20 IZ=1,NZ
         WRITE(21,*) '**IZ=',IZ
         WRITE(21,*) '1,0.0,0.0,0.0,0.0'
         DO 10 IS=1,ISTEP-1
              WRITE(21,1010) IS+1,-ST(IS,IZ),-QCT(IS,IZ),-QWT(IS,IZ),
     \                       -QCT(IS,IZ)-QWT(IS,IZ)
 1010         FORMAT(1H ,I8,',',F12.4,',',3(F12.2,','))
   10    CONTINUE
   20 CONTINUE
      RETURN
      END