      PROGRAM ZOUBUN KAISEKI
      IMPLICIT INTEGER(A-Z)
      COMMON /COM0/ MX,MZ,NX,NZ,MB,MC,L0,SEIDO,
     \              ISTEP,BAIR
     \       /COM1/ X(500),Z(50)
     \       /COM2/ NBIJ(3,500,50),NCIJ(3,500,50),NF(500),BF(500),
     \              NBP(2,500,50),NCP(2,500,50)
     \       /COM3/ EB(1000),IB(1000),EC(1000),IC(1000),AC(1000)
     \       /COM4/ KB(4,500,50),KC(5,500,50),
     \              KBT(4,500,50),KCT(5,500,50),
     \              KBP(4,500,50),KCP(5,500,50)
     \       /COM5/ U(50),V(500,50),R(500,50),P(50),Q(50),S(50),
     \              QT(25000,50),ST(25000,50),BAI(25000)
     \       /COM6/ MBLR(2,500,50),MCBT(2,500,50),
     \              BQLR(500,50),CQBT(500,50),CNBT(500,50),
     \              MBP(2,500,50),MBP0(2,500,50),
     \              MBPD(2,500,50),MBPT(2,500,50)
     \       /COM7/ MCP(2,500,50),MCP0(2,500,50),
     \              MCPD(2,500,50),MCPT(2,500,50)
     \       /COM8/ MW,NWIJ(3,500,50),ECW(1000),ICW(1000),ACW(1000),
     \              KW(5,500,50)
      REAL L0,X,Z,EB,IB,EC,IC,AC,KB,KC,SEIDO,U,V,R,P,ACR,Q
      REAL MBLR,MCBT,BQLR,CQBT,CNBT,BAIR,BF
      REAL KBT,KCT,KBP,KCP,QT,ST,MBP,MBP0,MBPD,MBPT,S,BAI,NF
      REAL MCP,MCP0,MCPD,MCPT
      REAL ECW,ICW,ACW,KW
      CHARACTER*20 WK_FILE1,WK_FILE2,WK_FILE3,WK_FILE4,WK_FILE5,
     \             WK_FILE6,WK_FILE7,WK_FILE8,WK_FILE9
      CHARACTER*4 TITL
      INTEGER ISTEP,ISTEP0
C
      COMMON /COMA/ MMW,MG,MMSC,MBNR,MBNV,MBNS,
     \              NNWIJ(3,2,2,1000),TNWIJ(3,2,500,50)
     \       /COMB/ XXX(3,1000),ZZZ(2,1000)
     \       /COMC/ NGIJ(3,3,2,1000),NMSIJ(3,1000),NBNIJ(3,3,2,1000)
     \       /COMD1/ EG(1000),IG(1000),EMS(1000),IMS(1000),AMS(1000),
     \               BNR(3,1000),BNV(3,1000),BNS(3,1000),
     \               BNSMAX(1000)
     \       /COME/ RS(3,2,1000),VS(3,2,1000),US(3,2,1000)
     \       /COMF/ KBS(4,3,2,1000),KCS(5,1000),KBNS(3,3,2,1000),
     \       /COMG/ QG(3,2,1000),RMG(2,3,2,1000),
     \              QMS(1000),NMS(1000),MMS(2,1000)
      INTEGER MMW,MG,MMSC,MBNR,MBNV,MBNS,NNWIJ,NGIJ,NMSIJ,NBNIJ
      REAL XXX,ZZZ,EG,IG,EMS,IMS,AMS,BNR,BNV,BNS,RS,VS,US,
     \     KBS,KCS,KBNS,QG,RMG,QMS,NMS,MMS
      COMMON /COMH/ NBNP(3,3,2,1000),NBNI(3,3,2,1000),BNP(3,3,2,1000),
     \              BNPT(3,3,2,1000),BNP0(3,3,2,1000),
     \              BNPD(3,3,2,1000),KBNP(3,3,2,1000),
     \              KBNT(3,3,2,1000),
     \              BNPMAX(3,2,1000)
      INTEGER NBNP,NBNI
      REAL BNP,BNPT,BNP0,BNPD,KBNP,KBNT,
     \     BNSMAX,BNPMAX
      COMMON /COMI/ QCT(25000,50),QWT(25000,50)
      REAL QCT,QWT
C
C                                       **FILE OPEN**
C
      READ(5,*) TITL
      WK_FILE1  =  TITL//'o.csv'
      WK_FILE2  =  TITL//'zb.csv'
      WK_FILE3  =  TITL//'zc.csv'
      WK_FILE4  =  TITL//'zlp.txt'
      WK_FILE5  =  TITL//'zmqn.csv'
      WK_FILE6  =  TITL//'zhoy.csv'
      WK_FILE8  =  TITL//'phi.csv'
      WK_FILE7  =  TITL//'q.csv'
      WK_FILE9  =  TITL//'cwt.csv'
C
      OPEN (UNIT=7, FILE=WK_FILE1, ACCESS='SEQUENTIAL',
     &      STATUS='OLD', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-01 ***'
      ENDIF
C
      OPEN (UNIT=10, FILE=WK_FILE2, ACCESS='SEQUENTIAL',
     &      STATUS='OLD', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-02 ***'
      ENDIF
C
      OPEN (UNIT=13, FILE=WK_FILE3, ACCESS='SEQUENTIAL',
     &      STATUS='OLD', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-03 ***'
      ENDIF
C
      OPEN (UNIT=15, FILE=WK_FILE7, ACCESS='SEQUENTIAL',
     &      STATUS='OLD', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-07 ***'
      ENDIF
C
      OPEN (UNIT=8, FILE=WK_FILE4, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-04 ***'
      ENDIF
C
      OPEN (UNIT=9, FILE=WK_FILE5, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-05 ***'
      ENDIF
C
      OPEN (UNIT=11, FILE=WK_FILE6, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-06 ***'
      ENDIF
C
      OPEN (UNIT=20, FILE=WK_FILE8, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-08 ***'
      ENDIF
C
      OPEN (UNIT=21, FILE=WK_FILE9, ACCESS='SEQUENTIAL',
     &      STATUS='UNKNOWN', FORM='FORMATTED',
     &      IOSTAT=WK_IOS)
      IF  (WK_IOS  .NE.  0)  THEN
          STOP '***  OPEN ERR-09 ***'
      ENDIF
C
C                                       **DATA INPUT**
C
      READ(7,1010) MX,MZ,MB,MC,L0,SEIDO,ACR,IMAX,MW,ISTEP0
      WRITE(6,*) MX,MZ,MB,MC,L0,SEIDO,ACR,IMAX,MW,ISTEP0
 1010 FORMAT(4I10,3E15.7,I10,I10,I10)
      IF(IMAX.EQ.0) IMAX=30000
      NX=MX-1
      NZ=MZ-1
      CALL GRIDST(X,MX)
      CALL GRIDST(Z,MZ)
      CALL BMEMST(EB,IB,MB)
      CALL CMEMST(EC,IC,AC,MC)
      WRITE(6,*) MW
      CALL CMEMST(ECW,ICW,ACW,MW)
      WRITE(6,*)'**CMEMST END**'
      CALL BHICST(NBIJ,MX,MZ,NX)
      WRITE(6,*) '**BHICST END**'
      CALL CHICST(NCIJ,MX,MZ,NZ)
      WRITE(6,*) '**CHICST-1 END**'
      CALL CLEARI(NWIJ,3*MX*MZ,2)
      IF(MW.NE.0) THEN
          CALL CHICST(NWIJ,MX,MZ,NZ)
      ENDIF
      WRITE(6,*) '**CHICST-2 END**'
      CALL NFSET(NF,MX)
      CALL PSET(P,MZ)
C
      CALL BFST(BF,NX)
C
      CALL TINPTZ
      IF(ISTEP0.EQ.0) ISTEP0=MX*MZ+MMW*4
      IF(ISTEP0.LT.100) ISTEP0=ISTEP0*2
C
      CALL MBPIN(NX,MZ,MBP)
      WRITE(6,*) '**MBPIN END**'
      CALL MCPIN(MX,NZ,MCP)
      WRITE(6,*) '**MCPIN END**'
C
      CALL CLEARI(NBP,2*NX*MZ,2)
      CALL CLEARI(NCP,2*MX*NZ,2)
      CALL CLEAR(MBPT,2*NX*MZ,3)
      CALL CLEAR(MCPT,2*MX*NZ,3)
C
C                                       **BUZAI GOUSEI MATRIX**
C
      WRITE(6,*) '**BMATST START**'
      CALL BMATST(EB,IB,MB,X,Z,L0,MX,MZ,NBIJ,NX,KB,NF,BF)
      CALL CMATST(EC,IC,MC,X,Z,L0,MX,MZ,NCIJ,NZ,KC,NF,AC)
      CALL CMATST(ECW,ICW,MW,X,Z,L0,MX,MZ,NWIJ,NZ,KW,NF,ACW)
      CALL BPMATS(EB,IB,MB,X,Z,L0,MX,MZ,NBIJ,NX,KBP,NF,BF)
      CALL CPMATS(EC,IC,MC,X,Z,L0,MX,MZ,NCIJ,NZ,KCP,NF,AC)
      WRITE(6,*) '**CPMATS END**'
C
      WRITE(6,*) '**TMATSZ START**'
      CALL TMATSZ
      WRITE(6,*) '**TMATSZ END**' 
C
C                                       **SYOKI SETTEI**
C
      CALL KBTINI(KB,NX,MZ,KBT)
      CALL KCTINI(KC,MX,NZ,KCT)
C
      ISTEP=0
      CALL CLEAR(U,MZ,3)
      CALL CLEAR(V,MX*MZ,3)
      CALL CLEAR(R,MX*MZ,3)
      CALL CLEAR(US,3*2*MMW,3)
      CALL CLEAR(VS,3*2*MMW,3)
      CALL CLEAR(RS,3*2*MMW,3)
C
      WRITE(6,*) '**BANEIN START**'
      CALL BANEIN
      WRITE(6,*) '**BANEIN END**'
C
C                                       **HOUTEISHIKI NO KAIHOU**
C
    5 ISTEP=ISTEP+1
C      CALL STOPCH(ISTEP,245,1)
      IF(ISTEP.EQ.ISTEP0) GO TO 100
C      IF(ISTEP.EQ.50) GO TO 100 
      WRITE(6,*) '**ISTEP=',ISTEP
C      WRITE(9,*) '**ISTEP=',ISTEP
      ICNT=0
C      CALL STOPCH(ISTEP,245,2)
   10 IH=0
      CALL RVUSET(KBT,KCT,NBIJ,NCIJ,U,V,R,MX,MZ,NX,NZ,SEIDO,IH,P,ACR,
     \            NBP,NCP,NWIJ,KW)
      CALL SCHECK(KCT,NCIJ,U,V,R,MX,MZ,NZ,P,Q,IHNT,SEIDO,NCP,
     \            KW,NWIJ)
      CALL TSCHEK(Q,MZ)
      CALL SCHECKS1(P,Q,SEIDO,MZ,IHNT)
C      IF(IHNT.NE.0) THEN
          ICNT=ICNT+1
C          WRITE(6,*) '**ICNT=  ',ICNT
          IF(ICNT.GT.IMAX) GO TO 20
          GO TO 10
C      ENDIF
   20 CALL MQNSET(KBT,KCT,NBIJ,NCIJ,U,V,R,MX,MZ,NX,NZ,
     \            MBP0,MCP0,BQLR,CQBT,CNBT,NBP,NCP,NF,L0,
     \            KW,NWIJ)
C      CALL STOPCH(ISTEP,245,3)
      CALL TMQNST
C
      CALL BANEOS
C
      BAIR=0.0
      CALL MBPTS1(MBP0,MBP,MX,NX,MZ,MBPD,NBP,NBIJ,BAIR,MBPT)
      CALL MCPTS1(MCP0,MCP,MX,NZ,MZ,MCPD,NCP,NCIJ,BAIR,MCPT)
      CALL TBNTS1(BAIR)
      CALL MBPTS2(MBP0,MBP,MX,NX,MZ,MBPD,NBP,NBIJ,BAIR,MBPT,ISTEP)   
      CALL MCPTS2(MCP0,MCP,MX,NZ,MZ,MCPD,NCP,NCIJ,BAIR,MCPT,ISTEP)
      CALL TBNTS2(BAIR,ISTEP)
C      CALL STOPCH(ISTEP,245,4)
      IF(BAIR.LE.0.0) THEN
          WRITE(6,*) '**BAIR=0.0',ISTEP
C          GO TO 100
          GO TO 50
      ENDIF
   50 CONTINUE
C      CALL STOPCH(ISTEP,245,5)
      CALL BUBUNC(NCIJ,NCP,MX,NZ,MZ,IHC)
      IF(IHC.EQ.1) THEN
          WRITE(6,*) '**BUBUN HOUKAI**'
          GO TO 100
      ENDIF
      WRITE(6,*) '**BAIR=',BAIR,ICNT
C      WRITE(9,*) '**BAIR=',BAIR,ICNT
      BAI(ISTEP)=BAIR
C      WRITE(6,*) '**01**',ISTEP
      CALL SSET(U,MZ,S)
C      WRITE(6,*) '**02**',ISTEP
C      CALL STOPCH(ISTEP,245,6)
      CALL STQTST(S,Q,ISTEP,BAIR,MZ,ST,QT)
      DO 70 IIZZ=1,NZ
          IF(ABS(ST(ISTEP,IIZZ)).GT.100.0) GO TO 100
   70 CONTINUE
C      WRITE(6,*) '**03**',ISTEP
C      CALL STOPCH(ISTEP,245,7)
      CALL QCWTST(QCT,QWT,ST,MX,MZ,NX,NZ,MMW,CQBT,
     \            TNWIJ,QMS,ISTEP,BAIR) 
C      CALL STOPCH(ISTEP,245,8)
      CALL KBTSET(KB,KBP,NBP,NBIJ,MX,NX,MZ,KBT)
      CALL KCTSET(KC,KCP,NCP,NCIJ,MX,NZ,MZ,KCT)
C
      CALL KBNSST
C      WRITE(6,*) '**04**',ISTEP
C      CALL STOPCH(ISTEP,245,9)
      GO TO 5
C
C                                       **DATA OUTPUT**
C
  100 WRITE(6,*)  ISTEP,ICNT
      WRITE(9,*)  ISTEP,(BAI(II),II=1,ISTEP)
      CALL STQTOT(ST,QT,MZ,ISTEP)
      WRITE(6,*) '**STQTOT END**'
      CALL QCWTOT(QCT,QWT,ST,NZ,ISTEP)
      WRITE(6,*) '**QCWTOT END**' 
      CALL UOUT(U,MZ)
      CALL VOUT(V,MX,MZ)
      CALL ROUT(R,MX,MZ)
      CALL QOUT(Q,MZ)
      CALL MQNOUT(NBIJ,NCIJ,MBLR,MCBT,BQLR,CQBT,CNBT,
     \           MX,MZ,NX,NZ,L0)
      WRITE(6,*) '**MQNOUT**'
C      CALL HOYUOT(ISTEP,ST,QT,MZ)
      CALL HIPRIN(NBP,NCP,MX,MZ,NX,NZ)
      STOP
      END
      SUBROUTINE GRIDST(X,MX)
      IMPLICIT INTEGER(A-Z)
      REAL X(MX)
      DO 10 IX=1,MX
          READ(7,1010) X(IX)
 1010     FORMAT(F10.0)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE BMEMST(EB,IB,MB)
      IMPLICIT INTEGER(A-Z)
      REAL EB(MB),IB(MB),FF(500)
      DO 10 I=1,MB
          READ(7,1010) IDUM,EB(I),IB(I)
 1010     FORMAT(I10,2E15.7)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE CMEMST(EC,IC,AC,MC)
      IMPLICIT INTEGER(A-Z)
      REAL EC(MC),IC(MC),AC(MC)
      DO 10 I=1,MC
          READ(7,1010) IDUM,EC(I),IC(I),AC(I)
 1010     FORMAT(I10,3E15.7)
          WRITE(6,*) IDUM,EC(I),IC(I),AC(I)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE BHICST(NBIJ,MX,MZ,NX)
      IMPLICIT INTEGER(A-Z)
      INTEGER NBIJ(3,MX,MZ)
      CALL CLEARI(NBIJ,3*MX*MZ,2)
      DO 10 IZ=1,MZ
          WRITE(6,*) IZ
          READ(7,1010) (NBIJ(1,IX,IZ),IX=1,MX)
 1010     FORMAT(10I10)
   10 CONTINUE
      DO 20 IX=1,NX
      DO 20 IZ=1,MZ
          IF(NBIJ(1,IX,IZ).NE.0) THEN
              NBIJ(2,IX+1,IZ)=IX
              NBIJ(3,IX,IZ)=IX+1
          ENDIF
   20 CONTINUE
   30 READ(7,1020) IZ,IJ1,IJ2
 1020 FORMAT(3I10)
      IF(IZ.EQ.0) RETURN
      NBIJ(3,IJ1,IZ)=IJ2
      DO 40 IX=IJ1+1,IJ2-1
          NBIJ(2,IX,IZ)=0
          NBIJ(3,IX,IZ)=0
   40 CONTINUE
      NBIJ(2,IJ2,IZ)=IJ1
      GO TO 30
      RETURN
      END    
      SUBROUTINE CHICST(NCIJ,MX,MZ,NZ)
      IMPLICIT INTEGER(A-Z)
      INTEGER NCIJ(3,MX,MZ)
      CALL CLEARI(NCIJ,3*MX*MZ,2)
      DO 10 IZ=1,MZ
          READ(7,1010) (NCIJ(1,IX,IZ),IX=1,MX)
 1010     FORMAT(10I10)
   10 CONTINUE
      DO 20 IX=1,MX
      DO 20 IZ=1,NZ
          IF(NCIJ(1,IX,IZ).NE.0) THEN
              NCIJ(2,IX,IZ+1)=IZ
              NCIJ(3,IX,IZ)=IZ+1
          ENDIF
   20 CONTINUE
   30 READ(7,1020) IX,IJ1,IJ2
 1020 FORMAT(3I10)
      IF(IX.EQ.0) RETURN
      NCIJ(3,IX,IJ1)=IJ2
      DO 40 IZ=IJ1+1,IJ2-1
          NCIJ(2,IX,IZ)=0
          NCIJ(3,IX,IZ)=0
   40 CONTINUE
      NCIJ(2,IX,IJ2)=IJ1
      GO TO 30
      RETURN
      END    
      SUBROUTINE BMATST(EB,IB,MB,X,Z,L0,MX,MZ,NBIJ,NX,KB,NF,BF)
      IMPLICIT INTEGER(A-Z)
      REAL EB(MB),IB(MB),X(MX),Z(MZ),L0,KB(4,NX,MZ),LB,LB0,
     \     KB0,NF(MX),BF(NX)
      INTEGER NBIJ(3,MX,MZ)
      CALL CLEAR(KB,4*NX*MZ,3)
C      WRITE(6,*) EB(1),EB(2),IB(1),IB(2)
      DO 10 IX=1,NX
      DO 10 IZ=1,MZ
         IF(NBIJ(1,IX,IZ).EQ.0) GO TO 10
         LB=X(NBIJ(3,IX,IZ))-X(IX)
         LB0=LB/L0
C         WRITE(6,*) LB0,LB,L0
         KB0=EB(NBIJ(1,IX,IZ))*IB(NBIJ(1,IX,IZ))/LB**3
         KB(1,IX,IZ)=12*KB0*NF(IX)*BF(IX)
         KB(2,IX,IZ)=+6*KB0*LB0*NF(IX)*BF(IX)
         KB(3,IX,IZ)=4*KB0*LB0**2*NF(IX)*BF(IX)
         KB(4,IX,IZ)=2*KB0*LB0**2*NF(IX)*BF(IX)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE CMATST(EC,IC,MC,X,Z,L0,MX,MZ,NCIJ,NZ,KC,NF,AC)
      IMPLICIT INTEGER(A-Z)
      REAL EC(MC),IC(MC),X(MX),Z(MZ),L0,KC(5,MX,NZ),LC,LC0,AC(MC),
     \     KC0,AC0,NF(MX)
      INTEGER NCIJ(3,MX,MZ)
      CALL CLEAR(KC,5*MX*NZ,3)
      DO 10 IX=1,MX
      DO 10 IZ=1,NZ
          IF(NCIJ(1,IX,IZ).EQ.0) GO TO 10
          LC=Z(NCIJ(3,IX,IZ))-Z(IZ)
          LC0=LC/L0
C          WRITE(6,*) LC,LC0,L0,EC(1),IC(1),AC(1)
          KC0=EC(NCIJ(1,IX,IZ))*IC(NCIJ(1,IX,IZ))/LC**3
          AC0=AC(NCIJ(1,IX,IZ))*LC**2/IC(NCIJ(1,IX,IZ))
          KC(1,IX,IZ)=12*KC0*NF(IX)
          KC(2,IX,IZ)=-6*KC0*LC0*NF(IX)
          KC(3,IX,IZ)=KC0*AC0*NF(IX)
          KC(4,IX,IZ)=4*KC0*LC0**2*NF(IX)
          KC(5,IX,IZ)=2*KC0*LC0**2*NF(IX)
   10 CONTINUE
C      STOP
      RETURN
      END
      SUBROUTINE RVUSET(KB,KC,NBIJ,NCIJ,U,V,R,MX,MZ,NX,NZ,
     \                  SEIDO,IH,P,ACR,NBP,NCP,NWIJ,KW)
      IMPLICIT INTEGER(A-Z)
      INTEGER NBIJ(3,MX,MZ),NCIJ(3,MX,MZ),NBP(2,NX,MZ),NCP(2,MX,NZ)
      INTEGER NWIJ(3,MX,MZ)
      REAL KB(4,NX,MZ),KC(5,MX,NZ),U(MZ),V(MX,MZ),R(MX,MZ),SEIDO,
     \     BUNSHI,BUNBO,R0,V0,U0,ACR,P(MZ),BUNSHIU,BUNBOU
      REAL KW(5,MX,NZ)
      DO 20 IZ=1,MZ
          BUNSHIU=0.0
          BUNBOU=0.0
      DO 10 IX=1,MX
C                                        **R WO MOTOMERU**
          BUNSHI=0.0
          BUNBO=0.0
          IF(NBIJ(1,IX,IZ).NE.0) THEN
              BUNSHI=BUNSHI+KB(2,IX,IZ)*V(IX,IZ)
     \                     -KB(2,IX,IZ)*V(NBIJ(3,IX,IZ),IZ)
              IF(NBP(2,IX,IZ).EQ.0) THEN
                  BUNSHI=BUNSHI+KB(4,IX,IZ)*R(NBIJ(3,IX,IZ),IZ)
              ENDIF
              BUNBO=BUNBO+KB(3,IX,IZ)
          ENDIF
          IF(NBIJ(2,IX,IZ).NE.0) THEN
              BUNSHI=BUNSHI+KB(2,NBIJ(2,IX,IZ),IZ)*V(NBIJ(2,IX,IZ),IZ)
     \                     -KB(2,NBIJ(2,IX,IZ),IZ)*V(IX,IZ)
              IF(NBP(1,NBIJ(2,IX,IZ),IZ).EQ.0) THEN
                  BUNSHI=BUNSHI+KB(4,NBIJ(2,IX,IZ),IZ)
     \                         *R(NBIJ(2,IX,IZ),IZ)
              ENDIF
              BUNBO=BUNBO+KB(3,NBIJ(2,IX,IZ),IZ)
          ENDIF
C
          IF(NCIJ(1,IX,IZ).NE.0) THEN
              IF(NCP(1,IX,IZ).EQ.0 .AND. NCP(2,IX,IZ).EQ.0) THEN
                  BUNSHI=BUNSHI+KC(2,IX,IZ)*U(IZ)
     \                         -KC(2,IX,IZ)*U(NCIJ(3,IX,IZ))
     \                         +KC(5,IX,IZ)*R(IX,NCIJ(3,IX,IZ))
                  BUNBO=BUNBO+KC(4,IX,IZ)
              ELSEIF(NCP(1,IX,IZ).EQ.0 .AND. NCP(2,IX,IZ).NE.0) THEN
                  BUNSHI=BUNSHI+KC(2,IX,IZ)*U(IZ)
     \                         -KC(2,IX,IZ)*U(NCIJ(3,IX,IZ))
                  BUNBO=BUNBO+KC(4,IX,IZ)
              ENDIF
          ENDIF
          IF(NCIJ(2,IX,IZ).NE.0) THEN
              IF(NCP(1,IX,NCIJ(2,IX,IZ)).EQ.0
     \              .AND. NCP(2,IX,NCIJ(2,IX,IZ)).EQ.0) THEN
                  BUNSHI=BUNSHI+KC(2,IX,NCIJ(2,IX,IZ))*U(NCIJ(2,IX,IZ))
     \                      +KC(5,IX,NCIJ(2,IX,IZ))*R(IX,NCIJ(2,IX,IZ))
     \                         -KC(2,IX,NCIJ(2,IX,IZ))*U(IZ)        
                  BUNBO=BUNBO+KC(4,IX,NCIJ(2,IX,IZ))
              ELSEIF(NCP(1,IX,NCIJ(2,IX,IZ)).NE.0
     \              .AND. NCP(2,IX,NCIJ(2,IX,IZ)).EQ.0) THEN
                  BUNSHI=BUNSHI+KC(2,IX,NCIJ(2,IX,IZ))*U(NCIJ(2,IX,IZ))
     \                         -KC(2,IX,NCIJ(2,IX,IZ))*U(IZ)        
                  BUNBO=BUNBO+KC(4,IX,NCIJ(2,IX,IZ))
C                  WRITE(6,1010) IX,IZ,NCIJ(2,IX,IZ),BUNSHI,BUNBO
 1010             FORMAT(1H ,3I5,2E15.7)
              ENDIF
          ENDIF

C 
          IF(NWIJ(1,IX,IZ).NE.0) THEN
                  BUNSHI=BUNSHI+KW(2,IX,IZ)*U(IZ)
     \                         -KW(2,IX,IZ)*U(NWIJ(3,IX,IZ))
     \                         +KW(5,IX,IZ)*R(IX,NWIJ(3,IX,IZ))
                  BUNBO=BUNBO+KW(4,IX,IZ)
C                  BUNSHI=BUNSHI+KW(2,IX,IZ)*U(IZ)
C     \                         -KW(2,IX,IZ)*U(NWIJ(3,IX,IZ))
C                  BUNBO=BUNBO+KW(4,IX,IZ)
          ENDIF
          IF(NWIJ(2,IX,IZ).NE.0) THEN
                  BUNSHI=BUNSHI+KW(2,IX,NWIJ(2,IX,IZ))*U(NWIJ(2,IX,IZ))
     \                      +KW(5,IX,NWIJ(2,IX,IZ))*R(IX,NWIJ(2,IX,IZ))
     \                         -KW(2,IX,NWIJ(2,IX,IZ))*U(IZ)        
                  BUNBO=BUNBO+KW(4,IX,NWIJ(2,IX,IZ))
C                  BUNSHI=BUNSHI+KW(2,IX,NWIJ(2,IX,IZ))*U(NWIJ(2,IX,IZ))
C     \                         -KW(2,IX,NWIJ(2,IX,IZ))*U(IZ)        
C                  BUNBO=BUNBO+KW(4,IX,NWIJ(2,IX,IZ))
          ENDIF
C
C          WRITE(6,*) '**TBRSET START**',MX,MZ,IX,IZ
          CALL TBRSET(BUNSHI,BUNBO,R,MX,MZ,IX,IZ)
C          WRITE(6,*) '**TBRSET END**',MX,MZ,IX,IZ
C
          IF(BUNBO.NE.0.0) THEN
              R0=R(IX,IZ)
              R(IX,IZ)=-BUNSHI/BUNBO
              R(IX,IZ)=(R(IX,IZ)-R0)*ACR+R0
              IF(R(IX,IZ).NE.0.0) THEN
                  IF(ABS(R(IX,IZ)-R0)/ABS(R(IX,IZ)).GT.SEIDO) IH=1
              ENDIF
          ENDIF       
C
C          WRITE(6,*) '**TKRSET START**',MX,MZ,IX,IZ 
          CALL TKRSET(BUNSHI,BUNBO,U,V,R,MX,MZ,IX,IZ,ACR,SEIDO,IH)
C          WRITE(6,*) '**TKRSET END**',MX,MZ,IX,IZ
C
C                                         **V WO MOTOMERU**
          IF(IZ.EQ.1) GO TO 10
          BUNSHI=0.0
          BUNBO=0.0
          IF(NBIJ(1,IX,IZ).NE.0) THEN
              BUNSHI=BUNSHI-KB(1,IX,IZ)*V(NBIJ(3,IX,IZ),IZ)
              IF(NBP(1,IX,IZ).EQ.0) THEN
                  BUNSHI=BUNSHI+KB(2,IX,IZ)*R(IX,IZ)
              ENDIF
              IF(NBP(2,IX,IZ).EQ.0) THEN
                  BUNSHI=BUNSHI+KB(2,IX,IZ)*R(NBIJ(3,IX,IZ),IZ)
              ENDIF
              BUNBO=BUNBO+KB(1,IX,IZ)
          ENDIF
          IF(NBIJ(2,IX,IZ).NE.0) THEN
              BUNSHI=BUNSHI-KB(1,NBIJ(2,IX,IZ),IZ)*V(NBIJ(2,IX,IZ),IZ)
              IF(NBP(1,NBIJ(2,IX,IZ),IZ).EQ.0) THEN
                  BUNSHI=BUNSHI-KB(2,NBIJ(2,IX,IZ),IZ)
     \                         *R(NBIJ(2,IX,IZ),IZ)
              ENDIF
              IF(NBP(2,NBIJ(2,IX,IZ),IZ).EQ.0) THEN
                  BUNSHI=BUNSHI-KB(2,NBIJ(2,IX,IZ),IZ)*R(IX,IZ)
              ENDIF
              BUNBO=BUNBO+KB(1,NBIJ(2,IX,IZ),IZ)
          ENDIF
C
          IF(NCIJ(1,IX,IZ).NE.0) THEN
              BUNSHI=BUNSHI-KC(3,IX,IZ)*V(IX,NCIJ(3,IX,IZ))
              BUNBO=BUNBO+KC(3,IX,IZ)
          ENDIF
          IF(NCIJ(2,IX,IZ).NE.0) THEN
              BUNSHI=BUNSHI-KC(3,IX,NCIJ(2,IX,IZ))*V(IX,NCIJ(2,IX,IZ))
              BUNBO=BUNBO+KC(3,IX,NCIJ(2,IX,IZ))
          ENDIF
C
          IF(NWIJ(1,IX,IZ).NE.0) THEN
              BUNSHI=BUNSHI-KW(3,IX,IZ)*V(IX,NWIJ(3,IX,IZ))
              BUNBO=BUNBO+KW(3,IX,IZ)
          ENDIF
          IF(NWIJ(2,IX,IZ).NE.0) THEN
              BUNSHI=BUNSHI-KW(3,IX,NWIJ(2,IX,IZ))*V(IX,NWIJ(2,IX,IZ))
              BUNBO=BUNBO+KW(3,IX,NWIJ(2,IX,IZ))
          ENDIF
C
C     WRITE(6,*) '**TBVSET START**',MX,MZ,IX,IZ
          CALL TBVSET(BUNSHI,BUNBO,V,MX,MZ,IX,IZ)
C          WRITE(6,*) '**TBVSET END**',MX,MZ,IX,IZ
C
          IF(BUNBO.NE.0.0) THEN
              V0=V(IX,IZ)
              V(IX,IZ)=-BUNSHI/BUNBO
              V(IX,IZ)=(V(IX,IZ)-V0)*ACR+V0
C              DO 5 I=IZ+1,MZ
C                  V(IX,I)=(V(IX,IZ)-V0)+V(IX,I)
C    5         CONTINUE
              IF(V(IX,IZ).NE.0.0) THEN
                  IF(ABS(V(IX,IZ)-V0)/ABS(V(IX,IZ)).GT.SEIDO) IH=1
              ENDIF
          ENDIF
C
C          WRITE(6,*) '**TKVSET START**',MX,MZ,IX,IZ
          CALL TKVSET(BUNSHI,BUNBO,U,V,R,MX,MZ,IX,IZ,ACR,SEIDO,IH)
C          WRITE(6,*) '**TKVSET END**',MX,MZ,IX,IZ
C
C                                        **U WO MOTOMERU**
C
C          WRITE(6,*) '**TBUSET START**',MX,MZ,IX,IZ
          CALL TBUSET(BUNSHIU,BUNBOU,MX,MZ,IX,IZ)
C          WRITE(6,*) '**TBUSET END**',MX,MZ,IX,IZ
          CALL TKUSET(U,V,R,MX,MZ,IX,IZ,ACR,SEIDO,IH)
C          WRITE(6,*) '**TKUSET END**',MX,MZ,IX,IZ
C
          IF(NCIJ(1,IX,IZ).NE.0) THEN
              IF(NCP(1,IX,IZ).EQ.0 .AND. NCP(2,IX,IZ).EQ.0) THEN
                  BUNSHIU=BUNSHIU+KC(2,IX,IZ)*R(IX,IZ)
     \                           -KC(1,IX,IZ)*U(NCIJ(3,IX,IZ))
     \                           +KC(2,IX,IZ)*R(IX,NCIJ(3,IX,IZ))
                  BUNBOU=BUNBOU+KC(1,IX,IZ)
              ELSEIF(NCP(1,IX,IZ).NE.0 .AND. NCP(2,IX,IZ).EQ.0) THEN
                  BUNSHIU=BUNSHIU-KC(1,IX,IZ)*U(NCIJ(3,IX,IZ))
     \                           +KC(2,IX,IZ)*R(IX,NCIJ(3,IX,IZ))
                  BUNBOU=BUNBOU+KC(1,IX,IZ)
C                  WRITE(6,1010) IX,IZ,NCIJ(3,IX,IZ),BUNSHI,BUNBO
              ELSEIF(NCP(1,IX,IZ).EQ.0 .AND. NCP(2,IX,IZ).NE.0) THEN
                  BUNSHIU=BUNSHIU+KC(2,IX,IZ)*R(IX,IZ)
     \                           -KC(1,IX,IZ)*U(NCIJ(3,IX,IZ))
                  BUNBOU=BUNBOU+KC(1,IX,IZ)
              ENDIF
          ENDIF
          IF(NCIJ(2,IX,IZ).NE.0) THEN
              IF(NCP(1,IX,NCIJ(2,IX,IZ)).EQ.0
     \              .AND. NCP(2,IX,NCIJ(2,IX,IZ)).EQ.0) THEN
                  BUNSHIU=BUNSHIU-KC(1,IX,NCIJ(2,IX,IZ))
     \                            *U(NCIJ(2,IX,IZ))
     \                            -KC(2,IX,NCIJ(2,IX,IZ))
     \                            *R(IX,NCIJ(2,IX,IZ))
     \                           -KC(2,IX,NCIJ(2,IX,IZ))*R(IX,IZ)
                  BUNBOU=BUNBOU+KC(1,IX,NCIJ(2,IX,IZ))
              ELSEIF(NCP(1,IX,NCIJ(2,IX,IZ)).NE.0
     \              .AND. NCP(2,IX,NCIJ(2,IX,IZ)).EQ.0) THEN
                  BUNSHIU=BUNSHIU-KC(1,IX,NCIJ(2,IX,IZ))
     \                            *U(NCIJ(2,IX,IZ))
     \                            -KC(2,IX,NCIJ(2,IX,IZ))
     \                            *R(IX,IZ)
                  BUNBOU=BUNBOU+KC(1,IX,NCIJ(2,IX,IZ))
C                  WRITE(6,1010) IX,IZ,NCIJ(2,IX,IZ),BUNSHI,BUNBO
              ELSEIF(NCP(1,IX,NCIJ(2,IX,IZ)).EQ.0
     \              .AND. NCP(2,IX,NCIJ(2,IX,IZ)).NE.0) THEN
                  BUNSHIU=BUNSHIU-KC(1,IX,NCIJ(2,IX,IZ))
     \                            *U(NCIJ(2,IX,IZ))
     \                            -KC(2,IX,NCIJ(2,IX,IZ))
     \                            *R(IX,NCIJ(2,IX,IZ))
                  BUNBOU=BUNBOU+KC(1,IX,NCIJ(2,IX,IZ))
              ENDIF
          ENDIF
C
          IF(NWIJ(1,IX,IZ).NE.0) THEN
                  BUNSHIU=BUNSHIU+KW(2,IX,IZ)*R(IX,IZ)
     \                           -KW(1,IX,IZ)*U(NWIJ(3,IX,IZ))
     \                           +KW(2,IX,IZ)*R(IX,NWIJ(3,IX,IZ))
                  BUNBOU=BUNBOU+KW(1,IX,IZ)
C                  BUNSHIU=BUNSHIU-KW(1,IX,IZ)*U(NWIJ(3,IX,IZ))
C     \                           +KW(2,IX,IZ)*R(IX,NWIJ(3,IX,IZ))
C                  BUNBOU=BUNBOU+KW(1,IX,IZ)
C                  BUNSHIU=BUNSHIU+KW(2,IX,IZ)*R(IX,IZ)
C     \                           -KW(1,IX,IZ)*U(NWIJ(3,IX,IZ))
C                  BUNBOU=BUNBOU+KW(1,IX,IZ)
          ENDIF
          IF(NWIJ(2,IX,IZ).NE.0) THEN
                  BUNSHIU=BUNSHIU-KW(1,IX,NWIJ(2,IX,IZ))
     \                            *U(NWIJ(2,IX,IZ))
     \                            -KW(2,IX,NWIJ(2,IX,IZ))
     \                            *R(IX,NWIJ(2,IX,IZ))
     \                           -KW(2,IX,NWIJ(2,IX,IZ))*R(IX,IZ)
                  BUNBOU=BUNBOU+KW(1,IX,NWIJ(2,IX,IZ))
C                  BUNSHIU=BUNSHIU-KW(1,IX,NWIJ(2,IX,IZ))
C     \                            *U(NWIJ(2,IX,IZ))
C     \                            -KW(2,IX,NWIJ(2,IX,IZ))
C     \                            *R(IX,IZ)
C                  BUNBOU=BUNBOU+KW(1,IX,NWIJ(2,IX,IZ))
C                  BUNSHIU=BUNSHIU-KW(1,IX,NWIJ(2,IX,IZ))
C     \                            *U(NWIJ(2,IX,IZ))
C     \                            -KW(2,IX,NWIJ(2,IX,IZ))
C     \                            *R(IX,NWIJ(2,IX,IZ))
C                  BUNBOU=BUNBOU+KW(1,IX,NWIJ(2,IX,IZ))
          ENDIF

   10 CONTINUE
      IF(IZ.EQ.1) GO TO 20
      IF(BUNBOU.NE.0.0) THEN
          U0=U(IZ)
          U(IZ)=(P(IZ-1)-BUNSHIU)/BUNBOU
          U(IZ)=(U(IZ)-U0)*ACR+U0
C          DO 7 I=IZ+1,MZ
C              U(I)=(U(IZ)-U0)+U(I)
C    7     CONTINUE
C          WRITE(6,*) U(IZ)
          IF(U(IZ).NE.0.0) THEN
               IF(ABS(U(IZ)-U0)/ABS(U(IZ)).GT.SEIDO) IH=1
          ENDIF
      ENDIF
   20 CONTINUE
      RETURN
      END
      SUBROUTINE PSET(P,MZ)
      IMPLICIT INTEGER(A-Z)
      REAL P(MZ)
      DO 10 IZ=MZ-1,1,-1
          READ(7,1010) P(IZ)
 1010     FORMAT(E15.7)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE CLEAR(U,MZ,IT)
      REAL U(MZ)
      DO 10 IZ=1,MZ
          U(IZ)=0.0
   10 CONTINUE
      RETURN
      END
      SUBROUTINE CLEARI(U,MZ,IT)
      INTEGER U(MZ)
      DO 10 IZ=1,MZ
          U(IZ)=0
   10 CONTINUE
      RETURN
      END
      SUBROUTINE NFSET(NF,MX)
      REAL NF(MX)
      READ(7,1010) (NF(IX),IX=1,MX)
 1010 FORMAT(10F10.0)
      RETURN
      END
      SUBROUTINE UOUT(U,MZ)   
      REAL U(MZ)
      WRITE(8,*) '**U**'
      WRITE(8,1010) (U(IZ),IZ=1,MZ)
 1010 FORMAT(1H ,F10.4)
      RETURN
      END
      SUBROUTINE QOUT(Q,MZ)
      REAL Q(MZ)
      WRITE(8,*) '**Q**'
      DO 10 IZ=1,MZ-1
          WRITE(8,1010) Q(IZ)
 1010     FORMAT(1H ,F10.2)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE ROUT(R,MX,MZ)
      REAL R(MX,MZ)
      WRITE(8,*) '**R**'
      DO 10 IZ=1,MZ
          WRITE(8,1010) (R(IX,IZ),IX=1,MX)
 1010     FORMAT(1H ,8F10.6)
   10 CONTINUE
      RETURN
      END 
      SUBROUTINE VOUT(V,MX,MZ)
      REAL V(MX,MZ)
      WRITE(8,*) '**V**'
      DO 10 IZ=1,MZ
          WRITE(8,1010) (V(IX,IZ),IX=1,MX)
 1010     FORMAT(1H ,8F10.6)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE SCHECK(KC,NCIJ,U,V,R,MX,MZ,NZ,P,Q,IHNT,SEIDO,NCP,
     \                  KW,NWIJ)
      IMPLICIT INTEGER(A-Z)
      REAL KC(5,MX,NZ),U(MZ),V(MX,MZ),R(MX,MZ),P(MZ),Q(MZ),Q0(50),
     \     SEIDO,KW(5,MX,NZ)
      INTEGER NCIJ(3,MX,MZ),NCP(2,MX,NZ),NWIJ(3,MX,MZ)
      CALL CLEAR(Q,MZ,3)
      DO 10 IZ=1,NZ
      DO 10 IX=1,MX
          IF(NCIJ(1,IX,IZ).EQ.0) GO TO 10
          IF(NCP(1,IX,IZ).EQ.0 .AND. NCP(2,IX,IZ).EQ.0) THEN
              Q(IZ)=Q(IZ)+KC(1,IX,IZ)*U(IZ)
     \                   +KC(2,IX,IZ)*R(IX,IZ)
     \                   -KC(1,IX,IZ)*U(NCIJ(3,IX,IZ))
     \                   +KC(2,IX,IZ)*R(IX,NCIJ(3,IX,IZ))
          ELSEIF(NCP(1,IX,IZ).NE.0 .AND. NCP(2,IX,IZ).EQ.0) THEN
              Q(IZ)=Q(IZ)+KC(1,IX,IZ)*U(IZ)
     \                   -KC(1,IX,IZ)*U(NCIJ(3,IX,IZ))
     \                   +KC(2,IX,IZ)*R(IX,NCIJ(3,IX,IZ))
          ELSEIF(NCP(1,IX,IZ).EQ.0 .AND. NCP(2,IX,IZ).NE.0) THEN
              Q(IZ)=Q(IZ)+KC(1,IX,IZ)*U(IZ)
     \                   +KC(2,IX,IZ)*R(IX,IZ)
     \                   -KC(1,IX,IZ)*U(NCIJ(3,IX,IZ))
          ENDIF
          IF(NWIJ(1,IX,IZ).EQ.0) GO TO 10
              Q(IZ)=Q(IZ)+KW(1,IX,IZ)*U(IZ)
     \                   +KW(2,IX,IZ)*R(IX,IZ)
     \                   -KW(1,IX,IZ)*U(NWIJ(3,IX,IZ))
     \                   +KW(2,IX,IZ)*R(IX,NWIJ(3,IX,IZ))
C              Q(IZ)=Q(IZ)+KW(1,IX,IZ)*U(IZ)
C     \                   -KW(1,IX,IZ)*U(NWIJ(3,IX,IZ))
C     \                   +KW(2,IX,IZ)*R(IX,NWIJ(3,IX,IZ))
C              Q(IZ)=Q(IZ)+KW(1,IX,IZ)*U(IZ)
C     \                   +KW(2,IX,IZ)*R(IX,IZ)
C     \                   -KW(1,IX,IZ)*U(NWIJ(3,IX,IZ))
   10 CONTINUE
      RETURN
      END
      SUBROUTINE SCHECKS1(P,Q,SEIDO,MZ,IHNT)
      IMPLICIT INTEGER(A-Z)
      REAL P(MZ),Q0(50),Q(MZ),SEIDO
      Q0(MZ-1)=P(MZ-1)
      DO 20 IZ=MZ-2,1,-1
          Q0(IZ)=Q0(IZ+1)+P(IZ)
   20 CONTINUE
      IHNT=0
      DO 30 IZ=1,MZ-1
          IF(Q0(IZ).EQ.0.0 .OR. Q(IZ).EQ.0.0) GOTO 30
          IF(ABS(Q0(IZ)+Q(IZ))/ABS(Q0(IZ)).GT.SEIDO) IHNT=1
   30 CONTINUE
      IF(IHNT.EQ.1) RETURN
      DO 40 IZ=1,MZ
          WRITE(8,1020) Q0(IZ),Q(IZ),
     \                  ABS(Q0(IZ)+Q(IZ))/ABS(Q0(IZ))
 1020     FORMAT(1H ,2F10.1,F10.4)
   40 CONTINUE
      RETURN
      END
      SUBROUTINE MQNSET(KB,KC,NBIJ,NCIJ,U,V,R,MX,MZ,NX,NZ,
     \                  MBLR,MCBT,BQLR,CQBT,CNBT,NBP,NCP,NF,L0,
     \                  KW,NWIJ)
      IMPLICIT INTEGER(A-Z)
      INTEGER NBIJ(3,MX,MZ),NCIJ(3,MX,MZ),NBP(2,NX,MZ),NCP(2,MX,NZ)
      REAL KB(4,NX,MZ),KC(5,MX,NZ),U(MZ),V(MX,MZ),R(MX,MZ)
      REAL MBLR(2,NX,MZ),MCBT(2,MX,NZ),BQLR(NX,MZ),
     \     CQBT(MX,NZ),CNBT(MX,NZ),L0,NF(MX) 
      INTEGER NWIJ(5,MX,MZ)
      REAL KW(5,MX,NZ)
      CALL CLEAR(MBLR,2*NX*MZ,3)
      CALL CLEAR(MCBT,2*MX*NZ,3)
      CALL CLEAR(BQLR,NX*MZ,3)
      CALL CLEAR(CQBT,MX*NZ,3)
      CALL CLEAR(CNBT,MX*NZ,3)
      DO 10 IZ=1,MZ
      DO 10 IX=1,MX
          IF(NBIJ(1,IX,IZ).NE.0) THEN
              MBLR(1,IX,IZ)=KB(2,IX,IZ)*V(IX,IZ)
     \                     -KB(2,IX,IZ)*V(NBIJ(3,IX,IZ),IZ)
              IF(NBP(2,IX,IZ).EQ.0) THEN
                  MBLR(1,IX,IZ)=MBLR(1,IX,IZ)
     \                         +KB(4,IX,IZ)*R(NBIJ(3,IX,IZ),IZ)
              ENDIF
              IF(NBP(1,IX,IZ).EQ.0) THEN
                  MBLR(1,IX,IZ)=MBLR(1,IX,IZ)+KB(3,IX,IZ)*R(IX,IZ)
              ELSE
                  MBLR(1,IX,IZ)=0.0
              ENDIF
              MBLR(2,IX,IZ)=KB(2,IX,IZ)*V(IX,IZ)
     \                     -KB(2,IX,IZ)*V(NBIJ(3,IX,IZ),IZ)
              IF(NBP(1,IX,IZ).EQ.0) THEN
                  MBLR(2,IX,IZ)=MBLR(2,IX,IZ)+KB(4,IX,IZ)*R(IX,IZ)
              ENDIF
              IF(NBP(2,IX,IZ).EQ.0) THEN
                  MBLR(2,IX,IZ)=MBLR(2,IX,IZ)
     \                         +KB(3,IX,IZ)*R(NBIJ(3,IX,IZ),IZ)
              ELSE
                  MBLR(2,IX,IZ)=0.0
              ENDIF
              BQLR(IX,IZ)=KB(1,IX,IZ)*V(IX,IZ)
     \                   +KB(2,IX,IZ)*R(IX,IZ)
     \                   -KB(1,IX,IZ)*V(NBIJ(3,IX,IZ),IZ)
     \                   +KB(2,IX,IZ)*R(NBIJ(3,IX,IZ),IZ)
          ENDIF
          IF(NCIJ(1,IX,IZ).NE.0) THEN
              MCBT(1,IX,IZ)=MCBT(1,IX,IZ)+KC(2,IX,IZ)*U(IZ)
     \                     -KC(2,IX,IZ)*U(NCIJ(3,IX,IZ))
              IF(NCP(1,IX,IZ).EQ.0) THEN
                  MCBT(1,IX,IZ)=MCBT(1,IX,IZ)+KC(4,IX,IZ)*R(IX,IZ)
              ENDIF
              IF(NCP(2,IX,IZ).EQ.0) THEN
                  MCBT(1,IX,IZ)=MCBT(1,IX,IZ)+KC(5,IX,IZ)
     \                                       *R(IX,NCIJ(3,IX,IZ))
              ENDIF
              MCBT(2,IX,IZ)=MCBT(2,IX,IZ)+KC(2,IX,IZ)*U(IZ)
     \                                   -KC(2,IX,IZ)*U(NCIJ(3,IX,IZ))
              IF(NCP(1,IX,IZ).EQ.0) THEN
                  MCBT(2,IX,IZ)=MCBT(2,IX,IZ)+KC(5,IX,IZ)*R(IX,IZ)
              ENDIF
              IF(NCP(2,IX,IZ).EQ.0) THEN
                  MCBT(2,IX,IZ)=MCBT(2,IX,IZ)+KC(4,IX,IZ)
     \                                       *R(IX,NCIJ(3,IX,IZ))
              ENDIF
              CQBT(IX,IZ)=+KC(1,IX,IZ)*U(IZ)
     \                    +KC(2,IX,IZ)*R(IX,IZ)
     \                    -KC(1,IX,IZ)*U(NCIJ(3,IX,IZ))
     \                    +KC(2,IX,IZ)*R(IX,NCIJ(3,IX,IZ))
              CNBT(IX,IZ)=KC(3,IX,IZ)*V(IX,IZ)
     \                   -KC(3,IX,IZ)*V(IX,NCIJ(3,IX,IZ))
          ENDIF
          IF(NWIJ(1,IX,IZ).NE.0) THEN
              MCBT(1,IX,IZ)=MCBT(1,IX,IZ)+KW(2,IX,IZ)*U(IZ)
     \                     -KW(2,IX,IZ)*U(NWIJ(3,IX,IZ))
                  MCBT(1,IX,IZ)=MCBT(1,IX,IZ)+KW(4,IX,IZ)*R(IX,IZ)
                  MCBT(1,IX,IZ)=MCBT(1,IX,IZ)+KW(5,IX,IZ)
     \                                       *R(IX,NWIJ(3,IX,IZ))
              MCBT(2,IX,IZ)=MCBT(2,IX,IZ)+KW(2,IX,IZ)*U(IZ)
     \                                   -KW(2,IX,IZ)*U(NWIJ(3,IX,IZ))
                  MCBT(2,IX,IZ)=MCBT(2,IX,IZ)+KW(5,IX,IZ)*R(IX,IZ)
                  MCBT(2,IX,IZ)=MCBT(2,IX,IZ)+KW(4,IX,IZ)
     \                                       *R(IX,NWIJ(3,IX,IZ))
              CQBT(IX,IZ)=+CQBT(IX,IZ)+KW(1,IX,IZ)*U(IZ)
     \                    +KW(2,IX,IZ)*R(IX,IZ)
     \                    -KW(1,IX,IZ)*U(NWIJ(3,IX,IZ))
     \                    +KW(2,IX,IZ)*R(IX,NWIJ(3,IX,IZ))
              CNBT(IX,IZ)=CNBT(IX,IZ)+KW(3,IX,IZ)*V(IX,IZ)
     \                   -KW(3,IX,IZ)*V(IX,NWIJ(3,IX,IZ))
          ENDIF
          IF(IX.NE.MX) THEN
              MBLR(1,IX,IZ)=-MBLR(1,IX,IZ)/NF(IX)/100*L0
              MBLR(2,IX,IZ)=-MBLR(2,IX,IZ)/NF(IX)/100*L0
          ENDIF
          IF(IZ.NE.MZ) THEN
              MCBT(1,IX,IZ)=MCBT(1,IX,IZ)/NF(IX)/100*L0
              MCBT(2,IX,IZ)=MCBT(2,IX,IZ)/NF(IX)/100*L0
          ENDIF
   10 CONTINUE
      RETURN
      END
      SUBROUTINE MQNOUT(NBIJ,NCIJ,MBLR,MCBT,BQLR,CQBT,CNBT,
     \           MX,MZ,NX,NZ,L0)
      IMPLICIT INTEGER(A-Z)
      INTEGER NBIJ(3,MX,MZ),NCIJ(3,MX,MZ)
      REAL MBLR(2,NX,MZ),MCBT(2,MX,NZ),BQLR(NX,MZ),
     \     CQBT(MX,NZ),CNBT(MX,NZ),L0
C
C      DO 10 IZ=1,MZ
C      DO 10 IX=1,NX
C          IF(NBIJ(1,IX,IZ).NE.0) THEN
C              WRITE(9,1010) IZ,IX,NBIJ(3,IX,IZ),MBLR(1,IX,IZ)/100.0*L0,
C     \                      MBLR(2,IX,IZ)/100.0*L0,BQLR(IX,IZ)
C 1010         FORMAT(1H ,I5,',',I5,',',I5,',',F10.1,
C     \                      ',',F10.1,',',F10.1)
C          ENDIF
C   10 CONTINUE
C
C      DO 20 IZ=1,NZ
C      DO 20 IX=1,MX
C          IF(NCIJ(1,IX,IZ).NE.0) THEN
C              WRITE(9,1020) IX,IZ,NCIJ(3,IX,IZ),MCBT(1,IX,IZ)/100.0*L0,
C     \                      MCBT(2,IX,IZ)/100.0*L0,CQBT(IX,IZ),
C     \                      CNBT(IX,IZ)
C 1020         FORMAT(1H ,I5,',',I5,',',I5,',',F10.1,
C     \                      ',',F10.1,',',F10.1,',',F10.1)
C          ENDIF
C   20 CONTINUE
      RETURN
      END
      SUBROUTINE MBPIN(NX,MZ,MBP)
      IMPLICIT INTEGER(A-Z)
      REAL MBP(2,NX,MZ),MBL,MBR
      CALL CLEAR(MBP,2*NX*MZ,3)
   10 READ(10,1010,END=20) IZ,IX1,IX2,MBL,MBR
 1010 FORMAT(3I10,2E15.7)
      MBP(1,IX1,IZ)=MBL
      MBP(2,IX1,IZ)=MBR
C      WRITE(6,1020) IZ,IX1,MBP(1,IX1,IZ),MBP(2,IX1,IZ)
 1020 FORMAT(1H ,2I5,2F10.1)
      GO TO 10
   20 RETURN
      END
      SUBROUTINE BPMATS(EB,IB,MB,X,Z,L0,MX,MZ,NBIJ,NX,KBP,NF,BF)
      IMPLICIT INTEGER(A-Z)
      REAL EB(MB),IB(MB),X(MX),Z(MZ),L0,KBP(4,NX,MZ),LB,LB0,
     \     KB0,NF(MX),BF(NX)
      INTEGER NBIJ(3,MX,MZ)
      CALL CLEAR(KBP,4*NX*MZ,3)
C      WRITE(6,*) EB(1),EB(2),IB(1),IB(2)
      DO 10 IX=1,NX
      DO 10 IZ=1,MZ
         IF(NBIJ(1,IX,IZ).EQ.0) GO TO 10
         LB=X(NBIJ(3,IX,IZ))-X(IX)
         LB0=LB/L0
C         WRITE(6,*) LB0,LB,L0
         KB0=EB(NBIJ(1,IX,IZ))*IB(NBIJ(1,IX,IZ))/LB**3
         KBP(1,IX,IZ)=3*KB0*NF(IX)*BF(IX)
         KBP(2,IX,IZ)=-3*KB0*LB0*NF(IX)*BF(IX)
         KBP(3,IX,IZ)=3*KB0*LB0**2*NF(IX)*BF(IX)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE KBTINI(KB,NX,MZ,KBT)
      IMPLICIT INTEGER(A-Z)
      REAL KB(4,NX,MZ),KBT(4,NX,MZ)
      DO 10 IT=1,4
      DO 10 IX=1,NX
      DO 10 IZ=1,MZ
          KBT(IT,IX,IZ)=KB(IT,IX,IZ)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE MBPTS1(MBP0,MBP,MX,NX,MZ,MBPD,NBP,NBIJ,BAIR,MBPT)
      IMPLICIT INTEGER(A-Z)
      REAL MBP0(2,NX,MZ),MBP(2,NX,MZ),MBPD(2,NX,MZ),MBPT(2,NX,MZ)
      REAL BAIR
      INTEGER NBP(2,NX,MZ),NBIJ(3,MX,MZ)
      CALL CLEAR(MBPD,2*NX*MZ,3)
      DO 20 IX=1,NX
      DO 20 IZ=1,MZ
          IF(NBIJ(1,IX,IZ).NE.0) THEN
              DO 10 I=1,2
                  IF(NBP(I,IX,IZ).NE.0) GO TO 10
                  IF(MBP0(I,IX,IZ).LE.0.1) GO TO 10
                  IF(MBP(I,IX,IZ).LT.0.0) GO TO 10
                  MBPD(I,IX,IZ)=(MBP(I,IX,IZ)-MBPT(I,IX,IZ))
     \                          /MBP0(I,IX,IZ)
C                  WRITE(6,1010) IX,IZ,I,MBPD(I,IX,IZ),
C     \                                  MBP(I,IX,IZ),MBP0(I,IX,IZ)
C 1010             FORMAT(1H ,3I5,3F10.1)
   10         CONTINUE
          ENDIF
   20 CONTINUE
C      BAIR=0.0
      DO 30 IX=1,NX
      DO 30 IZ=1,MZ
          IF(NBIJ(1,IX,IZ).EQ.0) GO TO 30
          DO 25 I=1,2
              IF(MBPD(I,IX,IZ).EQ.0.0) GO TO 25
              IF(NBP(I,IX,IZ).NE.0) GO TO 25
              IF(BAIR.EQ.0.0) THEN     
                  BAIR=MBPD(I,IX,IZ)
                  GO TO 25
              ENDIF
              IF(MBPD(I,IX,IZ).LE.BAIR) BAIR=MBPD(I,IX,IZ)
   25     CONTINUE
   30 CONTINUE
      RETURN
      END
      SUBROUTINE MBPTS2(MBP0,MBP,MX,NX,MZ,MBPD,NBP,NBIJ,BAIR,MBPT,ISTEP)
      IMPLICIT INTEGER(A-Z)
      REAL MBP0(2,NX,MZ),MBP(2,NX,MZ),MBPD(2,NX,MZ),MBPT(2,NX,MZ)
      REAL BAIR
      INTEGER NBP(2,NX,MZ),NBIJ(3,MX,MZ)
      DO 40 IX=1,NX
      DO 40 IZ=1,MZ
          IF(NBIJ(1,IX,IZ).EQ.0) GO TO 40
          DO 35 I=1,2
              IF(NBP(I,IX,IZ).EQ.0) THEN
                  IF(MBPD(I,IX,IZ).EQ.BAIR) THEN
                      NBP(I,IX,IZ)=ISTEP
                      MBPT(I,IX,IZ)=MBP(I,IX,IZ)
                      WRITE(6,*) '**KOUFUKU-B**',IX,IZ,I
C                      WRITE(9,*) '**KOUFUKU**',IX,IZ,I
                      GO TO 35
                  ENDIF
              ENDIF
              MBPT(I,IX,IZ)=MBPT(I,IX,IZ)+BAIR*MBP0(I,IX,IZ)
              IF(MBPT(I,IX,IZ).GT.MBP(I,IX,IZ)) THEN
C                  WRITE(6,*) IX,IZ,I,MBPT(I,IX,IZ),MBP(I,IX,IZ)
              ENDIF
   35     CONTINUE
   40 CONTINUE
      RETURN
      END
      SUBROUTINE STQTST(S,Q,ISTEP,BAIR,MZ,ST,QT)
      IMPLICIT INTEGER(A-Z)
      REAL S(MZ),Q(MZ),BAIR,ST(25000,MZ),QT(25000,MZ)
      DO 10 IZ=1,MZ
          IF(ISTEP.EQ.1) THEN
              ST(ISTEP,IZ)=S(IZ)*BAIR
              QT(ISTEP,IZ)=Q(IZ)*BAIR
          ELSE
              ST(ISTEP,IZ)=ST(ISTEP-1,IZ)+S(IZ)*BAIR
              QT(ISTEP,IZ)=QT(ISTEP-1,IZ)+Q(IZ)*BAIR
          ENDIF
   10 CONTINUE
C      DO 5 IZ=1,MZ
C          WRITE(9,*) S(IZ),Q(IZ),ST(1,IZ),QT(1,IZ)
C    5 CONTINUE
      RETURN
      END
      SUBROUTINE KBTSET(KB,KBP,NBP,NBIJ,MX,NX,MZ,KBT)
      IMPLICIT INTEGER(A-Z)
      REAL KB(4,NX,MZ),KBP(4,NX,MZ),KBT(4,NX,MZ)
      INTEGER NBP(2,NX,MZ),NBIJ(3,MX,MZ)
      DO 30 IX=1,NX
      DO 30 IZ=1,MZ
          IF(NBIJ(1,IX,IZ).EQ.0) GO TO 30
          IF(NBP(1,IX,IZ).EQ.0 .AND.NBP(2,IX,IZ).EQ.0) THEN
              DO 10 I=1,4
                  KBT(I,IX,IZ)=KB(I,IX,IZ)
   10         CONTINUE
          ELSEIF(NBP(1,IX,IZ).NE.0 .AND. NBP(2,IX,IZ).NE.0) THEN
              CALL CLEAR(KBT(1,IX,IZ),4,3)
          ELSE
              DO 20 I=1,4
                  KBT(I,IX,IZ)=KBP(I,IX,IZ)
   20         CONTINUE
          ENDIF
   30 CONTINUE
      RETURN
      END
      SUBROUTINE STQTOT(ST,QT,MZ,ISTEP)
      IMPLICIT INTEGER(A-Z)
      REAL ST(25000,MZ),QT(25000,MZ)
      DO 20 IZ=1,MZ
          WRITE(9,*) '**IZ=',IZ
          WRITE(9,*) '0,0.0,0.0,'
          DO 10 IS=1,ISTEP-1
              WRITE(9,1010) IS,-ST(IS,IZ),-QT(IS,IZ)
 1010         FORMAT(1H ,I8,',',F10.3,',',F10.1,',')
   10     CONTINUE
   20 CONTINUE
C      STOP      
      RETURN
      END
      SUBROUTINE SSET(U,MZ,S)
      REAL U(MZ),S(MZ)
      DO 10 IZ=1,MZ-1
          S(IZ)=U(IZ)-U(IZ+1)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE HOYUOT(ISTEP,ST,QT,MZ)
      IMPLICIT INTEGER(A-Z)
      REAL ST(25000,MZ),QT(25000,MZ)
      DO 10 IZ=MZ-1,1,-1
          WRITE(11,1010) IZ,ST(ISTEP-1,IZ),QT(ISTEP-1,IZ)
 1010     FORMAT(1H ,I8,',',F10.3,',',F10.1,',')
   10 CONTINUE
      RETURN
      END
      SUBROUTINE BFST(BF,NX)
      IMPLICIT INTEGER(A-Z)
      REAL BF(NX)
      DO 10 IX=1,NX
          BF(IX)=1.0
   10 CONTINUE
C      READ(12,1010) (BF(IX),IX=1,NX)
C 1010 FORMAT(10F8.0)
      RETURN
      END
      SUBROUTINE CPMATS(EC,IC,MC,X,Z,L0,MX,MZ,NCIJ,NZ,KCP,NF,AC)
      IMPLICIT INTEGER(A-Z)
      REAL EC(MC),IC(MC),X(MX),Z(MZ),L0,KCP(5,MX,NZ),LC,LC0,AC(MC),
     \     KC0,AC0,NF(MX)
      INTEGER NCIJ(3,MX,MZ)
      CALL CLEAR(KCP,5*MX*NZ,3)
      DO 10 IX=1,MX
      DO 10 IZ=1,NZ
          IF(NCIJ(1,IX,IZ).EQ.0) GO TO 10
          LC=Z(NCIJ(3,IX,IZ))-Z(IZ)
          LC0=LC/L0
          III=NCIJ(1,IX,IZ)
C          WRITE(6,*) LC,LC0,L0,EC(III),IC(III),AC(III)
          KC0=EC(NCIJ(1,IX,IZ))*IC(NCIJ(1,IX,IZ))/LC**3
          AC0=AC(NCIJ(1,IX,IZ))*LC**2/IC(NCIJ(1,IX,IZ))
          KCP(1,IX,IZ)=3*KC0*NF(IX)
          KCP(2,IX,IZ)=-3*KC0*LC0*NF(IX)
          KCP(3,IX,IZ)=KC0*AC0*NF(IX)
          KCP(4,IX,IZ)=3*KC0*LC0**2*NF(IX)
          KCP(5,IX,IZ)=3*KC0*LC0**2*NF(IX)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE MCPTS1(MCP0,MCP,MX,NZ,MZ,MCPD,NCP,NCIJ,BAIR,MCPT)
      IMPLICIT INTEGER(A-Z)
      REAL MCP0(2,MX,NZ),MCP(2,MX,NZ),MCPD(2,MX,NZ),MCPT(2,MX,NZ)
      REAL BAIR
      INTEGER NCP(2,MX,NZ),NCIJ(3,MX,MZ)
      CALL CLEAR(MCPD,2*MX*NZ,3)
      DO 20 IX=1,MX
      DO 20 IZ=1,NZ
          IF(NCIJ(1,IX,IZ).NE.0) THEN
              DO 10 I=1,2
C              WRITE(6,1010) IX,IZ,NCP(I,IX,IZ),
C     \           MCP0(I,IX,IZ),MCP(I,IX,IZ),MCPD(I,IX,IZ),MCPT(I,IX,IZ) 
 1010         FORMAT(1H ,3I5,4E15.7)
                  IF(NCP(I,IX,IZ).NE.0) GO TO 10
                  IF(MCP0(I,IX,IZ).LE.0.1) GO TO 10
                  IF(MCP(I,IX,IZ).LT.0.0) GO TO 10
                  MCPD(I,IX,IZ)=(MCP(I,IX,IZ)-MCPT(I,IX,IZ))
     \                          /MCP0(I,IX,IZ)
   10         CONTINUE
          ENDIF
   20 CONTINUE
C      BAIR=0.0
      DO 30 IX=1,MX
      DO 30 IZ=1,NZ
          IF(NCIJ(1,IX,IZ).EQ.0) GO TO 30
          DO 25 I=1,2 
              IF(MCPD(I,IX,IZ).EQ.0.0) GO TO 25
              IF(NCP(I,IX,IZ).NE.0) GO TO 25
              IF(BAIR.EQ.0.0) THEN     
                  BAIR=MCPD(I,IX,IZ)
                  GO TO 25
              ENDIF
              IF(MCPD(I,IX,IZ).LE.BAIR) BAIR=MCPD(I,IX,IZ)
   25     CONTINUE
   30 CONTINUE
      RETURN
      END
      SUBROUTINE MCPTS2(MCP0,MCP,MX,NZ,MZ,MCPD,NCP,NCIJ,BAIR,MCPT,ISTEP)
      IMPLICIT INTEGER(A-Z)
      REAL MCP0(2,MX,NZ),MCP(2,MX,NZ),MCPD(2,MX,NZ),MCPT(2,MX,NZ)
      REAL BAIR
      INTEGER NCP(2,MX,NZ),NCIJ(3,MX,MZ)
      DO 40 IX=1,MX
      DO 40 IZ=1,NZ
          IF(NCIJ(1,IX,IZ).EQ.0) GO TO 40
          DO 35 I=1,2
              IF(NCP(I,IX,IZ).EQ.0) THEN
                  IF(MCPD(I,IX,IZ).EQ.BAIR) THEN
                      NCP(I,IX,IZ)=ISTEP
                      MCPT(I,IX,IZ)=MCP(I,IX,IZ)
                      WRITE(6,*) '**KOUFUKU-C**',IX,IZ,I
C                      WRITE(9,*) '**KOUFUKU**',IX,IZ,I
                      GO TO 35
                  ENDIF
              ENDIF
              MCPT(I,IX,IZ)=MCPT(I,IX,IZ)+BAIR*MCP0(I,IX,IZ)
              IF(MCPT(I,IX,IZ).GT.MCP(I,IX,IZ)) THEN
C                  WRITE(6,*) IX,IZ,I,MCPT(I,IX,IZ),MCP(I,IX,IZ)
              ENDIF
   35     CONTINUE
   40 CONTINUE
      RETURN
      END
      SUBROUTINE MCPIN(MX,NZ,MCP)
      IMPLICIT INTEGER(A-Z)
      REAL MCP(2,MX,NZ),MCD,MCU
      CALL CLEAR(MCP,2*MX*NZ,3)
   10 READ(13,1010,END=20) IX,IZ1,IZ2,MCD,MCU
 1010 FORMAT(3I10,2F15.7)
      MCP(1,IX,IZ1)=MCD
      MCP(2,IX,IZ1)=MCU
C      WRITE(6,1020) IX,IZ1,MCP(1,IX,IZ1),MCP(2,IX,IZ1)
 1020 FORMAT(1H ,2I5,2F10.1)
      GO TO 10
   20 RETURN
      END
      SUBROUTINE KCTINI(KC,MX,NZ,KCT)
      IMPLICIT INTEGER(A-Z)
      REAL KC(5,MX,NZ),KCT(5,MX,NZ)
      DO 10 IT=1,5
      DO 10 IX=1,MX
      DO 10 IZ=1,NZ
          KCT(IT,IX,IZ)=KC(IT,IX,IZ)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE KCTSET(KC,KCP,NCP,NCIJ,MX,NZ,MZ,KCT)
      IMPLICIT INTEGER(A-Z)
      REAL KC(5,MX,NZ),KCP(5,MX,NZ),KCT(5,MX,NZ)
      INTEGER NCP(2,MX,NZ),NCIJ(3,MX,MZ)
      DO 30 IX=1,MX
      DO 30 IZ=1,NZ
          IF(NCIJ(1,IX,IZ).EQ.0) GO TO 30
          IF(NCP(1,IX,IZ).EQ.0 .AND.NCP(2,IX,IZ).EQ.0) THEN
              DO 10 I=1,5
                  KCT(I,IX,IZ)=KC(I,IX,IZ)
   10         CONTINUE
          ELSEIF(NCP(1,IX,IZ).NE.0 .AND. NCP(2,IX,IZ).NE.0) THEN
              CALL CLEAR(KCT(1,IX,IZ),5,3)
          ELSE
              DO 20 I=1,5
                  KCT(I,IX,IZ)=KCP(I,IX,IZ)
   20         CONTINUE
          ENDIF
   30 CONTINUE
      RETURN
      END
      SUBROUTINE BUBUNC(NCIJ,NCP,MX,NZ,MZ,IHC)
      INTEGER NCIJ(3,MX,MZ),NCP(2,MX,NZ),IHC
      DO 30 IZ=1,NZ
          IHC=1
          DO 20 IX=1,MX
              IF(NCIJ(1,IX,IZ).EQ.0) GO TO 20
              DO 10 IT=1,2
                  IF(NCP(IT,IX,IZ).EQ.0) THEN
                     IHC=0
                     GO TO 30
                  ENDIF
   10         CONTINUE
   20     CONTINUE
          IF(IHC.EQ.1) RETURN
   30 CONTINUE
      RETURN
      END
      SUBROUTINE HIPRIN(NBP,NCP,MX,MZ,NX,NZ)
      IMPLICIT INTEGER(A-Z)
      INTEGER NBP(2,NX,MZ),NCP(2,MX,NZ)
      INTEGER IBC(2,100)


C
C                                       **SAIJOUBU HARI UE**
C
      CALL CLEARI(IBC,200,2)
      DO 10 IX=1,NX
          IBC(2,IX)=NBP(2,IX,MZ)
   10 CONTINUE
      WRITE(20,1010) (IBC(2,IX),IX=1,NX)
 1010 FORMAT(',',100(',',',',I4,','))
C
      DO 50 IZ=MZ,2,-1
C
C                                       **HARI SHITA**
C
          CALL CLEARI(IBC,200,2)
          DO 20 IX=1,NX
              IBC(1,IX)=NCP(2,IX,IZ-1)
              IBC(2,IX)=NBP(1,IX,IZ)
   20     CONTINUE
          IBC(1,MX)=NCP(2,MX,IZ-1)
          WRITE(20,1020) ((IBC(IT,IX),IT=1,2),IX=1,NX),IBC(1,MX)
 1020     FORMAT(100(I4,',',I4,',',','))
C
C                                        **HARI UE**
C
          CALL CLEARI(IBC,200,2)
          DO 40 IX=1,NX
              IBC(1,IX)=NCP(1,IX,IZ-1)
              IBC(2,IX)=NBP(2,IX,IZ-1)
   40     CONTINUE
          IBC(1,MX)=NCP(1,MX,IZ-1)
          WRITE(20,1040) ((IBC(IT,IX),IT=1,2),IX=1,NX),IBC(1,MX)
 1040     FORMAT(',',100(I4,',',',',I4,','))
   50 CONTINUE
C
C                                       **SAIKAKAI HARI SHITA*
C
          CALL CLEARI(IBC,200,2)
          DO 60 IX=1,NX
              IBC(2,IX)=NBP(1,IX,IZ)
   60     CONTINUE
          WRITE(20,1050) (IBC(2,IX),IX=1,NX)
 1050     FORMAT(',',100(I4,',',',',',')) 
      RETURN
      END
      SUBROUTINE RDWRIT(NAME,AAA,NT,NX,NZ)
      CHARACTER*4 NAME
      REAL AAA(NT,NX,NZ)
      WRITE(8,*) NAME
      DO 10 IZ=1,NZ
      DO 10 IX=1,NX
          WRITE(8,1010) (AAA(IT,IX,IZ),IT=1,NT)
 1010     FORMAT(1H ,5E15.7)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE STOPCH(ISTEP,NSTEP,INO)
      IMPLICIT INTEGER(A-Z)
      IF(ISTEP.GE.NSTEP) THEN
          WRITE(6,*) '**STOPCH-',INO
      ENDIF
      RETURN
      END